(function () {
  
    var scopePointer;
    var id      	= 0;
    var season		= 0;
    var username	= '';
    var clubCache	= [];
    var playerCache	= [];
    var type		= 'accountProfile';
    var addedAlready    = {};
    var ajaxedForIt 	= 0;
    var selectedPlayer  = -1;
      
		
    angular.module('myApp.account', ['myApp.AJAX','myApp.me' ])
        .service('account', [ 'AJAX','me' ,
            function ( AJAX,me  ) { 
                return {
                	get: function( userId, setUsername, $scope  )
                	{  
                		id = 0;
                		ajaxedForIt	= 0;
                		
                		username	= '';
                		scopePointer = $scope;
                	 
                		if( typeof userId != 'undefined' )
                		{
                			id = userId;
                			field = 'id';	
                		}
                		
                		if( typeof setUsername != 'undefined' && setUsername != null )
                		{
                			username = setUsername;
                			field    = 'username';
                		}
                		 
                		var obj = this;
                		clubCache = {};
                		playerCche = {};
                		 
                		me.get('accounts', userId, field ).then(function( result ) { 
                				
                				 
                			if( typeof result[0] != 'undefined' )
                			{
                				
                				scopePointer.data = result[0];
                				if( typeof result[0].last_login != 'undefined' )
                					if( result[0].last_login != null )
                						scopePointer.data.when   = me.timeSince(me.getTimestamp(result[0].last_login.date));
                				id = result[0].fields.id;
                				var fields      = {};
                				fields.id	= id+'-99';
                					
                					 
                				if( typeof result[0].awardsCount != 'undefined' )
                					if( result[0].awardsCount != null )
                						scopePointer.count.awards = result[0].awardsCount.awards;
                				
                				scopePointer.wall.setType( 99 );
                				scopePointer.wall.setId( id );
                				
                				if( me.needsAjax( result[0] ) )
                					obj.ajaxForIt();
                				 
                				
                				me.get('wall', fields.id, fields ).then(function( result ) { 
                					 
							if( typeof result[0] != 'undefined' )
								scopePointer.data.posts = result[0].posts;
									
						});
						
						me.get('teamsByAcc', id ).then(function( result ) { 
								 
							scopePointer.data.clubs = [];
							if( typeof result != 'undefined' )
								for( var i in result )
								{
									scopePointer.data.clubs.push( result[i] );
									clubCache[result[i].fields.id] = result[i];	
								}
									
							scopePointer.count.clubs = scopePointer.data.clubs.length;
						});
                				
						}
							else
                						obj.ajaxForIt();
                					 
						 
						 
						me.get('playersByAcc', id ).then(function( result ) { 
					 
							if( typeof scopePointer.data.players == 'undefined' )
							{
								scopePointer.data.players = [];
								
							
								if( typeof result != 'undefined' )
									if( result != false )
										for( var i in result )
										{
											scopePointer.data.players.push( result[i] );
											playerCache[result[i].fields.id] = result[i];	
										}
								 
								obj.updatePlayingFor();
								scopePointer.count.players = scopePointer.data.players.length;
							}
						});
                				
                				obj.updateTitle();
                				if( obj.getType() == 'cyberpoints' || obj.getType() == 'cyberpointsSpend' )
                				{ 
							obj.updateSelectors(); 
						}
                				
                    	    	});
                    	    	 
                    	     
                		this.ajaxForIt();
                		 
                	},
                	
                	ajaxForIt: function()
                	{      
                		if( ajaxedForIt )
                			return 0;
                		 
                		ajaxedForIt = 1;
                		//performs ajax request for data 
                		
                		if( this.getType() == 'home' )
                			var getWhat = { 'get':'&get=fields,forum,players=fields-profile-career-club,clubs,'+(pushPossible()?'push,':'')+'posts=fields,user'};
                			else if( this.getType() == 'cyberpoints' )
                				var getWhat = { 'get':'&get=fields,players=fields-career-boosts,clubs,referrals,login_bonuses,cyberpoints=packages','platformType':getPlatform()}
                              			else if( this.getType() == 'cyberpointsGet' )
                              				var getWhat = { 'get':'&get=fields,events,activeReviews,facebook=invites,referrals,login_bonuses,cyberpoints=packages','platformType':getPlatform()}
                              				else if( this.getType() == 'cyberpointsSpend')
                              					var getWhat = { 'get':'&get=fields,players=fields-career-boosts,clubs','platformType':getPlatform()}                           			
									else
										var getWhat = { 'get':'&get=fields,last_login,forum,awardsCount,players=fields-profile-career,clubs,posts=fields,user'};
                		if( id != 0 )
                			getWhat.id_account = id;
                		else if( username != '' )
                			getWhat.username = username;
                		else;
                		 
				var promise = AJAX.get('ACCOUNTS', getWhat,1 ); 
				var myPos = 0;
				scopePointer.API.setResting(true);
				var obj = this;
				 
				promise.success(function(data, status, headers, config) {   
					obj.updateView( data ); 
				});
				
				if( promise.update )
					promise.update(function(data, status, headers, config) { 
						obj.updateView( data ); 
					});
				 
				 promise.error(function(data, status, headers, config) {
				 	scopePointer.API.setResting(false);
				 	scopePointer.API.setError( data.ret.message );
				 }); 
				 
				 
                	},
                	
                	updateView: function( data )
                	{
                		 
                		var cache;
                		var obj = this;
                		scopePointer.cachedCopy = data.cache;
				if( !data.cache ){
					 scopePointer.API.setResting(false);
					 scopePointer.API.checkNotifications( data, scopePointer);
				    } 
                	 
					if( data.status == 'SUCCESS' )
					{ 
						
						//scopePointer.API.checkNotifications( data, scopePointer);
						//aici o sa fie mai multe synch-uri
						me.synch( 'accounts',  data.ret, scopePointer.data, data.timestamp );
						 
						if( obj.getType() == 'cyberpoints'  )
							if( getPlatform() == 'ios' )
							{
								if( typeof scopePointer.data != 'undefined' )
									if( typeof scopePointer.data.cyberpoints != 'undefined' )
										if( typeof scopePointer.data.cyberpoints.packages != 'undefined' )
											if( typeof scopePointer.data.cyberpoints.packages.length >= 1 )
												delete data.ret.cyberpoints.packages;
										 	
							}
						 
						scopePointer.data 	 = data.ret;
						
						if( typeof scopePointer.wall != 'undefined' )
							if( scopePointer.wall.getType() == 99 )
							{ 
								scopePointer.wall.setId( data.ret.fields.id );
							}
						if( typeof data.ret.last_login != 'undefined' )
							scopePointer.data.when   = me.timeSince(me.getTimestamp(data.ret.last_login.date));
								else
									scopePointer.data.when = me.timeSince(me.getTimestamp(data.ret.fields.join_date));
						 
						var dt = new Date( data.ret.fields.join_date );
						var months = ['January','February','March','April','May','June','July','August','September','October','November','December'];
			
						scopePointer.data.joined 			= dt.getDate()+' '+tr(months[dt.getMonth()])+' \''+dt.getFullYear().toString().substr(2,2);
						 
						id = data.ret.fields.id;
						  
						//me.patch( ' UPDATE players set id_account = 0 WHERE id_account = "'+id+'" ' );
							 
					 
						if( data.ret.players )
							scopePointer.count.players = data.ret.players.length;
								else
									scopePointer.data.players = [];
						  
						if( data.ret.clubs )
							scopePointer.count.clubs = data.ret.clubs.length;
								else
									scopePointer.data.clubs = [];
					 
						if( typeof data.ret.awardsCount != 'undefined' )
							if( obj.getType() != 'home' )
								scopePointer.count.awards = data.ret.awardsCount.awards;
						 
						for( var i in data.ret.players )
							if( i <= 10 )
							{
								if( typeof playerCache[ data.ret.fields.id ] != 'undefined' ) 
									cache = playerCache[ data.ret.fields.id ];
										else
											cache = null;
								
								me.synch( 'player', data.ret.players[i], cache, data.timestamp );
							}
					
						me.patch( ' UPDATE teams set id_account = 0 WHERE id_account = "'+id+'" ' );
						
						for( var i in data.ret.clubs )
						{
							if( typeof clubCache[ data.ret.fields.id ] != 'undefined' ) 
									cache = clubCache[ data.ret.fields.id ];
										else
											cache = null;
										
							me.synch( 'teams', data.ret.clubs[i], cache, data.timestamp );
						}
					 
				 
						if( pushPossible() )
							if( typeof data.ret.push != 'undefined' )
							{
								 
								me.setOneSignalId( data.ret.push.oneSignalId );
								//saveLocalStorage( 'oneSignalId'      , data.ret.push.oneSignalId ); 
		     
								//IF USER IS NOT SUBSCRIBED TO PUSH NOTIFICATIONS IN OUR DATABASE
								//IF USER HAS NOT DISABLED THE PUSH SUBSCRIPTION FOR THIS DEVICE
								 
								if( data.ret.push.subscription != 'active' && data.ret.push.subscription != 'disabled' )
								{
									//IF LAST ACTIVATION REQUEST 14 DAYS AGO
									if( data.ret.push.last_activation_request >= 14 )
									{
										//REQUEST TO SUBSCRIBE
										window.plugins.OneSignal.registerForPushNotifications();  
										
										//SET PUSH SUBSCRIPTION "LAST_ACTIVIATION_REQUEST" TO "TODAY"
										//WITHOUT CALL TO OUR API ? SAU CALL <_<
									}
								}
							}
						 
						 
						if( typeof data.ret.events != 'undefined' )
							scopePointer.data.events = data.ret.events;
						  
						if( typeof data.ret.posts != 'undefined' )
							if( typeof data.ret.posts.error == 'undefined' )
							{
								var insertPosts 		= {fields:{}};
								insertPosts.posts 		= data.ret.posts;
								insertPosts.fields.id  		= data.ret.fields.id + "-99";
								insertPosts.fields.location  	= 99;
								me.synch( 'wall',  insertPosts, null, data.timestamp );
							} 
							
						 if( typeof data.ret.cyberpoints != 'undefined' )
						 	 if( typeof data.ret.cyberpoints.packages != 'undefined' )
								if( typeof scopePointer.data.cyberpoints != 'undefined' )
									if( typeof scopePointer.data.cyberpoints.packages != 'undefined' )
									{  
										for( var i in scopePointer.data.cyberpoints.packages )
										{
											 
											scopePointer.data.cyberpoints.packages[i].price 	= '$'+( me.format(scopePointer.data.cyberpoints.packages[i].cost,2 )  );  
											scopePointer.data.cyberpoints.packages[i].title 	= me.format(scopePointer.data.cyberpoints.packages[i].cyberpoints)+' '+tr('CyberPoints');
											 
											/*
											if( parseInt(scopePointer.data.cyberpoints.packages[i].discount) >= 1 )
											{
												scopePointer.data.cyberpoints.packages[i].description 	= scopePointer.data.cyberpoints.packages[i].discount + '% '+tr('discount');
													}
													else
														scopePointer.data.cyberpoints.packages[i].description 	= '';
														*/
										
										}
										
									}
						
						 if( typeof data.ret.activeReviews != 'undefined' )
						 	 scopePointer.data.cyberpoints.activeReviews = data.ret.activeReviews;
									
						obj.updateTitle();
						obj.updatePlayingFor();
						if( obj.getType() == 'cyberpoints' || obj.getType() == 'cyberpointsSpend'  )
							obj.updateSelectors();
						 
						 
					}
					else
						scopePointer.API.setError( data.ret.message, scopePointer );
					
					 
                		
                	},
                	
                	updateTitle: function()
                	{
                		if( typeof scopePointer.data != 'undefined' )
                			if( typeof scopePointer.data.fields != 'undefined' )
                				if( typeof scopePointer.data.fields.username != 'undefined' )
                					scopePointer.data.title = scopePointer.data.fields.username;	
                	},
                	
                	
                	updatePlayingFor: function()
                	{ 
                		var id_club = 0;
                		var player;
                		
                		addedAlready   = {};
                		scopePointer.data.playingFor = [];
                		if( this.getType() == 'home' )
                		{
                			scopePointer.data.playingFor = [];
                			if( typeof scopePointer.data.players != 'undefined' )
                				for( var i in scopePointer.data.players )
                				{
                					player  = scopePointer.data.players[i];
                					id_club = player.fields.id_club;
                					
                					this.addToPlayingFor( id_club, player.club,player.fields.id ); 
                					 
                				}
                		}
                		
                		if( typeof scopePointer.data.playingFor != 'undefined' )
					if( scopePointer.data.playingFor.length <= 1 )
						for( var clb in scopePointer.data.playingFor )
						{  
							scopePointer.API.setForm('player_'+scopePointer.data.playingFor[clb].id,1);
						}
				 
				//angular.element(document.getElementById("slider")).scope() = scopePointer;		
				//angular.element(document.getElementById("slider")).scope().$apply(); 
				 
                	},
                	
                	addToPlayingFor: function( id_club, club,pid )
                	{ 
                		if( typeof addedAlready[id_club] == 'undefined' ) 
                		{
                			if( id_club == 0 )
                			{
                				var undrafted = {};
                				undrafted.name = tr('UNDRAFTED players');
                				undrafted.id   = 0; 
                				scopePointer.data.playingFor.push( undrafted ); 
                			}
                			else
                			{
                				scopePointer.data.playingFor.push( club ); 
                			}
                		}
                		//console.log("PUSH>>>> UNDRAFTED"+JSON.stringify(scopePointer.data.playingFor));
                		addedAlready[id_club] = 1; 
                	},
                	
                	init: function( $scope )
                	{
                		scopePointer = $scope;	
                	},
                	
                	signup: function( credentials )
                	{
                		var getWhat = { 'return': 'login', 'username':credentials.username,'email': credentials.email, encryptedPassword: md5(sha1(sha1(md5( credentials.password )))) };
                		     
                		if( typeof credentials.referral != 'undefined' )
                			getWhat.referral = credentials.referral;
                		
                		var obj     = this;
        			var promise = AJAX.put('ACCOUNTS', getWhat ); 
        		 
        			scopePointer.API.setResting(true);
        			scopePointer.submission = 1;
        			promise.success(function(data, status, headers, config) {
        				scopePointer.API.setResting(false); 
        				 
        				if( data.status == 'SUCCESS' )
        				{
        					if( scopePointer.tutorial.getStepNum() == 0 )
        						scopePointer.tutorial.setStep( 1 );
        					data.ret = data.ret['return'];
        					scopePointer.API.setShowEntryTooltip( 1 );
        				 
        					scopePointer.API.login( data );  
        					scopePointer.go('/home/');
        				}
        				else
        					scopePointer.API.setError(  data.ret.message, scopePointer );
        					
        			});
        				
        			promise.error(function(data, status, headers, config) {
        				scopePointer.submission = 0;
        			  	scopePointer.API.setResting( false );
        			  	scopePointer.API.setError( 'REST', scopePointer );
        			});    
                	},
                	
                	forgotten: function( forgotten )
                	{
                		var obj     = this;
                		var getWhat = {'username':scopePointer.credentials.username };
        			var promise = AJAX.put('FORGOTTEN_PASSWORD', getWhat ); 
        		 
        			scopePointer.API.setResting(true);
        			scopePointer.submission = 1;
        			promise.success(function(data, status, headers, config) {
        				scopePointer.API.setResting(false); 
        				 
        				if( data.status == 'SUCCESS' )
        				{
        					scopePointer.API.setMessage(  data.ret.message, scopePointer );
        				}
        				else
        					scopePointer.API.setError(  data.ret.message, scopePointer );
        					
        			});
        				
        			promise.error(function(data, status, headers, config) { 
        			  	scopePointer.API.setResting( false );
        			  	scopePointer.API.setError( 'REST', scopePointer );
        			});    
                	},
   
                	setUsername: function( credentials )
                	{
                		var obj     = this;
                		var getWhat = {'username': credentials.username, id: me.get('id_account') };
        			if( typeof credentials.password != 'undefined' )
        				getWhat.encryptedPass = md5(sha1(sha1(md5(credentials.password))));
        			if( typeof credentials.referral != 'undefined' )
        				getWhat.referral = credentials.referral;
        			
                		var promise = AJAX.patch('SET_USERNAME', getWhat ); 
                		 
                		
        			scopePointer.API.setResting(true);
        			scopePointer.submission = 1;
        			promise.success(function(data, status, headers, config) {
        				scopePointer.API.setResting(false); 
        				 
        				if( data.status == 'SUCCESS' )
        				{ 
        					scopePointer.API.setMessage(  data.ret.message, scopePointer );
        					 
        					scopePointer.go('/home/');
        				}
        				else
        					scopePointer.API.setError(  data.ret.message, scopePointer );
        					
        			});
        				
        			promise.error(function(data, status, headers, config) { 
        			  	scopePointer.API.setResting( false );
        			  	scopePointer.API.setError( 'REST', scopePointer );
        			});    
                	},
                	
                	setScope: function( $scope )
                	{
                		scopePointer = $scope;	
                	},
                	
                	
                	updateSelectors: function()
                	{
                		var options = {};
                		var player  = {};
                		var options2 = {};
                		options2.label = tr("Equip on player..");
                		options2.value = 0;
                		options.label = tr('Choose a player first');
                		options.value = 0; 
                		scopePointer.form.options.customEquipmentPlayers = [];
                		scopePointer.form.options.customEquipmentPlayers.push( options2 );
                		scopePointer.form.equipmentPlayer = scopePointer.form.options.customEquipmentPlayers[0];
                		scopePointer.form.options.players = [];
                		scopePointer.form.options.players.push( options );
                		scopePointer.form.players = scopePointer.form.options.players[0];
                		scopePointer.form.customEquipmentPlayers = scopePointer.form.options.customEquipmentPlayers[0];
                 
                		if( typeof scopePointer.data.players != 'undefined' )
                			for( var pid in scopePointer.data.players )
                			{
                				options = {};
                				player = scopePointer.data.players[pid];
                				 
                				options.value = player.fields.id;
                				options.careerId = player.career.id_career;
                				options.label = player.fields.first_name+' '+player.fields.last_name;
                				
                				options2 = {};
                				player = scopePointer.data.players[pid];
                				 
                				options2.value = player.fields.id; 
                				options2.label = player.fields.first_name+' '+player.fields.last_name;
                				if( typeof this.getSelectedPlayer() != 'undefined' )
                					if( this.getSelectedPlayer() == player.fields.id )
                						var selectedPlayerIndex = scopePointer.form.options.customEquipmentPlayers.length;
                				//console.log(">>>"+(this.getSelectedPlayer())+" == "+(player.fields.id)+ "<<< >>"+selectedPlayerIndex+" ");
                				
                				scopePointer.form.options.customEquipmentPlayers.push( options2 );
                				if( typeof player.boosts != 'undefined' )
                					options.label += ' '+player.boosts.bought+' / '+player.boosts.buyable; 
                				scopePointer.form.options.players.push( options );
                			} 
                			
                		if( typeof selectedPlayerIndex != 'undefined' )
                		{ 
                			scopePointer.form.players 		 = scopePointer.form.options.players[ selectedPlayerIndex ];
                			scopePointer.form.equipmentPlayer        = scopePointer.form.options.customEquipmentPlayers[ selectedPlayerIndex ];	
                		}
                	},
                	
                	openChat: function( data ){
                		if( data.fields.id <= me.get('id_account') ){
                			var first  = data.fields.id;
                			var second =  me.get('id_account');
                		}else{
                			var first  =  me.get('id_account'); 
                			var second =  data.fields.id; 
                		}
                		
                		var id_chat = 'u-'+first+'-'+second;
                	
                		var icon = me.userAvatar(data.forum.picture, data.fields.id);
                		 
                		scopePointer.chat.openChat( {'id':id_chat ,'text': data.fields.username, 'icon': icon.replace('http://cyberdunk2.com','').replace('pics/avatars/','images/fb/')   } );
                	},
                	
                	getSelectedPlayer: function()
                	{
                		return selectedPlayer;
                	},
                	
                	setSelectedPlayer: function( to )
                	{
                		selectedPlayer = to;	
                	},
                	
                	getCustomsCost: function( ){
                
                		
                	},
                	
                	setType: function( to )
                	{
                		type = to;
                	},
                	
                	getType: function()
                	{
                		return type;	
                	},
                	
                	getHelp: function( page, item )
                	{
                		var help = { items:{} };
                		switch( page )
                		{
                			case "home":
                				
                				 
                				help.title 			= tr('This your homepage. An overview of all the players you have created, clubs you manage, your personal wall and the cyberpoints (ingame currency) you have available.');
                				help.items.a1_create 		= {'text' 	:tr("Tap the button to create more players. There's a limit of players you can own, but using CyberPoints, you can amend it."), 'title':tr('Creating a player')};
                				help.items.a2_cyberpoints 	= {'text' 	:tr("Cyberpoints are the way we keep things running, make money, reward loyal users and how we reward you for spreading the word about this game."), 'title':tr('CyberPoints ( ingame currency )')};
                				help.items.players 		= {'text' 	:tr('Players you create will appear here listed under the team they play for.')};
                				
                				help.items.a5_clubs 		= {'text' 	:tr('Clubs that you manage.')+' '+tr('Clubs can be bought with cyberpoints.')+' '+tr('Once you own a club you can sign players from other users, set team tactics etc'), 'title':tr('Clubs')};
                				help.items.a3_players	 	= {'text'	:tr('Players you own that play on this particular team'), 'title':tr("Club name") };
                				help.items.a4_undrafted 	= {'text' 	:tr('Players that you own that currently do not play for any team.')+' '+tr('Tap on their names, then in their "crib" page tap on "draft" in order to choose a league and a team to draft in.'), 'title':tr('Undrafted players')};	
                				help.items.wall 		= {'text'	:tr("Your public wall, a facebook-style wall where other users will leave you public messages or where you'll address the world."), 'title':tr("Wall")};
                			break; 
                			
                			case "profile":
                				help.title 			= tr("User profile page");
                				help.items.a1_players		= {'text' 	:tr("Players created by this user or transfered to his account."), 'title':tr('Players')};
                				help.items.a2_clubs 		= {'text' 	:tr("Clubs owned by this user.")+" "+tr('Clubs can be bought with cyberpoints.')+" "+tr('Drop a line on his wall if you are interested in joining one of his clubs.'), 'title':tr('Clubs') };
                				help.items.a3_awards 		= {'text' 	:tr('Awards earned by this member.')+' '+tr("Awards are given at the end of every season for winning or making the podium ( medals ) in official championships, for recording most stats and for winning the MVP award")+" "+tr('Awards can be earned as a manager or as a player'), 'title': tr('Awards')};
                				
                				
                			
                			break;
                		}
                		
                		 
                		if( typeof item != 'undefined' )
                			return help.items[item].text;
                		
                		return help;
                	}
                	
                	
                	
                	
                	
                }

            }]);
}());
