(function () {
  
    var scopePointer; 
    var id; 
    var anchorScroll;
    var perLoad = 10;
    var loadable;
    var lastLoadFrom;
    var users = [];
   
      
		
    angular.module('myApp.conversations', ['myApp.AJAX','myApp.me' ])
        .service('conversations', [ 'AJAX','me' ,
            function (  AJAX,me  ) { 
                return {
                	
                	setConversationId: function( to )
                	{
                		id = to;	
                	},
                	
                	getConversation: function( convoId, $scope  )
                	{ 
                		id = convoId;
                		loadable = 1;
                		scopePointer = $scope;
                		this.ajaxForIt( 0, perLoad );  
                	},
                	
                	canLoadMore: function()
                	{
                		return loadable;
                	},
                	
                	ajaxForIt: function( from, limit )
                	{
                		var getWhat  = {get: 'messages,users=fields-forum', id_conversation: id, from: from, limit: limit }; 
                		var promise  = AJAX.get('CONVERSATIONS', getWhat );
                		lastLoadFrom = from;
                		
                		scopePointer.API.setResting(true);
                		var obj     = this;
                		promise.success(function(data, status, headers, config) {
					
                			scopePointer.API.setResting(false);
                			scopePointer.API.checkNotifications( data, scopePointer );
					if( data.status == 'SUCCESS' )
					{
						for( var i in data.ret.messages )
						{
							
							scopePointer.data.messages.push( data.ret.messages[i] );	
						}
						
						scopePointer.data.users	   = data.ret.users;
						
						if( typeof data.ret.messages != null )
							if( data.ret.messages.length != perLoad )
								loadable = 0;
									else
										loadable = 1;
						 
					}
					else
						scopePointer.API.setError( data.ret.message, scopePointer );
				});
				
				promise.error(function(data, status, headers, config) {
					$scope.API.setResting(false);
				}); 
                	},
                	getUserPicture: function( id_account )
                	{
                		console.log( scopePointer.data.users[id_account]+"<<<<<<<<<<<<<<"  );
                		if( typeof  scopePointer.data.users[id_account] != 'undefined' )
                			if( typeof scopePointer.data.users[id_account].forum != 'undefined' )
                				return scopePointer.data.users[id_account].forum.picture;
                	},
                	
                	setScope: function( $scope )
                	{
                		scopePointer = $scope;	
                	},
                	 
                	
                	addMessage: function()
                	{
                		if( this.getConversationId() == 'new' )
                			this.createNewConversation();
                		else
                			this.submitNewMessageInExistingConversation();
                	},
                	
                	getUsers: function()
                	{
                		return users;
                	},
                	
                	clearUsers: function()
                	{
                		users = [];	
                	},
                	
                	getConversationId: function()
                	{
                		return id;
                	},
                	
                	addUser: function( username )
                	{
                		users.push(username);	
                	},
                	
                	createNewConversation: function()
                	{
                		lastLoadFrom = 0;
                		var getWhat  	 = {'message': encodeURIComponent(scopePointer.postMessage), return: 'messages,conversationId,users=fields-forum', id_conversation: 'new',users: this.getUsers(), from: 0, limit: perLoad }; 
                		var promise  	 = AJAX.put('MESSAGES', getWhat );
                	 
                		
                		scopePointer.API.setResting(true);
                		var obj     = this;
                		promise.success(function(data, status, headers, config) {
					
                			scopePointer.API.setResting(false);
                			scopePointer.API.checkNotifications( data, scopePointer );
					if( data.status == 'SUCCESS' )
					{  
						scopePointer.data.messages 	= data.ret['return'].messages;	 
						scopePointer.data.users	   	= data.ret['return'].users;
						scopePointer.postMessage	= '';
						if( typeof data.ret['return'].conversationId != 'undefined' ) 
							obj.setConversationId( data.ret['return'].conversationId );
						
						if( typeof data.ret['return'].messages != null )
							if( data.ret['return'].messages.length != perLoad )
								loadable = 0;
									else
										loadable = 1; 
					}
					else
						scopePointer.API.setError( data.ret.message, scopePointer );
				});
				
				promise.error(function(data, status, headers, config) {
					$scope.API.setResting(false);
				});
                		
                	},
                	
                	submitNewMessageInExistingConversation: function()
                	{
                		lastLoadFrom = 0;
                		var getWhat  	 = {'message': encodeURIComponent(scopePointer.postMessage), return: 'messages,users=fields-forum', id_conversation: id, from: 0, limit: perLoad }; 
                		var promise  	 = AJAX.put('MESSAGES', getWhat );
                	 
                		
                		scopePointer.API.setResting(true);
                		var obj     = this;
                		promise.success(function(data, status, headers, config) {
					
                			scopePointer.API.setResting(false);
                			scopePointer.API.checkNotifications( data, scopePointer );
					if( data.status == 'SUCCESS' )
					{  
						scopePointer.data.messages 	= data.ret['return'].messages;	 
						scopePointer.data.users	   	= data.ret['return'].users;
						scopePointer.postMessage	= '';
						
						if( typeof data.ret['return'].messages != null )
							if( data.ret['return'].messages.length != perLoad )
								loadable = 0;
									else
										loadable = 1; 
					}
					else
						scopePointer.API.setError( data.ret.message, scopePointer );
				});
				
				promise.error(function(data, status, headers, config) {
					$scope.API.setResting(false);
				}); 
                		
                	},
                	
                	loadMore: function()
                	{
                		this.ajaxForIt( parseInt(lastLoadFrom)+perLoad, perLoad );
                	}
                }

            }]);
}());
