(function() {

    var scopePointer;
    var obj;
    var liveGamesNow = 0;
    var liveGamesArray = {};


    angular.module('myApp.live', ['myApp.AJAX', 'myApp.me'])
        .service('live', ['AJAX', 'me',
            function(AJAX, me) {
                return {

                    connect: function() {
                        obj = this;
                        var sockjs_url = 'https://cyberdunk2.com:11799';

                        var sockjs = new SockJS(sockjs_url);

                        var data = {
                            type: 'auth',
                            id_account: me.get('id_account'),
                            username: me.get('username') + ' (APP)',
                            token: me.get('token'),
                            view: {
                                'mygames': 1
                            }
                        };

                        //auth.login
                        sockjs.onopen = function() {
                            sockjs.send(JSON.stringify(data));
                             
                                setInterval(function() {
                                    sockjs.send(JSON.stringify({
                                        type: 'heartbeat'
                                    }));
                                }, 10000);
                          
                        };
                        sockjs.onclose = function() {};
                        sockjs.onmessage = function(e) {

                            if (typeof e.data != 'undefined') {
                                var o = tryParseJSON(e.data);

                                if (o !== false)
                                    if (typeof o.type != 'undefined')
                                        switch (o.type) {
                                            case "score":
                                                obj.updateLiveGames(o.result);
                                                break;
                                        }
                            }
                        }
                    },

                    updateLiveGames: function(result) {

                        liveGamesArray[result.id_game] = result;


                        var liveGameCount = 0;
                        for (var i in liveGamesArray) {
                            var game = liveGamesArray[i];
                            if (game.quarter <= 3 || (game.quarter == 4 && game.time >= 10))
                                liveGameCount++;

                        }

                        liveGamesNow = liveGameCount;
                        scopePointer.liveGames = 'da';
                        //if( typeof scopePointer != 'undefined' ) 
                        //	for( var i in liveGamesArray )
                        //		scopePointer.gameList.live.push( liveGamesArray[i] );

                        //console.log( JSON.stringify(scopePointer.liveGames)+"???????????");

                    },

                    getLiveGamesCount: function() {
                        return liveGamesNow;
                    },

                    getLiveGames: function() {
                        //console.log( JSON.stringify(scopePointer.liveGamesArray)+"???????????");
                        return liveGamesArray;
                    },

                    setScopePointer: function($scope) {
                        scopePointer = $scope;
                        //console.log( JSON.stringify(scopePointer.liveGames)+"???????????");
                    }


                }

            }
        ]);
}());