(function () {
  
    var scopePointer;
    var fields	= { myPlayer: 'fields,skills,fixtures=2,results=3,salary,expiration,training,equipment,careerInfo,club' };
    var id      = 0;
    var cache;
    var skills	= {};
    var boosted = {};
    var cost;
    var balance = 0;
    var formType = 'skillpoints';
    var scopeRouter = { 'restLoading' : false };
    var location;
    
    
 
		
    angular.module('myApp.skillpoints', ['myApp.AJAX','myApp.me'  ])
        .service('skillpoints', [ 'AJAX','me' ,
        function ( AJAX,me ) { 
                return { 
                	
                    add			: function( skill, vl ){
                    		
                    	    	var cost  = this.getCost( skill , this.getSkill( skill ) + 1 );
                    	     
				if( cost <= this.getBalance() )
				{
					var newValue = this.getSkill( skill ) + 1;
					this.setBoosted( skill, this.getBoosted( skill ) + 1 );
					this.setSkill( skill, newValue ); 
					this.setBalance( this.getBalance() - cost ); 
					 
					return 1;
				}
				else
					return 0;	    
                    },
                    
                    rem			: function( skill, vl ){
                    	    	
                    	    	if( this.getBoosted( skill ) > 0 )
				{
					var cost  	= this.getCost( skill , this.getSkill( skill ) );
					var newValue 	= this.getSkill( skill ) - 1;
					this.setBalance( this.getBalance() + cost );
					this.setBoosted( skill, this.getBoosted( skill ) - 1 );
					this.setSkill( skill, newValue ); 
					   
					return 1;
				}
				else
					return 0;
                    },
                    
                    disabledBtn		: function( skill, how )
                    { 
                    	    if( how == '-' )
                    	    	    if( this.getSkill(skill) <= 5 || this.getBoosted(skill)==0 )
                    	    	    	return true;
                    	    			else 
                    	    				return false;
                    	    	else
                    	    		if( this.getCost( skill, this.getSkill(skill)+1 ) > this.getBalance() )
                    	    			return true;
                    	    				else
                    	    					return false;
                    	    			
                    	    
                    },
                    
                    save		: function( $scope, FORM )
                    {
                    	  
                    	 if( typeof $scope != 'undefined' )
                    	 	 if( $scope != null )
                    	 	 	scopePointer = $scope;
                    	 
                  
                    	if( formType == 'skillpoints' )
                    	{
                    		var FORM = {};
                    		for( var k in boosted )
                    			if( boosted[k] > 0 )
                    				FORM[k] = boosted[k];
                    			
                    		FORM.id_player = scopePointer.data.fields.id;
                    		FORM.return = 'fields,careerInfo';
                    		
                    		var promise = AJAX.put('BOOST', FORM  );
                    	}
                    	else
                    	{
                    	 
                    		if( typeof FORM == 'undefined' )
                    		{ 
                    			var FORM = {}; 
								FORM.first_name   = scopePointer.form.player.first_name;
								FORM.last_name    = scopePointer.form.player.last_name;
								FORM.id_country   = scopePointer.form.player.id_country;
								FORM.pos	  = scopePointer.form.player.pos;
								FORM.height	  = scopePointer.form.player.height;
								FORM.weight	  = scopePointer.form.player.weight;
								FORM.superstar	  = scopePointer.form.superstar;
					
				} 
                    		 
                    		for( var sk in skills )
                    			FORM[sk] = skills[sk]; 
                    	 
                    		FORM.return = 'fields,skills,careerInfo';
                    		 
			
				var promise = AJAX.put('PLAYER', FORM  );
			}
                    	
			
                    	scopePointer.API.setResting(true);
                    	scopePointer.API.clearErrors();
                    		 
                    		
                    	promise.success(function(data, status, headers, config) {
                    		  
                    		scopePointer.form.submitted = 1;
                    		scopePointer.API.setResting(false); 
                    		scopePointer.API.checkNotifications( data, scopePointer);
                    		if( data.status == 'SUCCESS' )
                    		{
                    			me.synch( 'player', data.ret, cache, data.timestamp );  
                    			 
                    			if( formType == 'skillpoints' )
                    			{
                    				scopePointer.API.setMessage( data.ret.message );
                    				scopePointer.data.fields = data.ret.fields;
                    				scopePointer.data.skills = data.ret.skills;
                    				
                    				if( scopePointer.tutorial ) 
                    					scopePointer.tutorial.doneStep('spendSkillpoints');
                    				}
                    				else{
                    					if( scopePointer.tutorial ) 
                    						scopePointer.tutorial.doneStep('createPlayer');
                    					
                    					location.url('myPlayer/'+data.ret.fields.id);
                    				}
                    		}
                    		else
                    			scopePointer.API.setError( data.ret.message, scopePointer );		
					
                	});
				
			 	promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting( false ); 
					scopePointer.API.setError( 'REST', scopePointer );
			}); 
			 
                    },
                    
                    setPlayerType	: function( to ){  					
			     
                    	    var pTypes 		= {"Jump Shooter":{"shooting_fg":50,"shooting_inside":5,"shooting_3pt":5,"dribbling":30,"passing":25,"stealing":5,"rebounding":5,"blocking":5,"strength":5,"speed":30,"jumping":30,"confidence":10,"stamina":16},"Sharpshooter":{"shooting_fg":5,"shooting_inside":5,"shooting_3pt":50,"dribbling":30,"passing":25,"stealing":5,"rebounding":5,"blocking":5,"strength":5,"speed":30,"jumping":30,"confidence":10,"stamina":16},"Inside Force":{"shooting_fg":5,"shooting_inside":50,"shooting_3pt":5,"dribbling":30,"passing":25,"stealing":5,"rebounding":5,"blocking":5,"strength":30,"speed":5,"jumping":30,"confidence":10,"stamina":16},"Slasher":{"shooting_fg":5,"shooting_inside":50,"shooting_3pt":5,"dribbling":40,"passing":30,"stealing":5,"rebounding":5,"blocking":5,"strength":5,"speed":40,"jumping":5,"confidence":10,"stamina":16},"Power Blocker":{"shooting_fg":5,"shooting_inside":5,"shooting_3pt":5,"dribbling":20,"passing":15,"stealing":5,"rebounding":5,"blocking":50,"strength":40,"speed":5,"jumping":40,"confidence":10,"stamina":16},"Hustle Blocker":{"shooting_fg":5,"shooting_inside":5,"shooting_3pt":5,"dribbling":20,"passing":15,"stealing":5,"rebounding":5,"blocking":50,"strength":5,"speed":40,"jumping":40,"confidence":10,"stamina":16},"Stealer":{"shooting_fg":5,"shooting_inside":5,"shooting_3pt":5,"dribbling":40,"passing":40,"stealing":50,"rebounding":5,"blocking":5,"strength":5,"speed":30,"jumping":5,"confidence":10,"stamina":16},"Power Rebounder":{"shooting_fg":5,"shooting_inside":5,"shooting_3pt":5,"dribbling":15,"passing":20,"stealing":5,"rebounding":50,"blocking":5,"strength":40,"speed":5,"jumping":40,"confidence":10,"stamina":16},"Hustle Rebounder":{"shooting_fg":5,"shooting_inside":5,"shooting_3pt":5,"dribbling":15,"passing":20,"stealing":5,"rebounding":50,"blocking":5,"strength":5,"speed":40,"jumping":40,"confidence":10,"stamina":16},"Playmaker":{"shooting_fg":5,"shooting_inside":30,"shooting_3pt":5,"dribbling":50,"passing":50,"stealing":5,"rebounding":5,"blocking":5,"strength":5,"speed":30,"jumping":5,"confidence":10,"stamina":16}}
			    var saveSkills 	= pTypes[ to ];
			    this.setBalance(  me.getSkillpoints( scopePointer.API.getDay(), scopePointer.form.superstar )  );
			   
			    for( var sk in saveSkills )  
			    {
			    	    this.setBoosted( sk, saveSkills[sk]  ); 
			    	     console.log("current balance"+this.getBalance()+"<< SKILL "+sk+" = "+saveSkills[sk]+" previously = "+this.getSkill(sk)+" COST "+this.getTotalCost( sk )+" << ");
			    	    this.setBalance( this.getBalance() - this.getTotalCost( sk ) );
			    	     console.log("after balance"+this.getBalance()+"<< ");
			    	   
			    } 
			    this.setSkills( saveSkills ); 
                    },
                    getBoosted		: function( skill  )		{ if( typeof boosted[skill] == 'undefined' ) return 0; else return parseInt( boosted[ skill ] );        },
                    setBoosted		: function( skill, value )	{ boosted[ skill ] = value;			},
                    setCost		: function( toCost   )		{ cost = toCost;				},
                    getCost		: function( skill, curValue )	{ 
                    	    			if( typeof curValue != 'undefined' )
                    	    				return curValue*2;
                    	    			return skills[skill] * 2; 
                    },
                    boostSkill		: function(skill  )	{
                    	     	 
                    	    	var value = document.getElementById("sv_"+skill).value ;
                    	    	 
                    	    	var val = this.getSkill( skill )-this.getBoosted(skill);
				var v   = [];
			 
				v['val']= val;
				
				if( val > value )
				{
					//this.API = new API( 'sp:boost' );
					//this.API.message.error(tr('Can not set value below {val}',v));
					
				}
				var boosted = this.getBoosted( skill );
				//$("body").append( boosted + " <> " + val + " = " + value + " <BR> ");
				
				if( boosted + val >= value )
				{
					for( var i = boosted+val; i> value; i-- )
						this.rem( skill,1 );
				}
				else
				{
					for( var i = boosted+val; i<value; i++ )
						this.add( skill,1 );
				}
				document.getElementById("sv_"+skill).value = this.getSkill(skill);
                    	    
                    },
                    
                    getHelp: function( page )
                    {
                    	    	var v				= {'num':30,a:'','/a':'','intl_link':'','career_link':'','oop_link':''};
                				
                    	        var help = { items:{} };
                    	        help.items.shooting_3pt 	= {'text' 	:tr("Ability to shoot from beyond the arc. It is harder to make than a normal shot and it is rewarded with 3 points."), 'title':tr('3PT Shooting')};
                		help.items.shooting_inside 	= {'text' 	:tr('AKA "In The Paint Shooting" is the ability to penetrate into the paint for small players and the ability to hustle inside the paint for big players.'), 'title':tr('Inside Shooting')};
                		help.items.strength 		= {'text' 	:tr('Strength, Speed, Jumping, all of them will increase your performance on the court depending on your chosen shot type or defensive methods prefered. Strength is usually associated with bigger players & rebounding.'),title: tr('Strength')};
                				
                		help.items.speed 		= {'text' 	:tr('Strength, Speed, Jumping, all of them will increase your performance on the court depending on your chosen shot type or defensive methods prefered. Speed is usually more associated with stealing and small players.'),title: tr('Speed')};
                		help.items.stealing 		= {'text' 	:tr('The main defensive skill for the back court. Every steal will lower an offensive chance to the enemy by 1 and increase an offensive chance to the team by 1 so it`s a +2 for every steal.'),title: tr('Stealing')};
                		help.items.stamina 		= {'text' 	:tr('Vital skill for the main scorer of the team as shooting consumes a lot of energy especially 3 pointers. Starters should have more because you stay on the court for a long time but subs should start training this after you train enough of your main skills because subs will be starters in the future. High stamina also guarantee you have stable performance for the whole match instead of a bad 4th quarter due to tiredness.'),title: tr('Stamina')};
                		help.items.confidence 		= {'text' 	:tr('Affects your overall gameplay, especially free throws.'),title: tr('Confidence')};
                		help.items.dribbling 		= {'text' 	:tr('Useful skill for small players that move around the court.'),title: tr('Dribbling')};
                		help.items.shooting_fg 		= {'text' 	:tr('AKA "Semi Distance Shooting". Its usually a jump shot from inside the arc and outside the paint.'),title: tr('Mid Range Shooting')};
                		help.items.jumping 		= {'text' 	:tr('Strength, Speed, Jumping, all of them will increase your performance on the court depending on your chosen shot type or defensive methods prefered. Jumping is a must for every position, helps gaining elevation when shooting or blocking.'),title: tr('Jumping')};
                		help.items.blocking 		= {'text' 	:tr('The king of kings attribute for now, it determines how well you can block.'),title: tr('Blocking')};
                		help.items.passing 		= {'text' 	:tr('A low passing will mean more turnovers. A high passing will mean assists and open looks for the scorers.'),title: tr('Passing')};
                		help.items.rebounding 		= {'text' 	:tr('A good blocking monster + a good rebounding monster = Ownage. Why? Blocking make the player miss the shoot and rebound give the team a offensive chance. Rebounding is important as it give you 2nd chance when in offense and make sure your enemy don\'t have 2nd chance when in defense.'),title: tr('Rebounding')};
                				
                		switch( page )
                		{
                			case "skillpoints":
                				
                				help.title 			= tr("Improve your skills using skillpoints you've earned throughout the season");
                				help.items.a_skillpoints 	= {'text' 	: tr('Are used to improve your skills.')+' '+tr('Skillpoints are recieved:')+'<ul><li>'+tr('After each league game')+'</li><li>'+tr('After each game in the first round of the playoffs')+'</li><li>'+tr('After each {intl_link}international game{/a} played during the pool stage (first round)',v)+'</li><li>'+tr('BUT only {num} games are redeemable per {career_link}career stage{/a} (1 season)',v)+'</li><li>'+tr('By reaching certain stats milestones')+'</li><li>'+tr('And a small amount can be purchased each career period (rookie, sophomore etc)')+'</li></ul>',title: tr('Skillpoints')};
                				
                				//help.items.blocking 		= {'text' 	:tr(''),title: tr('')};
                 			break; 
                			case "player_create": 
                				help.items.a_height		= {'text' 	:tr("Height & weight have minimal effect on your game play"), 'title':tr('Height & Weight')};
                				help.items.a_position 		= {'text' 	:tr("Preferred position on the court. Your manager is allowed to play you anywhere he sees fit but some {oop_link}positional changes{/a} are subjet to a performance penalty. Building a player is different according to your position. For example an inside shooting center will make use of his strength to score while an inside shooting guard will use his speed. Choose carefully.",v), 'title':tr('Position') };
                				help.items.a_cntry 		= {'text' 	:tr('You will only be allowed to play for the national team representing this country (not all countries have a team in our world championships though)'), 'title': tr('Country')};
                		
                				help.items.b_player_type 	= {'text' 	:tr('This will set your default skillset for the skill asignment step'), 'title': tr('Player Type')};
                			
                			break;
                			
                		}
                		
                		 
                		if( typeof item != 'undefined' )
                			if( typeof help.items[item] != 'undefined' )
                				return help.items[item].text;
                		
                		return help;
                    	    
                    },
                    
                    
                    getTotalCost	: function( skill  )		{ 						
                    	    var cost = 0;
                    	    for( var i=boosted[ skill ]; i>5; i-- )
                    	    {
                    	    	    //console.log(" i ="+i+" cost = "+cost+" < <BR>");
                    	    	    cost += i*2;
                    	    }
                    	    return cost;
                    },
                    setScope		: function( $scope )		{ scopePointer = $scope;  				},
                    setIdPlayer		: function( to	   ) 		{ id 	   = to;					},
                    setLocation		: function( setLoc )		{ location = setLoc;					},
                    getRestLoading	: function(    )		{ return scopeRouter.restLoading;			},
                    getFormType		: function(    )		{ return formType;					},
                    setFormType		: function( to )		{ formType = to;					},
                    setBalance 		: function( val    )		{ balance = val; 				},
                    getBalance		: function(	   )            { return parseInt( balance );			},
                    setSkills		: function( setTo )		{ skills = setTo; 				},
                    setSkill 		: function( skill, value )	{ skills[skill] = value;			},
                    getSkill 		: function( skill  )          	{ return parseInt( skills[skill] );		}
                    
                }        
        }]);
}());
