(function () {
  
    var scopePointer;
    var id      	= 0;
    var season		= 0;
      
		
    angular.module('myApp.team', ['myApp.AJAX','myApp.me' ])
        .service('team', [ 'AJAX','me' ,
            function ( AJAX,me  ) { 
                return {
                	
                	get: function( teamId, $scope, setSeason  )
                	{
                		season	     = 0;
                		scopePointer = $scope;
                		id	     = teamId;
                		 
                		var fields   = {};
                		if( typeof setSeason != 'undefined' && setSeason != me.get('season') )
                		{
                			table  = 'teamHistory';
                			season = setSeason;
                			fields.season = season;
                			getId  = teamId+"-"+setSeason;
                		}
                		else
                		{
                			getId = teamId;
                			table = 'teams';
                		}
                		
                		//sql for team data
                		var obj = this;
                		me.get( table , getId, fields ).then(function( result ) {
                    	    				 
                    	    		if( typeof result[0] != 'undefined' )
                    	    		{  
                    	    			scopePointer.data = result[0];
                    	    			scopePointer.loaded	= true;
                    	    	 
                    	    			obj.getPositionText( scopePointer.data.standings, scopePointer.data.fields.id );
                    	    			if( obj.needsAjax( result[0] ) )
                    	    				obj.ajaxForIt();
                    	    			
                    	    			obj.createHistoryDropdown( result[0] );
                    	    			obj.updateTitle();
                    	    		}
                    	    		else
                    	    		{
                    	    			obj.ajaxForIt();	
                    	    		}
                    	    	});
                    	    	
                    	    	 
                    	    	if( typeof setSeason == 'undefined' || setSeason == me.get('season') )
                    	    	{
                    	    		
                    	    		//CURRENT SEASON ONLY
					me.get('players', teamId, 'id_club' ).then(function( result ) {
						if( typeof result != 'undefined' )
						{  
							scopePointer.data.players = [];
							 
							for( var i in result ) 
							{ 
								scopePointer.data.players.push(result[i]);
							}
						}
					});
				}
			
				var getId = teamId+'-25';
				 
                    	    	me.get('wall', getId  ).then(function( result ) { 
                    	    			 
                    	    		if( typeof result[0] != 'undefined' )
                    	    			scopePointer.data.posts = result[0].posts;
                    	    				
                    	    	});
                    	    	
                    	    	this.ajaxForIt();
                	},
                	
                	ajaxForIt: function()
                	{   
                		//performs ajax request for data 	
                		 
                		var getWhat = { 'get':'fields,fixtures=2,results=3,standings,awards,stats,manager,players=fields-stats-profile,league,story,history,posts','id':id };
                		if( season != 0 )
                			getWhat.season = season;
                		
				var promise = AJAX.get('TEAM', getWhat,1 ); 
				var myPos = 0;
				scopePointer.API.setResting(true);
				var obj = this;
				promise.success(function(data, status, headers, config) {						   
					obj.updateView( data ); 
				});
				
				if( promise.update )
					promise.update(function(data, status, headers, config) { 
						obj.updateView( data ); 
					});
					/*
				    //succesful get event. 
				    me.synch( 'player', data.ret, cache, data.timestamp );
						scopePointer.data = data.ret; 
						obj.setEquipmentFromJSON( data.ret.equipment, 'id_inventory' );
					
				    });*/
				
				promise.error(function(data, status, headers, config) {
						$scope.API.setResting(false);
				}); 
                		
                	},
                	
                	updateView: function( data )
                	{
                		var obj = this;
                		 
				scopePointer.cachedCopy = data.cache;
                		if( !data.cache ){
                			scopePointer.API.setResting(false);
                		 	scopePointer.API.checkNotifications( data, scopePointer);
				}
                		 //aici o sa fie mai multe synch-uri
				 
				scopePointer.data 	 = data.ret;
				scopePointer.form.help   = obj.getHelp('profile');
					
				scopePointer.data.awardsCount = 0;
				if( typeof data.ret.awards != 'undefined' )
					for( var i in data.ret.awards ) 
						scopePointer.data.awardsCount++; 
					  
				if( !season || season == me.get('season') )
				{
					if( !isNaN( id ) )
						me.patch( ' UPDATE players set id_club = 0 WHERE id_club = "'+id+'" ' );
						
					for( var i in data.ret.players )
						me.synch( 'player', data.ret.players[i], null, data.timestamp );
							
						 
					me.synch( 'teams',  data.ret, null, data.timestamp );
				}
				else
				{
					data.ret.id 	= id+"-"+season;
					data.ret.season = season;
					me.synch( 'teamHistory',  data.ret, null, data.timestamp );
				}
					
				if( typeof data.ret.posts != 'undefined' )
					if( typeof data.ret.posts.error == 'undefined' )
					{
						var insertPosts 		= {fields:{}};
						insertPosts.posts 		= data.ret.posts;
						insertPosts.fields.id  		= data.ret.fields.id + "-25";
						insertPosts.fields.location  	= 25;
						me.synch( 'wall',  insertPosts, null, data.timestamp );
					}
					 	
				obj.createHistoryDropdown( data.ret );
				//text plural issues 
				obj.getPositionText( data.ret.standings, data.ret.fields.id );
					
				obj.updateTitle();
                	},
                	
                	updateTitle: function()
                	{
                			if( !this.getSeason() || this.getSeason() == me.get('season') )
						scopePointer.data.title	 = scopePointer.data.fields.name;
							else
							{
								var v = {};
								v['name']   = scopePointer.data.fields.name;
								v['season'] = this.getSeason();
								scopePointer.data.title = tr('{name} during S{season}',v);
							}	
                	},
                	
                	createHistoryDropdown: function( data )
                	{
                		var arrayIndex    = 0;
                		scopePointer.form.modelHistory;
                		scopePointer.form.optionsHistory = [];
                		
                		for( var i in data.history )
                		{
                			var option  	= {};
                			option.value 	= data.history[i];
                			
                			if( option.value == me.get('season') )
                			{
                				option.name 	= tr('Current season {value}', option);  
                					}
                					else
                					{
                						option.season  = option.value;
                						if( option.value == season )
									option.name = tr('Browsing Season {season}', option);
										else
											option.name = tr('Browse season {value}', option);
                					}
                			
                			scopePointer.form.optionsHistory.push( option );
                			 
                			if( !season ) 
                			{
                				
                				if( option.value == me.get('season') )
                					scopePointer.form.modelHistory = scopePointer.form.optionsHistory[arrayIndex];
                			}
                			else
                				if( option.value == season )
                					scopePointer.form.modelHistory = scopePointer.form.optionsHistory[arrayIndex];
                				
                			arrayIndex++;
                		} 
                		
                	},
                	
                	getLineupName: function( obj )
                	{
                		return ( !this.getSeason()? ( obj.first_name+' '+obj.last_name ) : obj.name );	
                	},
                	
                	privateFroumAccess: function()
                	{
                		
                		if( typeof scopePointer.data.fields != 'undefined' )
                		{
                		
					if( scopePointer.data.fields.id_account == me.get('id_account') )
						return 1;
					
					for( var item in scopePointer.data.players )
						if( scopePointer.data.players[item].fields.id_account == me.get('id_account') )
							return 1;
				}
                			
                		return 0;
                	},
                	
                	getPlaceIcon: function( story )
                	{
                		return story.place <=3 ? '<span class="top2 medal'+story.place+'" >&nbsp;</span>' : tr('LAST {place}',story);	
                		
                	},
                	
                	getPositionText: function( andVar,teamId )
                	{ 
                			var v = {}; 
                			var myPos = 0;
					for( var pos in andVar )
						if( typeof andVar[pos].team != 'undefined' )
							if( andVar[pos].team.fields.id == teamId )
								myPos = andVar[pos].place;
					v['pos'] = myPos;
					
					if( scopePointer.data.fields.club_type == 5 )
					{
						if( myPos == 1 )
							scopePointer.data.positionText = tr('1st in their pool');
						else if( myPos == 2 )
							scopePointer.data.positionText = tr('2nd in their pool');
						else if( myPos == 3 )
							scopePointer.data.positionText = tr('3rd in their pool');
						else if( myPos > 3 )
							scopePointer.data.positionText = tr('{pos}th in their pool',v);
						else
							scopePointer.data.positionText = tr('Standing in their pool');
						
					}
					else
					{
					
						if( myPos == 1 )
							scopePointer.data.positionText = tr('1st in their league');
						else if( myPos == 2 )
							scopePointer.data.positionText = tr('2nd in their league');
						else if( myPos == 3 )
							scopePointer.data.positionText = tr('3rd in their league');
						else if( myPos > 3 )
							scopePointer.data.positionText = tr('{pos}th in their league',v);
						else
							scopePointer.data.positionText = tr('Standing in their league');
						
					}
                	}, 
                	
                	
                	getSeason: function()
                	{
                		return season;	
                	},
                	 
                	
                	pg: function( which )
                	{
                		var divideBy = 1;
                		if( scopePointer.form.howStats != 'per_game' )
                			divideBy = 1;
                				else
                					divideBy = scopePointer.data.stats.games;
                		if( divideBy == 0 )
                			return 0;
                		return parseFloat(which/divideBy).toFixed(1);	
                	},
                	
                	getStat: function( stats, which )
                	{
                		var total = 0;
                		if( which == 'rebounds' )
                			total = stats.offensive_rebounds+stats.defensive_rebounds;
                				else
                					total = stats[which];
                				 
                		if( stats.games == 0 )
                			if( which != 'minutes' )
                				return 0;
                					else
                						return '00:00';
                		
                		if( which != 'minutes'  )
                			return parseFloat(total/stats.games).toFixed(1);	
                				else
                					return me.parseTime( parseInt(total/stats.games) );
                	},
                	
                	needsAjax: function( result )
                	{	
                		//checks whether the data has been updated today
                		//or if a game was scheduled to play today and it is likely to have simmed
                		//in which case its time to update
                		return 1;
                	}
                	,
                            
                          getHelp: function( page, item )
                          {
                		var help = { items:{} };
                		var v	 = { 'from_tns': 4, 'to_tns': 7,'games_per_career':30, 'season_days':61,'teams_per_league':16,'regular':30,'playoff':'3/3/3','playoff_teams':8,'playoff_start':53,'length': 12, '/a':'', pos:tr('C/PF/SF/SG/PG'),'cyberpoints_link':'','career_link':'', 'goals':3,'per_game':1, 'games':10,'sp_rewardable':30 };
                		 
                		v.season = season;
                		switch( page )
                		{
                			case "profile": 
                				if( season == me.get('season') )
                					help.items.a1_manager	= {'text' 	:tr('The manager of this team. It can either be another user, yourself or the computer.',v) + ' ' + tr('Teams can be bought using {cyberpoints_link}cyberpoints{/a} (ingame currency)',v), 'title':tr('Manager')};
                						else
                							help.items.a1_manager	= {'text' 	:tr('The manager of this team during season {season}.',v) + ' ' + tr('Teams can be bought using {cyberpoints_link}cyberpoints{/a} (ingame currency)',v), 'title':tr('Manager')};
                					
                				
                				help.items.a2_league	= {'text'	:tr('Each league has {teams_per_league} teams.',v)+' '+tr('In each season (~{season_days} days) they play {regular} regular season games, after which a {playoff} playoff system to decide the winner.',v)+' '+tr('Different leagues may exist.'), 'title':tr('League')};
                				//previous
                				if( season != me.get('season') )
                					help.items.a3_results	= {'text' 	:tr("Results obtained in this season in the competitions for which the team qualified."), 'title':tr('Results')};
                				if( typeof scopePointer.data.league != 'undefined' )
                					help.items.a4_standings	= {'text' 	:tr("Top {playoff_teams} teams qualify for the playoffs, scheduled to start on day {playoff_start}.",scopePointer.data.league.fields), 'title':tr('Standings')};
                						else
                							help.items.a4_standings	= {'text' 	:tr("During the regular season (~{regular} games) each win & loss among teams playing in this competition is recorded. Teams are then ranked by wins (+ point differential in case of ties) and a {playoff_teams} team {playoff} playoff system begins (around day {playoff_start}).",v), 'title':tr('Standings')};
                				help.items.a5_upcoming	= {'text' 	:tr("Games that will sim LIVE in x hours and games that have already simmed. Tap on each for a detailed breakdown."), 'title':tr('Recent & Upcoming Games')};
                				if( season == me.get('season') )
                					help.items.a6_lineup	= {'text' 	:tr("Current players signed to this team."), 'title':tr('Lineup')};
                						else
                							help.items.a6_lineup	= {'text' 	:tr("Players signed to this team during season {season}.",v), 'title':tr('Lineup')};
                						
                				
                				help.items.a7_playertats= {'text' 	:tr("PTS")+': '+tr('Points scored')+' '+tr("AST")+": "+tr('Assists')+' '+tr("BLK")+": "+tr('Blocks')+' '+tr("STL")+": "+tr('Steals')+' '+tr("REB")+": "+tr('Rebounds')+' '+tr("FLS")+": "+tr('Fouls')+' '+tr("MIN")+": "+tr('Minutes'), 'title':tr('Player Stats')};  
                				help.items.a8_teamStats = {'text' 	:tr("Cummulative stats accross multiple type of games & competitions"), 'title':tr('')};
                				help.items.a9_awards 	= {'text' 	:tr("Team awards are received after top 3 finishes.")+' '+tr("During each season depending on the manager's and player's ability each team will play in between {from_tns} to {to_tns} tournaments (including league play).",v)+' '+tr('The records here indicate the competition, the manager of the club when the award was earned, the season and the type of competition in which the trophy was won.')+' '+tr('Tapping on the award will redirect you to the competition during that season.'), 'title':tr('Awards')};
                				help.items.b1_current	= {'text'	:tr("This drop down allows you to browse our records for previous season in which this team was active."), title: tr('"Current Season / Previous Season" ?')};
                				help.items.b2_cash	= {'text'	:tr("Get cash from tickets and selling players.")+' '+tr('Spend cash on players and improving your arena.'), title: tr('"Team cash')};
                				help.items.b3_career	= {'text'	:tr("Team can only sign players that are currently in this career stage.")+tr('Next season this team will promote to the next career stage, unless otherwise instructed by the manager in the "manage team" sections.')+' '+tr('Once a player plays {games_per_career} games at a particular level and receives the skillpoints for those games he is ready to promote to the next career stage at the end of the season.',v)+' '+tr('Leagues are restricted by this "career stage" in order to enforce fairness & competition.')+' '+tr('Players usually spend 1 season for each career stage'), title: tr('Career Stage')};
                				help.items.b4_owned	= {'text'	:tr("Date upon which the manager of this team will no longer own it and any other user will be able to buy it with CyberPoints (ingame currency)."), title: tr('Owned Until')};
                			
                				
                			break;  
                			
                			case "manageTeam":
                				help.items.a1_name	= {'text'	:tr('Teams can be renamed by their owners, just tap the pen on the right.'), title:tr('Name')};
                				help.items.a2_owned	= {'text'	:tr("Date upon which the manager of this team will no longer own it and any other user will be able to buy it with CyberPoints (ingame currency)."), title: tr('Owned Until')};
                				help.items.a3_career	= {'text'	:tr("Team can only sign players that are currently in this career stage.")+tr('Next season this team will promote to the next career stage, unless otherwise instructed by the manager in the "manage team" sections.')+' '+tr('Once a player plays {games_per_career} games at a particular level and receives the skillpoints for those games he is ready to promote to the next career stage at the end of the season.',v)+' '+tr('Leagues are restricted by this "career stage" in order to enforce fairness & competition.')+' '+tr('Players usually spend 1 season for each career stage'), title: tr('Career Stage')};
                				help.items.a4_career	= {'text'	:tr("Specify in which career stage you wish to play next season.")+' '+tr('Since most players promote after 1 season, the default setting is "promotion".')+' '+tr('Next season you will not be able to sign players outside of that career stage so carefuly evaluate where your players will play before deciding.')          , title: tr('Next season career stage')};
                				
                				help.items.a5_fixtures  = {'text'	:tr('Upcoming games. On the left the list includes: your opponent, time left, local timestamp and on the right: game day, game type.'), 	title:tr('Fixtures')};
                				help.items.a6_results   = {'text'	:tr('Recent games played by this team.')+' '+tr('Score, opponent and result on the left.')+' '+tr('Game type and game day on the right.')+' '+tr("Tap to view the play by play, attendance, revenue, players and stats."), 	title:tr('Results')};
                				help.items.a7_standings = {'text'	:tr('League standings'),  'title':tr('Standings')};
                				if( typeof scopePointer != 'undefined' )
                					if( typeof scopePointer.data != 'undefined' )
                						if( typeof scopePointer.data.league != 'undefined' )
                							help.items.a7_standings	= {'text' 	:tr("Top {playoff_teams} teams qualify for the playoffs, scheduled to start on day {playoff_start}.",scopePointer.data.league.fields), 'title':tr('Standings')};
                				
                				help.items.a8_lineup	= {'text' 	:tr("Current players signed to this team.")+' '+tr('If you wish to sign a new player, go to their profiles, scroll down and click "SIGN PLAYER".')+' '+tr('Alternatively, you could browse players signed to a computer manager in "player search".'), 'title':tr('Lineup')};
                				help.items.a9_contracts	= {'text' 	:tr("Contracts and obligations this team has.")+tr('Tap for options: like releasing players, renewing contracts or offering cash bonuses.')+' '+tr('Once a contractual offer is made the player has to accept it'), 'title':tr('Lineup')};
                				
                				help.items.info		= {'text'	:tr('Edit name, future career stage, ownership period etc.')};
                			break; 
                			
                			case "tactics":
                				help.items.a1_qtacti    = {'text'	:tr('Set substition order and substition rule for this quarter.')+' '+tr('A player will be subbed once the sub-rule is met: too many fouls or stamina too low.')+' '+tr('If set substition choice is already on the court the next available substitution will enter the game.'), 'title': tr('Quarter tactics')};
                				help.items.a2_restri    = {'text'	:tr('Restrict certain players from making certain shots (3 pointers, mid range or inside shots).'), 'title': tr('Restrictions')};
                				help.items.a3_tshring   = {'text'	:tr('The current saved individual tactics of your players.')+' '+tr('Certain players may opt out from sharing this information with their manager or teammates.'), 'title': tr('Tactic sharing')};
                				help.items.a4_skilli    = {'text'	:tr("Player skills.")+' '+tr('Certain players may opt out from sharing this information with their manager or teammates.'), 'title': tr('Building sharing')};
                				help.items.a5_saving    = {'text'	:tr('All changes need to be saved.')+' '+tr('So make sure you click "Save Tactics", so everything can be synched with the game server.'), 'title': tr('Saving Tactics')};
                				help.items.a6_clear     = {'text'	:tr('This will basically delete everything in terms of tactics, restrictions, etc.')+' '+tr('Should be used once a team is bought or in case something is not working as expected.'), 'title': tr('Clearing Tactics')};
                			break;
                			
                			case "playerSearch":
                				help.items.a1_player_list = {'text'	:tr('The players listed here are currently signed to a non-human owner and thus can be signed easily.')+' '+tr('They also play in the same career stage as your team.'), 'title':tr('Player directory')};
                				help.items.ab_signing_one = {'text'	:tr('In order to sign one of those players go to their profile, scroll down and click "SIGN PLAYER".'), 'title':tr('Signing players')};
                			break;
                			
                			
                		}
                		
                		 
                		if( typeof item != 'undefined' )
                			if( typeof help.items[item] != 'undefined' )
                				return help.items[item].text;
                					 
                		
                		return help; 
                    	},
                    	
                    	setScope: function( $scope )
                    	{
                    		scopePointer = $scope;	
                    	}
                	
                	
                	
                	
                }

            }]);
}());
