'use strict';


(function () {
 
    
    var APILINK    =  'http://cyberdunk2.com/API/'; 
    var error	   =  {};
    var notificationCount = 0;
    var id_account =  -1;
    var username   = ' ?? ';
    var token	   =  "-1";	
    var email	   = ' ?? ';
    var myPlayers  = {};
    var myPlayersStringified = '';
    var myTeams	   = {};
    var questionMarks = 1;
    var dbNotCreated  = 0;
    var language   = "UNKNOWN";
    var resting    =  false;
    var lastSearch = '';
    var showEntryTooltip;
    var footerPosition = 800;
    var oneSignalId = '';
    var vars	    = {};
    var settings   =  {'season':8, 'day':31, 'days': 61, 'games_per_tier': 30, 'id_account':1};
    //var db 	   =  window.openDatabase("site", "1.0", "SITE DATABASE", 50000); 
    // var db 	   =  window.sqlitePlugin.openDatabase({name:"site.db"});
    var platform	= getPlatform();
    
    var offlineBrowsing =  0;
    var db	   	=  html5PhoneyDatabase();
    var data	   = {};
    var equipments = [ 'shoes', 'accessory', 'under clothing' ];
    var majorStats = [ 'points','assists','steals','blocks','rebounds' ];
  //,'standings','next_round','last_round','playoffs','previous_winners','points','assists','steals','blocks','rebounds','mvp_race','schedule'
    var JSONS	=  { 
    	    		'player': ['fields','club','skills','fixtures','results','goals','training','equipment','contract','profile','stats','awards','statsHistory','history','ratings','career'], 
    	    		'playerTactics': ['fields','tactics'],
    	    		'accounts': ['fields','forum','last_login','awardsCount'],
    	    		'lastRest': ['timestamp'],
    	    		'teams': ['fields','stats','fixtures','results','awards','standings','league','history'],
    	    		'teamHistory': ['fields','stats','players','awards','standings','league','history','story'],
    	    		'competitions': ['fields','standings','next_round','last_round','playoffs','previous_winners','stats','mvp_race','schedule'],
    	    		'competitionList': ['leagues','tournaments'],
    	    		'wall': ['posts'],
    	    		'gameList': ['games'],
    	    		'notifications': ['alerts'],
    	    		'games':['fields','stats','play_by_play','home_team','away_team','attendance','starters','sim','competition','quarterScores','players']
    };
    var form	=  {};
    var skills	=  ['shooting_inside', 'shooting_3pt', 'shooting_fg', 'dribbling', 'passing', 'blocking', 'rebounding', 'stealing', 'jumping', 'stamina', 'strength', 'confidence', 'speed'];
    
    var INDEXfields = {
    			'last_login': ['id_account','token','username','email' ],
    			'lastRest': ['field'], 
    			'teams': ['id_account'],
    			'teamHistory': ['season'],
    			'competitions': ['type','career'], 
    			'player': ['id_account','id_club'],
    			'playerTactics': ['id_account','id_club'],
    			'accounts': ['username'],
    			'gameList': ['id_account']
    };

    angular.module('myApp.me', ['myApp.AJAX' ])
        .service('me', [ '$q','AJAX',
            function ( $q, AJAX ) { 
            	return {
                    login: function ( returnData ) {
                    	    
                    	this.clearLocalStorage();
                   
                    	var info      = returnData.ret;   
                    	id_account    = info.fields.id;
             
                    	username      = info.fields.username;
                    	token         = info.token; 
                    	//language      = info.fields.language; 
                    	this.setLanguage(language);
                    	questionMarks = info.fields.tooltips;
                    	 
                    	settings.season = returnData.timestamp.season;
                    	settings.day 	= returnData.timestamp.day;
                    	AJAX.setToken( token );
                    	 
                    	this.saveLocalStorage( returnData );
                    	var login = { fields: { 'token': info.token, 'id': info.fields.id, 'username': info.fields.username, 'email': info.fields.email } };                      
                        this.synch( 'last_login', login, null, returnData.timestamp );
                    	
                    	for( var i in info.players )
                    	{ 
                    		if( typeof info.players[i] != 'undefined' ) 
                    			this.synch( 'player', info.players[i], null, returnData.timestamp ); 
                        }
                        
                   
                        delete info.players;
                       // console.log( JSON.stringify( info ) );
                        this.synch( 'account', info, null, returnData.timestamp );
                       
 
                    	//data = info; 
                    },
                    
                    getMaxCareers: function(){
                    	return 10;    
                    },
                    
                    checkLanguage: function()
                    { 
                    	if( language == 'UNKNOWN' || language == '' || language == 'undefined' )
                    	{
                    		this.determineLanguage();	
                    	}
                    },
                    
                    determineLanguage: function()
                    {
                    	var lang = '';
                        if( typeof getLocalStorage( 'language' ) == 'string' )
                    	{
                    		lang = getLocalStorage( 'language' ); 
                    	}
                    	else
                    	{ 
                    		var obs = this;
				//console.log(">>>>"+( localStorage.getItem( 'language' ) )+" ==> "+lang+"<<<<");
				//window.navigator.userLanguage is IE only and it's the language set in Windows Control Panel - Regional Options and NOT browser languag
				
				if( typeof navigator != 'undefined' )
				{ 
					if( typeof navigator.globalization != 'undefined' )
					{
						navigator.globalization.getLocaleName(
						  function (locale) { 
						  	 
						  	  if( typeof locale.value == 'string' )
						  	  	  lang = (locale.value).replace('-','_');
						  
						  
						  if( lang != '' )
							obs.setLanguage( lang );
								else
									obs.setLanguage( 'en_US' );
						  },
						  function () {obs.setLanguage( 'en_US' ); }
						);
					} 
				}
			}
			if( lang != '' )
				this.setLanguage( lang );
					else
						this.setLanguage( 'en_US' );
			
			
                    },
                    
                    setLanguage: function( iso, callback )
                    {
                    	console.log("current language = "+language+" << <BR>");
                    	if( !this.languageExists( iso ) )
                    		iso = 'en_US'; 
                    	console.log("language = "+language+" != iso= "+iso);
                    	//require that language :)
                    	if( language != iso   )
                    	{  
                    		console.log("language = "+language+" != iso= "+iso);
                    		if( language == 'UNKNOWN' && iso == 'en_US' )
                    		{ 
                    			//already loaded	
                    		}
                    		else
                    		{ 	 
                    			if( getPlatform() == 'windowsphone' )
                    			{
                    				loadjscssfile("locales/"+iso+".js", "js");
                    				if( typeof callback != 'undefined' )
                    					callback();
                    						else
                    							window.SC.go('new-language-set');
                    			}
                    			else
                    			{ 
						if( typeof callback == 'undefined' )
							yepnope.injectJs('locales/'+iso+'.js', function () {  angular.element(document.getElementById('body')).scope().go( 'new-language-set' );    }, { charset: "utf-8"}, 5000);
								else 
									yepnope.injectJs('locales/'+iso+'.js', callback, { charset: "utf-8"}, 5000);
					}
                    		}			 
                    	} 
                    	else if( iso == language )
                    	{ 
                    		if( typeof callback != 'undefined' )
                    		{
                    			callback();
                    		} 
                    		else console.log('no callback');
                    	}
                    	else;
                    	
                    	 		
                    	console.log("language is now "+iso+" < ");
                    	language = iso;   
                    	AJAX.setIso( language );
                    	saveLocalStorage( 'language'      , iso );
                    	  
                    },
                    
                    getIso: function( )
                    {
                    	return language;	    
                    },
                    
                    getLanguage: function()
                    { 
                    	if( typeof LANGUAGES[ this.getIso() ] != 'undefined' )
                    		return LANGUAGES[ this.getIso() ];  
                    	else
                    		return {"sv_SE":{"name":"Swedish","native":"svenska","countryId":"191"},"fr_FR":{"name":"French","native":"fran\u00e7ais, langue fran\u00e7aise","countryId":"73"},"pt_BR":{"name":"Portuguese","native":"Portugu\u00eas","countryId":"156"},"pt_PT":{"name":"Portuguese","native":"Portugu\u00eas","countryId":"29"},"tr_TR":{"name":"Turkish","native":"T\u00fcrk\u00e7e","countryId":"204"},"lv_LV":{"name":"Latvian","native":"latvie\u0161u valoda","countryId":"120"},"hz_HZ":{"name":"Hindi","native":"\u0939\u093f\u0928\u094d\u0926\u0940, \u0939\u093f\u0902\u0926\u0940","countryId":"100"},"hr_HR":{"name":"Croatian","native":"hrvatski","countryId":"52"},"hu_HU":{"name":"Hungarian","native":"Magyar","countryId":"98"},"es_ES":{"name":"Spanish","native":"espa\u00f1ol, castellano","countryId":"184"},"es_AR":{"name":"Spanish","native":"espa\u00f1ol, castellano","countryId":"9"},"zh_CN":{"name":"Chinese ( Simplified )","native":"\u4e2d\u6587 (Zh\u014dngw\u00e9n), \u6c49\u8bed, \u6f22\u8a9e","countryId":"44"},"zh_HANS":{"name":"Chinese ( Simplified )","native":"\u4e2d\u6587 (Zh\u014dngw\u00e9n), \u6c49\u8bed, \u6f22\u8a9e","countryId":"44"},"lt_LT":{"name":"Lithuanian","native":"lietuvi\u0173 kalba","countryId":"126"},"id_ID":{"name":"Indonesian","native":"Bahasa Indonesia","countryId":"101"},"fil_PH":{"name":"Filipino","native":"","countryId":"153"},"ro_RO":{"name":"Romanian","native":"rom\u00e2n\u0103","countryId":"160"},"pl_PL":{"name":"Polish","native":"polski","countryId":"155"},"sr_SR":{"name":"Serbian","native":"\u0441\u0440\u043f\u0441\u043a\u0438 \u0458\u0435\u0437\u0438\u043a","countryId":"173"},"ru_RU":{"name":"Russian","native":"\u0440\u0443\u0441\u0441\u043a\u0438\u0439 \u044f\u0437\u044b\u043a","countryId":"161"},"it_IT":{"name":"Italian","native":"Italiano","countryId":"107"},"nl_NL":{"name":"Dutch","native":"Nederlands, Vlaams","countryId":"132"},"de_DE":{"name":"German","native":"Deutsch","countryId":"80"},"et_ET":{"name":"Estonian","native":"eesti, eesti keel","countryId":"67"},"zh_TW":{"name":"Chinese ( Traditional )","native":"","countryId":"194"},"si_SI":{"name":"Sinhala","native":"\u0dc3\u0dd2\u0d82\u0dc4\u0dbd","countryId":"186"},"vi_VI":{"name":"Vietnamese","native":"Ti\u1ebfng Vi\u1ec7t","countryId":"217"},"ig_IG":{"name":"Igbo","native":"As\u1ee5s\u1ee5 Igbo","countryId":""},"en_US":{"name":"English","native":"English","countryId":"212"}};  

                    },
                    
                    getLanguages: function()
                    {
                    	var languageArray = [];
                    	var item 	  = {};
                    	for( var id in LANGUAGES )
                    	{
                    		item = LANGUAGES[id];
                    		item.iso = id; 	
                    		languageArray.push( item );
                    	}
                    	return languageArray;    
                    },
                    
                    languageExists: function( which )
                    { 
                    	    console.log("language exists ?"+which+" ???");
                    	    console.log( LANGUAGES );
                    	    if( typeof LANGUAGES != 'undefined' )
				if( typeof LANGUAGES[ which ] != 'undefined' ){
					console.log("yes");	
					return 1;
				}
                    	return 0;
                    },
                    
                    getPlatform: function()
                    {
                    	return getPlatform();    
                    },
                    
                    getVersion: function()
                    {
                    	    if( typeof window.cordova != 'undefined' )
                    	    	     if( typeof window.cordova.device != 'undefined' )
                    	    	     	return parseInt(window.cordova.device.version);    
                    	    
                    },
                    
                    canSvg: function()
                    {	 
                    	    if( this.getPlatform() == 'windowsphone' )
                    	    	    return 1; 
                    	    
                    	    if( this.getPlatform() == 'ios' )
                    	    	    return 1;    
                    	    
                    	    if( this.getPlatform() == 'android' )
                    	    {	
                    	    	    if( typeof getAndroidVersion() != 'undefined' )
					if( parseInt( getAndroidVersion(), 10 ) >= 3 )
						return 1;  
							else 
								return 0;
				
					return 0;
                    	    }
                    	     
                    	    return 1; 
                    },
                    
                    getSpinner: function()
                    {
                    	    if( this.canSvg() )
                    	    	    return 'pics/largeSpinner.svg';
                    	    		else
                    	    			return 'pics/largeSpinner.gif';
                    },
                     
                    imgExtension: function()
                    {
                    	 if( this.canSvg() )
                    	 	 return 'svg';
                    	 		else
                    	 			return 'png';
                    },
                    
                    logout: function( scopePointer, message )
                    {
                    	  
                    	AJAX.setToken( '' );
                    	id_account = -1;  
                    	username   = '';
                    	token	   = "-1";
                    	this.clearLocalStorage();
                    	
                    	var getWhat = {};
                    	 
                    	AJAX.patch( 'ACCOUNTS_LOGOUT' , getWhat ); 
                    	
                    	

                    	
                    	scopePointer.go('/login');
                    	if( typeof message != 'undefined' )
                    		 error = { status: 1, message: message, type: 'Error' };
                    
                    },
                    
                    restartAnimation: function( id ){
                    	
                    	//JQUERY DEPENDENT :(
                    	$(id).replaceWith($(id).clone(true));   
                    },
                    
                    ucwords: function( str )
                    {
                    	return   str.toLowerCase().replace(/\b[a-z]/g, function(letter) {
                    			return letter.toUpperCase();
    				});
   
                    },
                    
                    transformCareer: function( career )
                    {
                    	return career.replace('_',' ') ;	    
                    },
                    
                   
                    
                    setLogin: function( result )
                    {
                    	token 		= result.fields.token;
                    	settings.season = result.timestamp.season;
                    	settings.day 	= result.timestamp.day;
                    	AJAX.setToken( token );
                    	id_account	= result.fields.id;
                    },
                    setFooterPosition:function( to )
                    {
                    	footerPosition = to;    
                    },
                    getFooterPosition: function(){
                    	   
                    	//console.log("---------------------------------------------------------------- footerPosition >> <<< ");
                    	return footerPosition;    
                    },
                    get: function( which, pid, field )
                    {
                    	    /*
                    	    console.log("get >> "+which+" << ");
                    	    //ENABLE OFFLINE BROWSING
                    	    if( platform != this.getPlatform() )
                    	    {
                    	    	    console.log(" platform != de ");
                    	    	    if( isCordovaReady == true )
                    	    	    {
                    	    	    	     console.log(" cordovaready ");
					    if( typeof window.sqlitePlugin != 'undefined' )
					    {
						    platform = this.getPlatform();
						      console.log(" sqlitePlugin != undefined ");
						    if( typeof window.sqlitePlugin.openDatabase != 'undefined' )
						    {
						    	    console.log(" window.sqlitePlugin.openDatabase != undefined ");
						    	    if( getPlatform() == 'android' )
						    	    {
						    	    	    console.log('init. sqlLitePlugin');
								    offlineBrowsing 	=   1;
								    //alert('aici?');
								    //alert( window.sqlitePlugin.openDatabase({name: "DB", bgType: 1}) );
								    db 			=  window.sqlitePlugin.openDatabase({name: "DB", bgType: 1});
								    console.log('not crashed');
						            }
						    }
					    }
				   }
			    } */
                    	     
                    	    switch( which )
                    	    {
                    	    	        case "facebookAppId":
                    	    	        	return '1019725601390879';
                    	    	        break;
                    	    	    
                    	    	        case "id_account":
                    	    	             
                    	    	       	       return this.getIdAccount();
                    	    	       	break;
                    	    	       	
                    	    		case "email":
                    	    			return email;
                    	    		break;
                    	    	       	
                    	    		case "username":
                    	    			return username;
                    	    		break;
                    	    	       	
                    	    		case "last_login":
                    	    		case "sqlLogin":
                    	    		 
                    	    			return this.query('SELECT * FROM `last_login` ', 'last_login');
                    	    		break;
                    	    	       	
                    	    		case "accounts":
                    	    		    	return this.query('SELECT * FROM `accounts` WHERE `'+field+'` = "'+pid+'" ', 'accounts');
                    	    		break;
                    	    		case "token":
                    	    			return this.getToken();
                    	    		break;
                    	    		
                    	    		case "games_per_tier":
                    	    			return settings.games_per_tier;
                    	    		break;
                    	    		case "season":
                    	    			return settings.season;
                    	    		break;
                    	    	       	
                    	    		case "major_stats":
                    	    			return majorStats;
                    	    		break;
                    	    	    
                    	    	    	case "skills":
                    	    	    		if( typeof pid == 'undefined' )
                    	    	    			return skills;
                    	    	    	break;
                    	    	    	
                    	    		case "day":
                    	    			return settings.day;
                    	    		break;
                    	    	    	
                    	    		case "days":
                    	    			return settings.days;
                    	    		break;
                    	    		
                    	    		case 'contact_email':
                    	    			return 'contact@cybersports.com';
                    	    		break;
                    	    		
                    	    		case "skrill":
                    	    		case "paypal":
                    	    			return 'payments@cybersports.org';
                    	    		break;
                    	    		
                    	    		case "myClubs":
                    	    			if( Object.size(myTeams) >= 1 )
                    	    				 	 results     = myTeams;
                    	    				 		else
                    	    				 			results = tryParseJSON(getLocalStorage('myTeams'));
                    	    			return results;
                    	    		break;
                    	    		case "myClubs":
                    	    			if( Object.size(myTeams) >= 1 )
                    	    				 	 results     = myTeams;
                    	    				 		else
                    	    				 			results = tryParseJSON(getLocalStorage('myTeams'));
                    	    			return results;
                    	    		break;
                    	    		
                    	    		case "randomTeamId":
                    	    			if( Object.size(myTeams) >= 1 )
                    	    				 	 results     = myTeams;
                    	    				 		else
                    	    				 			results = tryParseJSON(getLocalStorage('myTeams'));
                    	    			
                    	    			if( results )
                    	    			{
                    	    				for( var tid in results )
                    	    					return results[tid].fields.id;
                    	    				//alert(JSON.stringify( results ));
                    	    				//console.log("random >>>"+JSON.stringify( results ) );	
                    	    				 
                    	    			}
                    	    		break;
                    	    		
                    	    		
                    	    		case "myTeams":
                    	    			pid =  this.get('id_account');
                    	    		case "teamsByAcc":
                    	    			if( pid == this.get('id_account') )
                    	    			{
                    	    				 var deferred = $q.defer();
                    	    				 var results = [];
                    	    				 //console.log( " >>> "+ JSON.stringify( myTeams ) );
                    	    				
                    	    				 if( Object.size(myTeams) >= 1 )
                    	    				 	 results     = myTeams;
                    	    				 		else
                    	    				 			results = tryParseJSON(getLocalStorage('myTeams'));
                    	    				 
                    	    				 deferred.resolve(results);
                    	    				 return deferred.promise; 
                    	    			}
                    	    			 
                    	    				//return this.query('SELECT * FROM `teams` WHERE `id_account` = "'+pid+'" ', 'competition');
                    	    		break;
                    	    		
                    	    		 
                    	    		
                    	    		case "countries":
                    	    			
                    	    			return {1:"Afghanistan",2:"Albania",3:"Algeria",4:"American Samoa",5:"Andorra",6:"Angola",7:"Anguilla",8:"Antigua and Barbuda",9:"Argentina",10:"Armenia",11:"Aruba",12:"Australia",13:"Austria",14:"Azerbaijan",15:"Bahamas, The",16:"Bahrain",17:"Baker Island",18:"Bangladesh",19:"Barbados",20:"Belarus",21:"Belgium",22:"Belize",23:"Benin",24:"Bermuda",25:"Bhutan",26:"Bolivia",27:"Bosnia and Herzegovina",28:"Botswana",29:"Brazil",30:"Virgin Islands",31:"Brunei",32:"Bulgaria",33:"Burkina Faso",34:"Burma",
35:"Burundi",36:"Cambodia",37:"Cameroon",38:"Canada",39:"Cape Verde",40:"Cayman Islands",41:"Central African Republic",42:"Chad",43:"Chile",44:"China",45:"Colombia",46:"Comoros",47:"Congo",48:"Cook Islands",49:"Coral Sea Islands",50:"Costa Rica",51:"Cote d`Ivoire",52:"Croatia",53:"Cuba",54:"Cyprus",55:"Czech Republic",56:"Denmark",57:"Dhekelia",58:"Djibouti",59:"Dominica",60:"Dominican Republic",61:"East Timor",62:"Ecuador",63:"Egypt",64:"El Salvador",65:"Equatorial Guinea",66:"Eritrea",67:"Estonia",
68:"Ethiopia",69:"Falkland Islands",70:"Faroe Islands",71:"Fiji",72:"Finland",73:"France",74:"French Guiana",75:"French Polynesia",76:"Gabon",77:"Gambia",78:"Gaza Strip",79:"Georgia",80:"Germany",81:"Ghana",82:"Gibraltar",83:"Glorioso Islands",84:"Greece",85:"Greenland",86:"Grenada",87:"Guadeloupe",88:"Guam",89:"Guatemala",90:"Guernsey",91:"Guinea",92:"Guinea-Bissau",93:"Guyana",94:"Haiti",95:"Honduras",96:"Hong Kong",97:"Howland Island",98:"Hungary",99:"Iceland",100:"India",101:"Indonesia",102:"Iran",
103:"Iraq",104:"Ireland",105:"Isle of Man",106:"Israel",107:"Italy",108:"Jamaica",109:"Japan",110:"Jersey",111:"Jordan",112:"Kazakhstan",113:"Kenya",114:"Kingman Reef",115:"Kiribati",116:"Kerguelen Archipelago",117:"Kuwait",118:"Kyrgyzstan",119:"Laos",120:"Latvia",121:"Lebanon",122:"Lesotho",123:"Liberia",124:"Libya",125:"Liechtenstein",126:"Lithuania",127:"Luxembourg",128:"Namibia",129:"Nauru",130:"Navassa Island",131:"Nepal",132:"Netherlands",133:"Netherlands Antilles",134:"New Caledonia",135:"New Zealand",
136:"Nicaragua",137:"Niger",138:"Nigeria",139:"Niue",140:"Norfolk Island",141:"North Korea",142:"Northern Mariana Islands",143:"Norway",144:"Oman",145:"Pakistan",146:"Palau",147:"Palmyra Atoll",148:"Panama",149:"Papua New Guinea",150:"Paracel Islands",151:"Paraguay",152:"Peru",153:"Philippines",154:"Pitcairn Islands",155:"Poland",156:"Portugal",157:"Puerto Rico",158:"Qatar",159:"Reunion",160:"Romania",161:"Russia",162:"Rwanda",163:"Saint Helena",164:"Saint Kitts and Nevis",165:"Saint Lucia",166:"Saint Pierre and Miquelon",
167:"Saint Vincent and the Grenadines",168:"Samoa",169:"San Marino",170:"Sao Tome and Principe",171:"Saudi Arabia",172:"Senegal",173:"Serbia",174:"Seychelles",175:"Sierra Leone",176:"Singapore",177:"Slovakia",178:"Slovenia",179:"Solomon Islands",180:"Somalia",181:"South Africa",182:"South Georgia",183:"South Korea",184:"Spain",185:"Spratly Islands",186:"Sri Lanka",187:"Sudan",188:"Suriname",189:"Svalbard",190:"Swaziland",191:"Sweden",192:"Switzerland",193:"Syria",194:"Taiwan",195:"Tajikistan",196:"Tanzania",
197:"Thailand",198:"Togo",199:"Tokelau",200:"Tonga",201:"Trinidad and Tobago",202:"Tromelin Island",203:"Tunisia",204:"Turkey",205:"Turkmenistan",206:"Turks and Caicos Islands",207:"Tuvalu",208:"Uganda",209:"Ukraine",210:"United Arab Emirates",211:"United Kingdom",212:"USA",213:"Uruguay",214:"Uzbekistan",215:"Vanuatu",216:"Venezuela",217:"Vietnam",218:"Virgin Islands",219:"Wake Island",220:"Wallis and Futuna",221:"West Bank",222:"Western Sahara",223:"Yemen",224:"Yugoslavia",225:"Zambia",226:"Zimbabwe",
227:"Mexico",228:"Malta",229:"Malaysia",230:"Monaco",231:"Montenegro",232:"Morocco",233:"Vatican",235:"Mongolia",250:"Macedonia"};	

                    	    		break;
                    	    		
                    	    		case "myPlayersArray":
                    	    			 var myPlayersList = this.get('myPlayers');
                	 	 
						 if( typeof myPlayersList == 'undefined' )
							 return [];
						 
						 if( typeof myPlayersList['$$state'] == 'undefined' )
							 return [];
						 
						 var players = [];
						 var myPlayers = myPlayersList['$$state'];
						 if( typeof myPlayers['value'] != 0 )
							 for( var i in myPlayers['value'] )
							 	if( typeof myPlayers['value'][i]['fields'] != 'undefined' )
									players.push( myPlayers['value'][i] );
							
						return players;
                    	    		break;
                    	    		
                    	    		case "myPlayers":
                    	    			pid = this.get('id_account');
                    	    		case "playersByAcc":
                    	    			if( pid == this.get('id_account') )
                    	    			{
                    	    				 var deferred = $q.defer();
                    	    				 var results = {};
                    	    				 //alert(myPlayersStringified);
                    	    				// console.log(">>>>>>>>>>>>"+myPlayers+"<<<<");
                    	    				/*
                    	    				 if( Object.size(myPlayers) >= 1 )
                    	    				 	 results     = myPlayers;
                    	    				 		else
                    	    				 			results =*/ 
                    	    				 if( this.canLocalStorage() )			
                    	    				 	results = tryParseJSON(getLocalStorage('myPlayers'));
                    	    				 else{
                    	    				 	 if( myPlayersStringified )
                    	    				 	 	results = tryParseJSON(myPlayersStringified);
                    	    				 }
                    	    				 deferred.resolve(results);	
                    	    				 return deferred.promise; 
                    	    			}
                    	    		 
                    	    			  return this.query('SELECT * FROM `players` WHERE `id_account` = "'+pid+'" ', 'competition');
                    	    		break;
                    	    		
                    	    		case "competition":
                    	    		case "competitions":
                    	    			 
                    	    			return this.query('SELECT * FROM `competitions` WHERE `id` = "'+pid+'" ', 'competition');
                    	    		break;
                    	    		

                    	    		
                    	    		case "wall": 
                    	    			return this.query('SELECT * FROM `wall` WHERE `id` = "'+pid+'"  ', 'wall');  
                    	    		break;
                    	    	    	
                    	    		case "lastRest":
                    	    		case "lastRequest": 
                    	    			return this.query('SELECT * FROM `lastRest` WHERE `id` = "'+pid+'" ', 'lastRest');  
                    	    		break;
                    	    	    	
                    	    		 
                    	    		
                    	    		case "playerTactics":
                    	    			return this.query('SELECT * FROM `playerTactics` WHERE `'+field+'` = "'+pid+'" ', 'playerTactics');  
                    	    	
                    	    		break;
                    	    		 
                    	    		case "teams":
                    	    		case "team": 
                    	    			return this.query('SELECT * FROM `teams` WHERE `id` = "'+pid+'" ', 'team');   
                    	    		break;
                    	    	    
                    	    		case "player": 
                    	    			return this.query('SELECT * FROM `players` WHERE `id` = "'+pid+'" ', 'player');  
                    	    		break; 
                    	    		
                    	    		case "playersByClub":
                    	    		case "players":
                    	    			return this.query('SELECT * FROM `players` WHERE `id_club` = "'+pid+'" ', 'player');  
                    	    		break;
                    	    		
                    	    		case "gameList":
                    	    			return this.query('SELECT * FROM `'+which+'` WHERE `id_account` = "'+pid+'" ', 'team');   
                    	    		break;
                    	    		
                    	    		case "careers":
                    	    			return {
                    	    				1:tr('Rookie'),
                    	    				2:tr('Sophomore'),
                    	    				3:tr('Junior 1'),
                    	    				4:tr('Junior 2'),
                    	    				5:tr('Junior 3'),
                    	    				6:tr('Senior 1'),
                    	    				7:tr('Senior 2'),
                    	    				8:tr('Senior 3'),
                    	    				9:tr('Elite'),
                    	    				10:tr('Prime'),
                    	    				11:tr('Veteran')
                    	    			};
                    	    		break;
                    	    		
                    	    		default:
                    	    			return this.query('SELECT * FROM `'+which+'` WHERE `id` = "'+pid+'" ', 'team');   
                    	    		break;
                    	    }
                    },
                    
                    getCareers: function( active )
                    {
                    	var careers = [{value: 'rookie', label: tr('Rookie'), id: 1},
                    		       {value: 'sophomore', label: tr('Sophomore'), id: 2},
                    		       {value: 'junior_1', label: tr('Junior 1'), id:3},
                    		       {value: 'junior_2', label: tr('Junior 2'), id: 4},
                    		       {value: 'junior_3', label: tr('Junior 3'), id: 5},
                    		       {value: 'senior_1', label: tr('Senior 1'), id: 6},
                    		       {value: 'senior_2', label: tr('Senior 2'), id: 7},
                    		       {value: 'senior_3', label: tr('Senior 3'), id: 8},
                    		       {value: 'elite', 	  label: tr('Elite'), id: 9},
                    		       {value: 'prime', 	  label: tr('Prime'), id: 10},
                    		       {value: 'veteran',  label: tr('Veteran'), id: 11}];
                       	
                    	if( active == 1 )
                        {
                        	for( var i in careers )
                        		if( careers[i].id > this.get('season') )
                        			delete careers[i];
                        		
                        	return careers;
                        }
                    		
                    	return careers;
                    		
                    },
                    
                    tableToString: function( size )
                    {
                    	    switch( size ){
                    	    	case 2: return tr('Final'); break;	    
                    	    	case 4: return tr('Semifinals'); break; 
                    	    	case 8: return tr('Quarterfinals'); break;  
                    	    	case 16: return tr('Sweet Sixteen'); break;  
                    	    	default: 
                    	    		var v = {runda: size};
                    	    		return tr('{runda} Table',v);
                    	    	break; 
                    	    }
                    },
                    
                    getTableSize: function( size )
                    {
                		if( size >= 1 && size <= 1 )
                			return 2;
                		if( size >= 2 && size <= 2 )
                			return 4;
                		if( size >= 3 && size <= 4 )
                			return 8; 
                		if( size >=5 && size <= 8 )
                			return 16;
                		if( size >=9 && size <= 16 )
                			return 32;
                		if( size >=17 && size <= 32 )
                			return 64;
                		if( size >=33 && size <= 64 )
                			return 128;
                		if( size >=65 && size <= 128 )
                			return 256;
                		if( size >=129 && size <= 256 )
                			return 512;
                		if( size >=257 && size <= 512 )
                			return 1024;
                		if( size >=513 && size <= 1024 )
                			return 2048;
                		if( size >=1025 && size <= 5096 )
                			return 5096;
                	},
                    
                    patch: function( query )
                    {
                    	    return this.query(query, 'patch');  
                    },
                    
                    //parsed database result.
                    //indexes as fields      | example: players table => player.id = x, player.id_account = y, player.id_club = z
                    //JSON strings as JSONS  |          player.fields = parseJSON, player.equipment = parseJSON, player.skills = parseJSON
                    parseResult: function( result, method )
                    { 
                    	    //we don't usually use this but i wanted to included in case in the future someone needs something specific
                    	    if( typeof method == 'undefined' )
                    	    	    method = 'default';
                    	    
                    	    var works = {};
                    	    var list  = {};
                    	    switch( method )
                    	    {
                    	    	   default:
                    	    	   	   //parse each row
                    	    	   	  	for (var i = 0; i < result.rows.length; i++) {
                    	    	   	  		list[i] = {};
                    	    	   	  		
                    	    	   	  		//foreach field in the row
                    	    	   	  		for( var field in result.rows.item(i) )
                    	    	   	  		{
                    	    	   	  			//console.log(" result [ "+i+" ][ "+field+" ] ==> "+result.rows.item(i)[field]+" << ");
                    	    	   	  		
                    	    	   	  			//parseJSON or save as field (only indexes on tables)
                    	    	   	  			works = tryParseJSON( result.rows.item(i)[field] );
                    	    	   	  			if( works === false )
                    	    	   	  				list[i][field] = result.rows.item(i)[field];
                    	    	   	  					else
                    	    	   	  						list[i][field] = works;
                    	    	   	  		}
                    	    	   	  	}
                    	    	   break;
                    	    }
                    	    
                    	    return list;
                    },
                    
                    getData: function( )
                    {   //alert(JSON.stringify(data));
                    	var info = data;
                    	for( var i in info.players )
                    	{
                    		if( typeof info.players[i].id != 'undefined' )
                    		{
					var cid = info.players[i].id_club;
					var pid = info.players[i].id;
					if( typeof data.playingFor == 'undefined' )
						data.playingFor = {};
					
					if( typeof data.playingFor[ cid ] == 'undefined' )
					{
						data.playingFor[ cid ] 		= {};
						data.playingFor[ cid ].name	= data.players[i].club_name;
						 
						data.playingFor[ cid ].players  = []; 
						data.playingFor[ cid ].count	= 0;
						data.playingFor[ cid ].id	= cid;
					}
					data.playingFor[ info.players[i].id_club ].players.push( pid );
					data.playingFor[ cid ].count++;
					
					var v = [];
					v['num'] 	= data.playingFor[ cid ].count;
					v['fred'] 	= '<font class="red_12">';
					v['fclose'] 	= '</font>';
					v['club_name']  = data.playingFor[ cid ].name;
					v['team_name']	= data.playingFor[ cid ].name;
					if( cid == 0 )
					{ 
						if( data.playingFor[ cid ].count == 1 )
							data.playingFor[ cid ].text = tr('{num} player is <B>{fred}UNDRAFTED{fclose}</B>',v);
								else
									data.playingFor[ cid ].text = tr('{num} players are <B>{fred}UNDRAFTED{fclose}</B>',v);
					}
					else
					{
						data.playingFor[ cid ].text = tr('playing for the {team_name}',v);
						
					}
				}
                        }
                    	//alert(JSON.stringify( data.playingFor ) );
                    	return data;	    
                    },
                    
                    checkNotifications: function( data, scopePointer )
                    {
                    	   if( typeof data.notifications != 'undefined' )
                    	   {
                    	    	    scopePointer.notifications = {};
                    	    	    scopePointer.notifications.count = data.notifications;
                    	    	    notificationCount = data.notifications;  
                    	   } 
                    	   
                    	   if( typeof data.timestamp != 'undefined' )
                    	   {
                    	    	    var timestamp = data.timestamp;
				    settings.season = timestamp.season;
				    settings.day    = timestamp.day;
				    settings.days   = timestamp.days;
                    	   }
                    },
                    
                    getNotifications: function()
                    {
                    	    return notificationCount;
                    },
                    
                    setNotifications: function( to )
                    {
                    	    notificationCount = to;
                    },
                    
                    //synches AJAX request with SQL LITE database
                    synch: function( module, latest, current, timestamp, data, scopePointer )
                    { 
                    	
                    	    switch( module )
                    	    {
                    	    	    
                    	    	    case "lastRest":
                    	    	    	    this.update( module, 0, latest, timestamp ); 
                    	    	    break;
                    	    	    
                    	    	    case "team":
                    	   	    case "teams":
                    	   	    	    var toLocalStorage = {};
                    	   	    	    var toSave	       = 0;
                    	   	    	    if( typeof latest != 'undefined' )
                    	   	    	    	if( typeof latest.fields != 'undefined' )
                    	   	    	    		if(   latest.fields.id_account == this.get('id_account') )
                    	   	    	    		{
                    	   	    	    			myTeams[ latest.fields.id ] = latest; 
                    	   	    	    		}
                    	   	    	 
                    	   	    	            saveLocalStorage('myTeams'      , JSON.stringify(myTeams) );
                    	   	    	    	    //localStorage.setItem( 'myTeams'      , JSON.stringify(myTeams) ); 
                    	   	    	   
                    	   	    	    
                    	    	    break;
                    	    	    
                    	    	    case "player":
                    	    	    case "players":
                    	    	    	                        	   	    
                    	   	    	    var toLocalStorage = {};
                    	   	    	    var toSave	       = 0;
                    	    	    	     if( typeof latest != 'undefined' )
						    if( typeof latest.fields != 'undefined' )
						    { 
								if(   latest.fields.id_account == this.get('id_account') )
								{
									myPlayers[ latest.fields.id ] = latest;	  
									
									if( typeof toLocalStorage[ latest.fields.id ] == 'undefined' )
										toLocalStorage[ latest.fields.id ] = {};	
                    	   	    	    				
                    	   	    	    			toLocalStorage[ latest.fields.id ]  = latest;
                    	   	    	    			toSave=1;
                    	   	    	    			}
                    	   	    	    	   }
                    	   	    	  
                    	   	    	    myPlayersStringified = JSON.stringify(myPlayers);
                    	   	     
                    	   	    	    saveLocalStorage('myPlayers'      , JSON.stringify(myPlayers));
                    	   	    	    //localStorage.setItem( 'myPlayers'      , JSON.stringify(myPlayers) ); 
                    	   	    	     
                    	    	    break;
                    	    	     
                    	    	    case "playerProfile":
                    	    	    case "accounts":
                    	    	    case "account":
                    	    	    case "player":
                    	    	    case "mine":
                    	            case "myPlayer":
                    	    	    default:  
                    	            	    for( var i in latest )
                    	            	    { 
                    	            	    	if( this.check( module, i, latest, current ) ){
                    	            	    		this.update( module, i, latest, timestamp );
                    	            	    		break;
                    	            	    	}
                    	            	    }
                    	            	    
                    	    	    break;
                    	    	    
                    	    } 
                    },
                    
                    createArray: function( num )
                    {
                    	var arr = [];
                    	for(var i=0;i<=5;i++)
                    		arr.push(i);
                    	return arr;
                    },
                    
                    nullToDash: function( val )
                    {
                    	if( parseFloat(val) == 0 )
                    		return '-';
                    	
                    	return val;
                    },
                    
                    //SQL-query basically.
                    //these are ASYNCHRONOUS. SO. We return a promise. Whoever calls this function will use something like:
                    //result.then(function(){..});
                    query: function( query, method )
                    {
                    	    var deferred = $q.defer();
                    	    var obj	 = this;
                    	       
                    	/*alert( "offlineBrowsing--->"+offlineBrowsing);
                    	alert( "dbNotCreated--->"+dbNotCreated);  
                    	alert( "platform--->"+getPlatform());*/
                    	
                    	if( offlineBrowsing )
                    	{  
                    		 
				if( dbNotCreated )   
					this.createDatabase();
                    		
				 
				
				db.transaction(function(tx) {    
						 tx.executeSql( query, [], function (tx, result) {
								//console.log( query + " >>> " + result );
								//console.log(result.rows.length + " <<< <BR>");
								 var results = obj.parseResult( result, method );
								  
								 deferred.resolve(results);
								 return result;
								},  function errorHandler(transaction, error) { 
									if( typeof error != 'undefined' )
										if( typeof error.message != 'undefined' )
										{
											var lookFor = 'no such table';
											if( error.message.indexOf(lookFor) >= 0){
												obj.createDatabase();	
											}
											
											//console.log( query+'          >>INSERT. Error was ' + error.message + ' (Code ' + error.code + ')');
										}
				})});
			}
			else
			{	
				var results = [];
				deferred.resolve(results);
			}
			
			return deferred.promise; 
                    },
                    
                    createDatabase: function()
                    {
                    	    dbNotCreated = 0;
                    	    //console.log("creating database");
                    	    /*alert('creating database');*/
                    	    db.transaction(function(tx){ tx.executeSql( ' DROP  `competitionList`' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( ' CREATE TABLE `competitionList` (`id`	TEXT,`leagues`	TEXT,`tournaments`	TEXT,`timestamp`	TEXT,PRIMARY KEY(id)) ;' ) } );
                   	         	    
                    	    db.transaction(function(tx){ tx.executeSql( ' DROP TABLE   `forum`' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( ' CREATE TABLE `forum` (`id`	INTEGER,`threads`	TEXT,`last_activity`	TEXT,`last_activity_excl`	TEXT,`my_countries`	TEXT,`private_forums`	TEXT,`timestamp`	TEXT,PRIMARY KEY(id));' ) } );
                    	 
                    	    db.transaction(function(tx){ tx.executeSql( ' DROP  `competitionList`' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( ' CREATE TABLE `competitionList` (`id`	TEXT,`leagues`	TEXT,`tournaments`	TEXT,`timestamp`	TEXT,PRIMARY KEY(id)) ;' ) } );
                    
                            db.transaction(function(tx){ tx.executeSql( 'DROP TABLE   `notifications`' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE TABLE `notifications` (`id`	INTEGER,`alerts`	TEXT,`timestamp`	TEXT,PRIMARY KEY(id) )' ) } );
                    		
                    	    db.transaction(function(tx){ tx.executeSql( 'DROP TABLE `games`' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE TABLE `games` (`id`	INTEGER PRIMARY KEY AUTOINCREMENT,`fields`	TEXT,`play_by_play`	TEXT,`attendance`	TEXT,`competition`	TEXT,`stats`	TEXT,`quarterScores`	TEXT,`home_team`	TEXT,`away_team`	TEXT,`sim`	TEXT,`starters`	TEXT,`players`	TEXT,`timestamp`	TEXT)' ) } );
                    	
                    	    db.transaction(function(tx){ tx.executeSql( 'DROP TABLE `gameList`' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE TABLE `gameList` (`id_account`	INTEGER,`games`	TEXT,`timestamp`	TEXT,`id`	INTEGER,PRIMARY KEY(id_account));') } );
                    	    
                    	    db.transaction(function(tx){ tx.executeSql( 'DROP TABLE `last_login`' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE TABLE `last_login` (`id`	INTEGER,`fields` TEXT, `email`	TEXT,`token` TEXT,`username`	INTEGER,`id_account` INTEGER, `timestamp` TEXT, PRIMARY KEY(id));' ) } );
                    	         
                    	
                    	    db.transaction(function(tx){ tx.executeSql( 'DROP TABLE   `playerTactics`' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE TABLE `playerTactics` (`id`	INTEGER PRIMARY KEY AUTOINCREMENT,`id_account`	INTEGER,`id_club`	INTEGER,`fields`	TEXT,`tactics`	TEXT, `timestamp` TEXT);' ) } ); 
                            db.transaction(function(tx){ tx.executeSql( 'CREATE INDEX `id_account` 		ON `playerTactics` (`id_account` ASC);' ) } ); 
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE INDEX `id_club` 		ON `playerTactics` (`id_club` ASC);' ) } ); 
                    	       
                    	    db.transaction(function(tx){ tx.executeSql( 'DROP TABLE `competitions`' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE TABLE `competitions` ( `id`	TEXT PRIMARY KEY,`type`	INTEGER,`career` TEXT, `fields`	TEXT, `standings`	TEXT, `next_round`	TEXT, `last_round`	TEXT, `playoffs`	TEXT, `previous_winners` TEXT, `stats`	TEXT, `mvp_race`	TEXT, `schedule` TEXT, `timestamp`	TEXT );' ) } ); 
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE INDEX `type` 		ON `competitions` (`type` ASC);' ) } ); 
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE INDEX `career` 		ON `competitions` (`career` ASC);' ) } ); 
                      	  
                    	    db.transaction(function(tx){ tx.executeSql( 'DROP TABLE `wall`' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE TABLE `wall` ( `id`	TEXT PRIMARY KEY, `posts`	TEXT ,`timestamp` TEXT );' ) } );
                    	                	  
                    	    
                    	    db.transaction(function(tx){ tx.executeSql( 'DROP TABLE `teams`' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE TABLE `teams` ( `id`	INTEGER PRIMARY KEY AUTOINCREMENT, `fields`	TEXT, `stats`	TEXT, `fixtures`	TEXT, `results`	TEXT, `standings`	TEXT, `id_account`	INTEGER, `league` TEXT, `awards`	TEXT, `history` TEXT, `timestamp`	TEXT );' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE INDEX `id_account` 		ON `teams` (`id_account` ASC);' ) } ); 
                    	   
                    	    db.transaction(function(tx){ tx.executeSql( 'DROP TABLE `teamHistory`' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE TABLE `teamHistory` ( `id`	TEXT PRIMARY KEY,`season` INTEGER, `fields`	TEXT, `stats`	TEXT, `players` TEXT, `story` TEXT, `standings`	TEXT, `id_account`	INTEGER, `league` TEXT, `awards`	TEXT, `history` TEXT, `timestamp`	TEXT );' ) } );
                    	    
                    	    db.transaction(function(tx){ tx.executeSql( 'DROP TABLE `lastRest`' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE TABLE `lastRest` (`id`	TEXT PRIMARY KEY,`field` TEXT, `timestamp`	TEXT);' ) } );
                    	    
                    
                    	   
                    	    db.transaction(function(tx){ tx.executeSql( 'DROP TABLE `players`' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE TABLE `players` (`id`	INTEGER PRIMARY KEY AUTOINCREMENT UNIQUE,`id_club`	INTEGER,`id_account`	INTEGER,`fields`	TEXT,`goals`	TEXT,`skills`	TEXT,`contract`	TEXT,`training`	TEXT,`fixtures`	TEXT,`results`	TEXT,`timestamp`	TEXT, `equipment`     TEXT, `playingFor`   TEXT, `club` TEXT, `career` TEXT, `profile` TEXT, `stats` TEXT, `awards` TEXT, `history` TEXT, `statsHistory` TEXT, `ratings` TEXT);' ) } );               	   
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE INDEX `id_club` 		ON `players` (`id_club` ASC);' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE INDEX `id_account` 	ON `players` (`id_account` ASC);' ) } );
                      	   
                    	    db.transaction(function(tx){ tx.executeSql( 'DROP TABLE `accounts`' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE TABLE `accounts` (`id`	INTEGER,`fields`	TEXT, `username` TEXT, `forum` TEXT, `awardsCount` TEXT, `timestamp` TEXT, `last_login` TEXT,PRIMARY KEY(id));' ) } );
                    	    db.transaction(function(tx){ tx.executeSql( 'CREATE INDEX `username` 		ON `accounts` (`username` ASC);' ) } ); 
                      	     	
                    	      //uncomment here    
                    	    
                    },
                    
                    update: function( module, method, dataSet, timestamp )
                    { 
                    	    var obj		= this;
                    	    //var db = window.sqlitePlugin.createDatabase("Database", "1.0", "PhoneGap Demo", 200000);
                    	    var field 		= '';  
                    	    var queries 	= [];
                    	    var queries 	= this.getQueries( module,method,dataSet,timestamp );
                    	  
                    	    if( typeof timestamp != 'undefined' )
                    	    {
				    settings.season = timestamp.season;
				    settings.day    = timestamp.day;
				    settings.days   = timestamp.days;
                    	    }
                    	   
                   
                    	    //make each query. ugliest code ever..
                    	    //if update returns 0 rows, make insert.
                    	
                    	    if( offlineBrowsing )
				    for( var q in queries )
				    {     
					    db.transaction(
						    function(tx) { 
							    tx.executeSql(queries[q]['update'], [], function (tx, result) {
									   /*console.log(" >> "+queries[q]['update']+" << ");
									    console.log( "update typeof "+(typeof result)+" << ");
									    console.log(" this update had ...<<<<<<<< "+result.rowsAffected+" <<  ");
									   */
									    if( result.rowsAffected == 0 )
									    {
										 /* console.log(" INSERT ! >> "+queries[q]['insert']+" << <BR>"); */
										   tx.executeSql(queries[q]['insert'], [], function (tx, result) {
													
											},  function errorHandler(transaction, error) {
												/*console.log(queries[q]['insert']+'          >>INSERT. Error was ' + error.message + ' (Code ' + error.code + ')');
												/*alert(queries[q]['insert']+'INSERT. Error was ' + error.message + ' (Code ' + error.code + ')');*/
											return false;
											} 
												); 
									    }
								},  function errorHandler(transaction, error) {
									if( typeof error != 'undefined' )
										if( typeof error.message != 'undefined' )
										{
											 
											//console.log(queries[q]['update']+'        >>UPDATE. Error was ' + error.message + ' (Code ' + error.code + ')');
											//alert(queries[q]['update']+'UPDATE. Error was ' + error.message + ' (Code ' + error.code + ')');
											var lookFor = 'no such table';
											if( error.message.indexOf(lookFor) >= 0){
												obj.createDatabase();	
											}
										}
									return false;
								} 
									);
							    }
							     
							  ); 
				    }
                    	    //console.log("method:"+method+" || "+JSON.stringify(dataSet[method])+" || timestamp >> "+JSON.stringify(timestamp )+" << ");
                    },
                    parseInt: function(num){ return parseInt(num);
                    },
                    call: function( module, vars, notification, returner ){
                    	var box    = module.split(":");
                    	var method = box[ box.length - 1 ];
                    	method = method.toLowerCase();
                    	var link = window.scope(); 
                    	if( method == 'put' )
                    		var promise = AJAX.put(box[0], vars, notification ); 
                    	if( method == 'get' )
                    		var promise = AJAX.get(box[0], vars, notification ); 
                    	if( method == 'patch' )
                    		var promise = AJAX.patch(box[0], vars, notification ); 
                    	
                    	var obj = this;
                    	promise.success(function(data, status, headers, config) {
                     
							link.API.setResting(false);
							if( data.status == 'SUCCESS' )
							{
								if( data.ret.message )
									link.API.setMessage( data.ret.message );  
								
								if( notification )
									obj.checkNotifications(data, window.scope());
								
								if( method == 'get' ) 
									if( typeof returner != 'function' )
										link.data				= data.ret; 
									else
										returner( data ); 
								//^call returner function for most get calls.
									
								//returner = data.allstar
								//data.allstar = data.ret.returner;
								if( method=='put' && method=='patch' && typeof returner == 'string' ){
									var objs = returner.split(".");
									if( objs.length == 1 )
										link.data[objs[0]] = data.ret['return'];
									
									if( objs.length == 2 ){ 
											if( !link.data[objs[0]] )
												link.data[objs[0]] = {}; 
										 	link.data[objs[0]][objs[1]] = data.ret['return'];
										 
										 	
									}
								}
							}
							else{
								if( data.ret )
									link.API.setError( data.ret.message );
								else
									link.API.setError( 'REST', window.SC() );
							}
						});
                    	
                    	promise.error(function(data, status, headers, config) {
							  link.API.setResting( false );
							  link.API.setError( 'REST',  window.SC() );
						});
                    	
                    },
                    
                    //creates queries for SQLLITE
                    getQueries: function( module,method,dataSet,timestamp)
                    {   
                    	var queries = [];
                    	switch( module )
                    	{
                    		case "myPlayer":
                    	    	case "player":
                    	    			var JSONfields   = JSONS['player']; 
                    	    			var INDEXES 	 = ['id_club','id_account'];
                    	    			var query        = this.generateQueries( 'players', dataSet, timestamp, JSONfields, INDEXES ); 
                    	    			queries.push(query);
                    	    	break;
                    	    	
                    		case "account":
                    				var JSONfields   = JSONS['accounts'];  
                    	    			var query        = this.generateQueries( 'accounts', dataSet, timestamp, JSONfields, INDEXES ); 
                    	    			queries.push(query);
                    		break;
                    		
                    		default:
						var JSONfields   = JSONS[module];
						var INDEXES	 = INDEXfields[module];
						var query        = this.generateQueries( module, dataSet, timestamp, JSONfields, INDEXES ); 
						queries.push(query);
                    		break;
                    	    }	   
                    	     
                    	    return queries;
                    },
                    
                    //generates an INSERT query from a JSON
                    //the table structure for player:
                    //FIELDS:
                    //( INT & INDEXES ): id,id_club,id_account
                    //( JSONS ): fields,fixtures,results,training,equipment,goals
                    generateQueries: function( table, dataSet, timestamp, JSONS, INDEXES )
                    {
                    	     
                    	    var comma	 = '';
                    	    var field  	 = '';
                    	    var updateFields = '';
                    	    var insertFields = '';
                    	    var insertValues = '';
                    	    var value;
                    	    /*
                    	    if( table=='lastRest')
                    	    {
                    	    	console.log( "dataSet >>>"+JSON.stringify( dataSet )+" <<<< <BR>");
                    	    	console.log( "timestamp >>>"+JSON.stringify( timestamp )+" <<< <BR>");
                    	    	console.log( "JSONS >>>"+JSON.stringify( JSONS )+" <<< <BR>");
                    	    	console.log( ">>>"+JSON.stringify( INDEXES )+" <<< <BR>");
                    	    }*/
                    	    //go thru the JSONS and see if there's data to be updated
                    	    if( typeof JSONS != 'undefined' )
				    for( var j in JSONS )
				    {
					    field = JSONS[j];
					     
					    if( typeof dataSet[ field ] != 'undefined' )
					    {
					    	    //alert( dataSet[ field ] + " DATASET? >> "+field+" " + (typeof dataSet[ field ]) );
						    value = this.sqlJSON( dataSet[ field ], field );
						    if( value != false )
						    { 
						    	    //we need to keep the integrity of the data
						    	    //strings, null or integer
						    	    if( value != null ) 
						    	    	    value = "'"+value+"'";
						    	    
							    updateFields += comma + " `"+field+"` = "+value+" "; 
							    insertFields += comma + "`"+field+"`";
							    insertValues += comma + value;
										
							    comma = ',';
						    }
					    }
				    }
                    	    
                    	    //go thru the INDEXES and see if there's data to be updated
                    	     
                    	    if( typeof INDEXES != 'undefined' )
				    for( var j in INDEXES )
				    {
					    field = INDEXES[j];
					    if( typeof dataSet.fields != 'undefined' )
						    if( typeof dataSet.fields[ field ] != 'undefined' )
						    {  
						    	    value = dataSet.fields[ field ];
						    	    if( typeof value != 'undefined' )
						    	    {
						    	    	    
						    	    	    
								    updateFields += comma + " `"+field+"` = '"+value+"' ";
								    insertFields += comma + "`"+field+"`";
								    insertValues += comma + "'"+value+"'";
											
								    comma = ',';
							    }
						    }
				    }
                    	       
                    	    	var query = {};
                    	    	
                    	    	
                    	    	//APP based updates provide no timestamp
                    	    	if( typeof timestamp != 'undefined' ) 
                    	    		var andTimestamp = {update: ", `timestamp` = '"+this.sqlJSON(timestamp, "timestamp")+"' ", insertField: ",`timestamp`", insertValue:",'"+this.sqlJSON(timestamp)+"'" };
                    	    			else
                    	    				var andTimestamp = {update:"", insertField:"", insertValue:""};
                    	    	//patch them together in an UPDATE and if that does not work, INSERT statement.
                    	    	//on duplicate key update does not work. workaround. if update returns -1 -> insert. 
                    	    	var id_item;
                    	    	
                    	    	if( typeof dataSet.fields != 'undefined' )
                    	    		if( typeof dataSet.fields.id != 'undefined' )
                    	    			id_item = dataSet.fields.id;
                    	    	 
                    	    	if( typeof dataSet.id != 'undefined' )
                    	    		id_item = dataSet.id;
                    	    	
                    	    	
                    	    	
                    	    
                    	    	query.update 	= "UPDATE `"+table+"` SET "+updateFields+" "+(andTimestamp.update)+" WHERE `id` = '"+ id_item +"' ";
                    	    	query.insert    = "INSERT INTO `"+table+"`("+insertFields+",id"+(andTimestamp.insertField)+") values("+insertValues+",'"+id_item+"'"+(andTimestamp.insertValue)+") "; 
                    	    	
                    	    	 
                    	    	//console.log( query.update );
                    	    	//console.log( query.insert );
                    	    	return query;
                    	    
                    },
                    
                    //parses a JSON in order to make it insertable in a SQLLITE database
                    //removes ' to ascii and JSON.stringify
                    sqlJSON: function( jsonVar, field )
                    {  
                    	    if( jsonVar == null )
                    	    	    return null;
                    	    
                    	    var string = JSON.stringify( jsonVar );
                    	    
                    	    if( string != false )
                    	    {
                    	    	    if( typeof field != 'undefined' )
                    	    	    {
                    	    	    	   //console.log("BEFORE ["+field+"] >> "+string+" ");//"+string+"
                    	    	    	    if( field == 'posts' )
                    	    	    	    {
                    	    	    	    	    //  console.log("BEFORE ["+field+"] >> "+string+" ");
                    	    	    	    	    //  console.log("AFTER ["+field+"] >> "+string.replace('"','&#34;').replace("'","&#39;")+" ");
					    	   return string.replace('"','&#34;').replace("'","&#39;");
					    }
					    
					    if( field == 'club' || field == 'threads' || field == 'private_forums' || field == 'last_activity' || field == 'last_activity_excl' || field == 'my_countries' || field == 'alerts' || field == 'games' || field == 'posts' || field == 'stats' || field == 'fields' || field =='equipment' || field == 'user' || field == 'next_round' || field == 'playoffs' || field == 'last_round' || field == 'standings'  || field =='fixtures' || field =='results' )
					    {
					    
					    	   //console.log("AFTER ["+field+"] >> "+string+" ");
						    return string.replace(/'/g, '&#39;');
					    }
					    
					    
				    }
					return string;    
			    }
				    
				    return false;
                    },
                    
                    needsAjax: function( result )
                    { 
                    	return 1;    
                    },
                    
                    setVar: function( which, to )
                    {
                    	// console.log("[setVar] = "+which+" = "+vars[which]+" << ");   
                    	 vars[which] = to;   
                    	saveLocalStorage( which      , to ); 
                    	 
                    	 
                    },
                    
                    getVar: function( which )
                    {
                    	    //console.log("[getVar] = "+which+" = "+vars[which]+" << ");
                    	    if( this.canLocalStorage() )
                    	    {
                    	    	    //console.log("[getVar] can localstorage ");
                    	    	    return getLocalStorage(  which );
                    	    }
                    	return vars[which];    
                    },
                    
                    setOneSignalId: function( to )
                    {
                    	   
                    	oneSignalId = to;    
                    	//console.log('[setOneSignalId] setting oneSignalId to '+to+' == '+oneSignalId);
                    	saveLocalStorage( 'oneSignalId'      , oneSignalId ); 
                    },
                    
                    getOneSignalId: function()
                    {
                    	    if( this.canLocalStorage() )
                    	    {
                    	    	    //console.log("[getOneSignalId] can localstorage "); 
                    	    	    return getLocalStorage( 'oneSignalId' );
                    	    }
                    	    //console.log("[getOneSignalId] return oneSignalId is"+oneSignalId);
                    	    return oneSignalId;
                    },
                    
                    //checks if there are changes to our dataset. if so,
                    //then update our dataset 
                    check: function( module, method, dataSet, current )
                    {
                    	if( current == null )
                    		return 1;
                    	   
                    	if( typeof current[ method ] == 'undefined' )
                    		return 1;
                    	
                    	for( var i in dataSet[ method ] )
                    		if( typeof current[method] != 'undefined' )
                    		{
                    			//console.log( '>> '+i+' >>> method = '+method+' | '+(typeof current[ method ])+' ?? << ');
					if( current[method] != null )
						if( typeof current[ method ][ i ] == 'undefined' )
							return 1;
								else if( current[ method ][ i ] != dataSet[ method ][ i ] )
									return 1;
										else;
				}
				else
					return 1;
                    					
                    				
                    	return 0;
                    },
                    
                    getHandshake: function(){
                    	return '?app=phone';    
                    },
                    
                    getTimestamp: function( whichDate )
                    {
                    	    return Date.parse( whichDate )/1000;
                    },
                    
                    parseTime: function( time ){
                     
                    	    	var minutes = Math.floor(time / 60);
				if( minutes <= 9 )
					minutes = '0'+minutes;
		 
				var seconds = time - minutes * 60;
				if( seconds <= 9   )
					seconds = '0'+seconds;
				return  minutes+':'+seconds;
                    },
                    
                    getSkillpoints: function( day, superstar )
                    {
                    	    //if( day > 50 )
                    	    //	    return 0;
                    	    
                    	    var played = { 
				0 : 3,
				1 : 4,
				2 : 5,
				3 : 6,
				4 : 7,
				5 : 9,
				6 : 11,
				7 : 13,
				8 : 14,
				9 : 15,
				10 : 17,
				11 : 18,
				12 : 20,
				13 : 21,
				14 : 23,
				15 : 24,
				16 : 25,
				17 : 28,
				18 : 29,
				21 : 30,
				19 : 31,
				22 : 32,
				20 : 38,
				23 : 41,
				24 : 43,
				25 : 45,
				26 : 47,
				27 : 49,
				28 : 51,
				29 : 53 
			    }
			    //console.log(">>>day="+day+"<<");
			    var gamesPlayed 	= 0;
                    	    var starting 	= 8000;
                    	    for( var runda in played )
                    	    {
                    	    	    //console.log(" runda = "+runda+" , played = "+played[runda]+"<< <= day");
                    	    	    if( played[runda] <= day )
                    	    	    	gamesPlayed = runda;
                    	    }
                    	    //console.log(">>> gp >> "+gamesPlayed+"< << ");
                    	    if( typeof superstar== 'undefined' )
                    	    	    return 250 * gamesPlayed + starting;
                    	    
                    	     if(   superstar== 0 ) 
                    	     	     return 250 * gamesPlayed + starting;
                    	     
                    	     return  (250 * gamesPlayed + starting)*1.25;
                    },
                    getToken: function()
                    { 
                    	    if(   token == "-1" )
                    	    	   this.initializeFromLocalStorage();
                    	   
                    	    return token;    
                    },
                    
                    getIdAccount: function()
                    {
                    	    if(   id_account == -1 )
                    	    	   this.initializeFromLocalStorage();
                    	    
                    	    return id_account;                       	    
                    },
                    
                    saveLocalStorage: function( data )
                    {
                    	saveLocalStorage( 'token'      , data.ret.token ); 
                    	saveLocalStorage( 'id_account' , data.ret.fields.id  ); 
                    	saveLocalStorage( 'username'   , data.ret.fields.username ); 
                    	saveLocalStorage( 'email'      , data.ret.fields.email ); 
                    	saveLocalStorage( 'season'     , data.timestamp.season ); 
                    	saveLocalStorage( 'day'        , data.timestamp.day ); 
                    	saveLocalStorage( 'days'       , data.timestamp.days ); 
                    },
                    
                    clearLocalStorage: function()
                    {
                    	    try{
				    localStorage.setItem( 'token'      , '' ); 
				    localStorage.setItem( 'id_account' , -1  ); 
				    localStorage.setItem( 'username'   , '' ); 
				    localStorage.setItem( 'email'      , '' );   
				    localStorage.clear(); 
                    	    }
                    	    catch(e){}
                    },
                    
                    initializeFromLocalStorage: function()
                    { 
                    	  
                    	try{
				token       	= localStorage.getItem('token');   
				AJAX.setToken( token );
			     
				id_account  	= localStorage.getItem('id_account');
				username	= localStorage.getItem('username');
				settings.season	= localStorage.getItem('season');
				settings.day	= localStorage.getItem('day');
				settings.days	= localStorage.getItem('days');
				 
                    	}
                    	catch(e){}	
                    },
                    
                    getPercentage: function( attempted,made )
                    {
                    	    return made * 100 / attempted;
                    },
                    
                    getHeader: function()
                    {
                    	var v 		 = [];
                    	v['f'] 		 = '';
                    	v['day'] 	 = settings.day;
                    	v['season'] 	 = settings.season;
                    	v['days']	 = settings.days;
                    	v['endf']	 = '';
                    	var header 	 = tr('day {day} / {days}',v);
                    	header 		+= ' '+tr('season {season}',v);  
                    	
                    	return header;
                    },
                    
                    getDay: function(){  
                    	return settings.day;    
                    },
                    
                    getSettings: function()
                    {   
                    },
                    
                    getLocationShort: function( location ){
                    	if( location == 1 )
                    		return tr('LG');
                    	
                    	if( location == 2 )
                    		return tr('INTL');
                    	
                    	if( location == 5 )
                    		return tr('WC');
                    	
                    	if( location == 9 )
                    		return tr('DEMO');
                    	
                    	if( location == 8 )
                    		return tr('PG'); 
                    },
                    
                     getLocationLong: function( location ){
                    	if( location == 1 )
                    		return tr('League Game');
                    	
                    	if( location == 2 )
                    		return tr('International Game');
                    	
                    	if( location == 5 )
                    		return tr('World Championship');
                    	
                    	if( location == 9 )
                    		return tr('Demo Game');
                    	
                    	if( location == 8 )
                    		return tr('Pickup Game'); 
                    	
                    	if( location == 10 )
                    		return tr('Allstar Game'); 
                    	
                    	if( location == 11 )
                    		return tr('Allstar Veteran Game'); 
                    },
                    
                    toUnixThenDiff: function( dateTime ){
                    	var timestamp = new Date(dateTime.replace(' ', 'T')).getTime();    
                    	return this.dateDiff( timestamp );
                    },
                    
                    dateDiff: function( timestamp )
                    {
                    	var unix = Math.round(+new Date()/1000);
                    	
                    	return parseInt(timestamp) - parseInt(unix);
                    },
                    
                    daysAgo: function( which )
                    { 
                    	if( typeof which == 'undefined' )
                    		return 99999;
                    	    
                    	if( which == null || which == '' )
                    		return 99999;
                    	    
                    	return this.dateDiff( which )/86400 * (-1); 
                    },
                    
                    today: function( )
                    {
                    	    return Math.round(+new Date()/1000);
                    },
                    
                    getDayOfTheWeek: function( timestamp )
                    {  
			var xx = new Date(timestamp*1000); 
			return this.parseDayOfTheWeek(xx.getDay());
                    },
                    
                    
                    
                    getDayMonth: function( timestamp )
                    {
                    	  var xx = new Date(timestamp*1000);
                    	  return xx.format( ' d M ' );
                    },
                    
                    getDayMonthYear: function( timestamp )
                    {
                    	  var xx = new Date(timestamp*1000);
                    	  return xx.format( ' d M Y' );
                    },
                    
                    getNiceDate: function( timestamp )
                    {
                    	    var daysDiff = this.dateDiff( timestamp )/86400;
                    	   
                    	    if( daysDiff < 0 )
                    	    	    daysDiff = daysDiff * (-1);
                    	    if(  daysDiff <= 7 )
                    	    	    return this.getDayOfTheWeek( timestamp );
                    	    		else if ( daysDiff >= 7 && daysDiff <= 150 )
                    	    			return this.getDayMonth( timestamp );
                    	    				else
                    	    					return this.getDayMonthYear( timestamp );
                    	    
                    },
                    
                    notSorted: function(obj)
                    {  
				if (!obj) {
				    return [];
				}
				return Object.keys(obj); 
                    },
                    
                    parseDayOfTheWeek: function( day )
                    {
                    	switch( day )
                    	{
                    		case 1: return tr('Monday'); break;
                    		case 2: return tr('Tuesday'); break;
                    		case 3: return tr('Wednesday'); break;
                    		case 4: return tr('Thursday'); break;
                    		case 5: return tr('Friday'); break;
                    		case 6: return tr('Saturday'); break;
                    		case 7: return tr('Sunday'); break;
                    	}
                    },
                    
                   
                    
                    getSeasonDay: function( format, season, day )
                    {
                    	var v = {};
                    	v['season'] = season;
                    	v['day']    = day;
                    	return tr( format, v );
                    },
                 
                    createBackButton: function( newStatus, scopePointer )
                    { 
                    	    var obj = this;
                    	    this.backButton  = function()
                    	    {
                    	    	    scopePointer.form.status = newStatus; 
                    	    	    obj.deleteBackButton();
                    	    } 
                    	 
                    },
                    
                    deleteBackButton: function( scopePointer )
                    {
                    	delete this.backButton;    
                    }, 
                    
                    getTime: function( timestamp )
                    {
                    	    var xx = new Date(timestamp*1000); 
                    	    return xx.format( ' H:i:s ')+'GMT'+xx.format('P');
                    	    //return ('0' + xx.getHours()).slice(-2)+':'+('0' +xx.getMinutes()).slice(-2)+':'+('0' +xx.getSeconds()).slice(-2) ;
                    }, 
                    
                    dateFormat: function( format, timestamp )
                    {
                    	    var xx = new Date(timestamp*1000); 
                    	    var string = xx.format( format );
                    	    if( format == 'l, F d' )
                    	    {
                    	    	var strings = string.split(", ");
                    	    	var str = strings[1].split(" ");
                    	    	return tr(strings[0])+", "+tr(str[0])+" "+str[1];
                    	    }
                    	    else
                    	    	    return string; 
                    },
                    
                    getPositionText: function()
                    {
                    	return { 'C':tr('Center')+' ('+tr('C')+')', 'PF':tr('Power Forward')+' ('+tr('PF')+')', 'SG':tr('Shooting Guard')+' ('+tr('SG')+')',  'PG':tr('Point Guard')+' ('+tr('PG')+')', 'SF':tr('Small Forward')+' ('+tr('SF')+')'};     
                    },
                    
                    getPositions: function()
                    {
						var pos = new Array('C','PF','PG','SG','SF');
						return pos; 
					},
                    
                    getSkillTranslation: function( skill )
                    { 
                    	    var skText =  {'shooting_inside':tr('Inside Shooting'),'shooting_fg':tr('Mid Range Shooting'),'shooting_3pt':tr('3PT Shooting'),'dribbling':tr('Dribbling'), 'speed':tr('Speed'),'strength':tr('Strength'),'confidence':tr('Confidence'),'stamina':tr('Stamina'),'blocking':tr('Blocking'),'rebounding':tr('Rebounding'),'stealing':tr('Stealing'),'jumping':tr('Jumping'),'passing':tr('Passing')};
                    	    if( typeof skill == 'undefined' )
                    	    	    return skText;
                    	    		else
                    	    			return skText[ skill ];
                    	    		
                    },
                    
                    setError: function( message, $scope )
                    { 
                    	    if( message == 'REST' )
                    	    	    message = tr("Error contacting server. Check internet connection.");
                    	    
                    	     error = { status: 1, message: message, type: 'Error' };
                    	     this.setResting( false );
                    	     
                    	     if( typeof $scope != 'undefined' )
                    	     {
				     var lookFor = '#ERR';
				     if( message.indexOf(lookFor) >= 0){
				     	     this.logout( $scope, message );
				     }
			     }
                    },
                    
                    setMessage: function( message, scope )
                    {
                    	    error = { status: 1, message: message, type: 'Info' };
                    },
                    
                    getMessageType: function()
                    {
                    	if( typeof error.message == 'undefined' )
                    		return '';
                    			else
                    				return error.type;    
                    },
                    
                    clearMessage: function()
                    { 
                    	error = {};	    
                    },
                    
                    getMessage: function( )
                    {
                    	   if( typeof error.status == 'undefined' )
                    	   	   return 0;
                    	   		else
                    	   			return error.status;
                    	   
                    	   return error.message; 
                    },
                    
                    getMessageText: function()
                    {
                    	if( typeof error.message == 'undefined' )
                    		return '';
                    			else
                    				return error.message;
                    },
                    
                    clearErrors: function()
                    {
                    	 error = {};
                    },
                    
                    isResting: function()
                    {
                    	return resting;    
                    },
                    
                    getResting: function(){ return this.isResting(); },
                    
                    setResting: function( to )
                    {
                    	resting = to;  
                    	if( to == true )
                    		this.clearErrors();
                    },
                    
                    getEquipmentSlots: function()
                    {
                    	return equipments;    
                    },
                    
                    form: function( which )
                    {
                    	   if( typeof form[which] == 'undefined' )
                    	   	   return 'nav-arrow-down';
                    	   
                    	   if( typeof form[which] != 'undefined' )
                    	   	   return form[which];
                    },
                    
                    getDisplayWidth: function()
                    {
                    	    return window.innerWidth;
                    },
                    
                    getDayDifference: function( season, day )
                    {
                    	   
                    	var daysLeft = 0;
                    	if( season != this.get('season') )
                    		daysLeft += parseInt( parseInt(season) - parseInt( this.get('season') ) ) * this.get('days');
                    		
                    	daysLeft += parseInt(this.get('day')) - parseInt(day);
                    	return daysLeft;
                    },
                    
                    setForm: function( which, to )
                    {  
                    	    if( to == 0 ){
                    	    	    form[which] = 'nav-arrow-down';
                    	    	    return 1;
                    	    }
                    	    
                    	    if( typeof to != 'undefined' )
                    	    	    if( to == 1 )
                    	    	    	return form[which] = 'nav-arrow-up';
                    	    			 
                    	    				
                    	    
                    	    if( typeof form[which] == 'undefined' ){
                    	    	    form[which] = 'nav-arrow-up';   
                    	    	    return 1;
                    	    }
                    	    
                    	    
                    	    
                    	    if( form[which] == 'nav-arrow-down' )
                    	    	    form[which] = 'nav-arrow-up'; 
                    	    		else
                    	    			form[which] = 'nav-arrow-down';
                    },
                    
                    viweableForm: function( which )
                    {
                    	if( typeof form[which] == 'undefined' )
                    		return 0;
                    		
                    	if( form[which] == 'nav-arrow-up' )
                    		return 1;
                    	
                    	return 0; 
                    },
                    
                    playerAvatar: function( avatar, id_player )
                    {
                    	if( typeof avatar == 'undefined' || avatar.length <=3 )
                    		return 'pics/noavatar.gif';
                    	else
                    		return 'http://cyberdunk2.com/images/avatars/'+avatar;
                    },
                    
                    percentage: function(from, to)
		    {  
		    	    if( to == 0 )
		    	    	    to = 1;
			return parseInt(1000 * from / to);
		    }, 
		    
		    getNumber: function(num) { 
		    	    var info = [];
		    	    for(var i=1;i<=num;i++)
		    	    	    info.push(i);
		    	    return info;
		    },
			    
                    getFlag: function( id_country )
                    {
                    	return 'background-image=url("pics/flags/'+id_country+'.gif")';    
                    },
                    
                    getngFlag: function( id_country )
                    {
                    	 return "{'background-image':'url(pics/flags/"+id_country+".gif)'}";      
                    },
                   
                    prepare: function( where, how, args  )
                    {   
                    	   var addFields = this.getHandshake(); 
                    	   for(var i in args)
				addFields = addFields + '&'+encodeURIComponent(i)+'='+encodeURIComponent(args[i]);
			
                    	   //var urllink = APILINK+''+where+'/'+how+'/'+addFields; 
                    	    
                    	   return {module:where,method:how,vars:addFields};
                    	   
                    },
                    
                    format: function( number, decimals, dec_point, thousands_sep) {
 

			  number = (number + '')
			    .replace(/[^0-9+\-Ee.]/g, '');
			  var n = !isFinite(+number) ? 0 : +number,
			    prec = !isFinite(+decimals) ? 0 : Math.abs(decimals),
			    sep = (typeof thousands_sep === 'undefined') ? ',' : thousands_sep,
			    dec = (typeof dec_point === 'undefined') ? '.' : dec_point,
			    s = '',
			    toFixedFix = function(n, prec) {
			      var k = Math.pow(10, prec);
			      return '' + (Math.round(n * k) / k)
				.toFixed(prec);
			    };
			  // Fix for IE parseFloat(0.55).toFixed(0) = 0;
			  s = (prec ? toFixedFix(n, prec) : '' + Math.round(n))
			    .split('.');
			  if (s[0].length > 3) {
			    s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
			  }
			  if ((s[1] || '')
			    .length < prec) {
			    s[1] = s[1] || '';
			    s[1] += new Array(prec - s[1].length + 1)
			      .join('0');
			  }
			  return s.join(dec); 
                    },
                    
                    
                    getQuarters: function( num )
                    { 
                    	    if( typeof num == 'undefined' )
                    	    	    num = 5;
                    	     
                    	    var arr = [];
                    	    var obj = {};
                    	    for( var i=1; i<= num; i++) 
                    	    {
                    	    	    obj = {};
                    	    	    obj.num = i;
                    	    	    arr.push(obj);
                    	    }
                    	    
                    	    return arr;
                    },
                    
                    parseInt: function( num )
                    { 
                    	return parseInt( num );    
                    },
                    
                    userAvatar: function( picture, id_account, linked )
                    {   
                    	if( typeof picture != 'undefined' )
                    		if( picture != null )
					if( picture.length > 1 )
					{
						if( typeof linked == 'undefined' )
							return picture;
								else
									return 'http://cyberdunk2.com/'+picture;
					}
                    	return 'pics/avatars/avatar'+parseInt(id_account%13)+'.png';
                    },
                    
                    teamAvatar: function( picture, size )
                    {
                    	if( typeof picture != 'undefined' )
                    		if( picture.length > 1 )
                    			return 'http://cyberdunk2.com/images/teams/'+picture;
                    		
                    	return 'pics/noteamlogo.png';	    
                    },
                    
                    getShotsShort: function()
                    {
                    	return ['3pt','inside','fg'];    
                    },
                    
                    getReleaseClause: function( which )
                    {
                    	var clauses = {};
                    	
                    	clauses['min/12'] = tr('12 min / game');
                    	clauses['min/24'] = tr('24 min / game');
                    	clauses['min/36'] = tr('36 min / game');
                    	clauses['play/1'] = tr('Every game');
                    	clauses['play/2'] = tr('Every 2 games');
              
                    	if( typeof clauses[ which ] != 'undefined' )
                    		return clauses[which];
                    			else
                    				return ' - ';
                    },
                    
                    getFooterClass: function( form, myRedirect )
                    { 
                    	    if( typeof form != 'undefined' )
                    	    	    if( typeof form.page != 'undefined' )
                    	    	    	if( form.page == myRedirect ) 
                    	    	    		return 'white'; 
                    	    return '';
                    },
                    
                    showHelp: function()
                    {
                    	return questionMarks;    
                    },
                   
                    
                    toggleHelp: function()
                    {
                    	    if( questionMarks )
                    	    	    questionMarks = 0;
                    	    		else
                    	    			questionMarks = 1;
                    	    		
                    	    var getWhat = { 'edit':{'tooltips':questionMarks}, id_account: this.get('id_account') };
                    	    var promise = AJAX.patch( 'ACCOUNTS', getWhat );
                    },
                    
                    setShowEntryTooltip: function( to )
                    {
                    	    if( to == 1 )
                    	    	    if( this.getShowEntryTooltip() == 0 ) 
                    	    	    {    
                    	    	    	showEntryTooltip = to;
                    	    	    	return 1;
                    	    	    }
                    	    showEntryTooltip = to;
                    	   	   
                    },
                    
                    getShowEntryTooltip: function()
                    {
                    	return showEntryTooltip;    
                    },
                  
                    getAddress: function( notification )
                    {
                    	 
                    	
                    	   // console.log("in getAddress "+( typeof notification.links )+" << ");
                    	    if( typeof notification == 'undefined' )
                			return '';
                		if( typeof notification.links != 'object' )
                			var links 	= tryParseJSON( notification.links );
                				else
                					var links = notification.links;
                		var address	= '';
                		//console.log(">>>>>>>>>>>"+links.mobileLink);
                		if( typeof links.mobileLink != 'undefined' )
                			return ""+(links.mobileLink)+"";
                		
                		if( typeof notification.mobileLink != 'undefined' )
                			return ""+(notification.mobileLink)+"";
                		
                		if( typeof notification.type == 'undefined' )
                			notification.type = 'default';
                		 
                		if( typeof links != 'undefined' )
					switch( notification.type )
					{
						case "referral_bonus": 
						case "login_bonus":
							return "/cyberpoints/"; 
						break;
						case "referral":
							return "/account/"+links.a.id+""; 	
						break;
						
						case "release":
						case "cash_bonus":
						case "promotion":
							return "/myPlayer/"+links.id+"";
						break;
						
						case "expiry":
							return "/manageTeam/"+links.id+"";
						break;
						
						case "offer_received":
						case "contract": 
							return "/contract/"+links.accept.id+"";
						break;
						 
						
						case "image_post":  
						case "new_post":	
							if( links.m == 'competition' )
								return "/competition/"+links.l+"/"+links.id+""; 
							
							if( links.m == 'country' )
								return "/country/"+links.id+"/"+links.v.country+"/"; 
							
							if( links.m == null )
								return "/user/"+links.id+""; 
							//if( links.m == 'openThread' )
							//else
							return "/thread/"+links.id+"";
						break;
						
						case "comment":
						case "like":
						case "mention":
							return "/thread/"+links.id+"/"+links.location+"/"+links.id_module+"/"+links.highlight+"";
						break;
						
						
						case "new_message":
						case "private_message":
							return "/conversation/"+links.id+"";
						break;
						
						case "cup": 
							return "/competition/"+links.l+"/"+links.id+"";
						default:
							/* 
							call_notification	[x]
							contract		[.]
							cup			[x]
							demo_game		[x]
							expiry			[x]
							image_post		[-]
							like			[-]
							login_bonus		[x]
							new_message		[o]
							new_post		[-]
							offer_received		[.]
							private_message		[o]
							promotion		[x]
							referral		[x]
							release			[x]
							wc_vote			[x]
							mention			[-]
							referral_bonus		[x]
							bug,edit,event		[API]
							translations_q		[API]
							po			[DELETED]
							comment			[-]
							cash_bonus		[x]
							*/ 
							
							if( typeof links != 'undefined' )
							{
								if( typeof links.m != 'undefined' )
									address = '/'+links.m+'';
								
								if( typeof links.id != 'undefined' )
									address += '/'+links.id+'/';
							}
							
							return ""+address+"";
							
						break;
						
					}
					
                		return "/home/";
                    	    
                    },
                	
                     timeSince: function(date, shrt) {
                     	     
			    var seconds = Math.floor(( (new Date().getTime()/1000) -  (date)))
			    
			    var interval = Math.floor(seconds / 31536000);
			
			  
			    
			    interval = Math.floor(seconds / 86400);
			    var v = {};
			    v.interval = interval;
			    if (interval > 1 && interval <= 6) {
			    	    
			    	if( typeof shrt !='undefined' )
			    		return tr('{interval}d',v);
			    	else
			    		return tr('{interval} days ago',v);
			    }
			    else if( interval >= 7 )
			    {
			    	     
			    	    var xx = new Date(date*1000);
			    	    if( typeof shrt !='undefined' ){
			    	    	return tr('{interval}d',v);	
			    	    }
			    	    else
			    	    {
							if( interval <= 180 )
									return xx.format( ' d M ' );
									else
										return xx.format( 'd M Y' );
						}
				}
			    
			    interval = Math.floor(seconds / 3600);
			    v.interval = interval;
			    if (interval > 1) {
			    	if( typeof shrt !='undefined' )
			    		return tr('{interval}h',v);
			    	else
			    		return tr('{interval} hours ago',v);
			    }
			    interval = Math.floor(seconds / 60);
			     v.interval = interval;
			    if (interval > 1  ) {
			    	if( typeof shrt !='undefined' )
			    		return tr('{interval}m',v);
			    	else
			    		return tr('{interval} minutes ago',v);
			    }
			    v.interval = seconds;
			    
			    if( typeof shrt !='undefined' )
			    	return tr('{interval}s',v);
			    else
			    	return tr('{interval} seconds ago',v);
			},
			
			
			lookFor: function( string )
			{ 
				//console.log(">>>"+string+"<<< ");
				if( typeof string == 'string' )
					if( string.length >= 1 )
						if( lastSearch != string )
						{
							//$scope
							var scopePointer = angular.element(document.getElementById("body")).scope();
							var obj = this;
							var req = {};
							req['string'] = string;
							req['notifications'] = 0;
							lastSearch = string;
							
							var promise 		= AJAX.get('SEARCH', req , 1 );
							scopePointer.API.setResting(true);
							
							 promise.success(function(data, status, headers, config) {
								obj.updateSearchView( data,scopePointer );
							 });
							 
							 if( promise.update )
								 promise.update(function(data, status, headers, config) {
									obj.updateSearchView( data,scopePointer );
								 }); 
							
							 promise.error(function(data, status, headers, config) {
								scopePointer.API.setResting(false); 
								scopePointer.API.setError( 'REST', scopePointer );
							 }); 
							 
						}
				
				
			},
			
			updateSearchView: function( data,scopePointer )
			{
				scopePointer.cachedSearch = data.cache;
				scopePointer.recentSearch = data.recentSearch
				if( !data.cache ) 
					scopePointer.API.setResting(false);  
				
				//console.log(">>>"+JSON.stringify( data )+"<<<< ");	
				scopePointer.popup.searchItems = [];
				var item = {};
				if( data.status == 'SUCCESS' )
				{
					for( var i in data.ret.result )
					{
						item = data.ret.result[i];
						scopePointer.popup.searchItems.push( item );
					}
					
				} 
			},
			
			getSearchIcon: function( icon )
			{
				return 'http://cyberdunk2.com/'+icon;	
			},
			
			addRecentSearch: function( item )
			{
				document.getElementById('searchBox').blur(); 
				if( getPlatform() == 'android' || getPlatform() == 'ios' )
				{
					//grr
					cordova.plugins.Keyboard.close();
				}
				
				/*window.KeyBoard.hideKeyBoard(); 
				alert(typeof window.KeyBoard.hideKeyBoard);*/
				var saveForEntry = { string: item.string, subtext: item.subtext, icon: item.icon, mobileLink: item.mobileLink };
			 
				var recentSearchesStorage = getLocalStorage('recentSearches');
				 
				var recentSearches   = [];
				if( recentSearchesStorage ) 
					recentSearches = tryParseJSON( recentSearchesStorage );	 
				
				
				
				for( var i in recentSearches )
				{
					if( recentSearches[ i ] != null )
						if( recentSearches[ i ].mobileLink == saveForEntry.mobileLink )
						{
							//console.log("splice i="+i+" >>> "+ ( JSON.stringify(recentSearches[i] ) )+" << ");
							recentSearches.splice( parseInt(i) , 1);
						}
				}		 
					
				var curLength = recentSearches.unshift( saveForEntry );
				
				
				//keep just last 10 searches
				if (curLength > 10) recentSearches = recentSearches.slice(0, 10);
				
				
				saveLocalStorage('recentSearches', JSON.stringify( recentSearches ) );
				
				 
				//console.log("RECENT SEARCHES ["+curLength+"] = "+JSON.stringify(recentSearches) );
				
			},
			
			boldify: function( v ){ 
				for( var what in v ){
					//console.log(" what = "+what+" >> "+v[what]+" << ");
					v[what] = '<B>'+v[what]+'</B>';
				} 
				return v; 
			},
			
			canLocalStorage: function()
			{ 
				try{
					if( typeof localStorage != 'undefined' )
						if( localStorage.setItem('test',1) )
							return 1;
					return 0;		
					
					
				}catch(e){ return 0; }
				
			},
			
			showRecentSearches: function()
			{
				var scopePointer = angular.element(document.getElementById("body")).scope();
							
				var recentSearchesStorage = getLocalStorage('recentSearches');
				var recentSearches   = [];
				if( recentSearchesStorage ) 
					recentSearches = tryParseJSON( recentSearchesStorage );	
				 
				scopePointer.recentSearch 	= 1;
				scopePointer.popup.searchItems  = recentSearches;
			}
                }

            }]);
}());



function tryParseJSON (jsonString){
    try {
        var o = JSON.parse(jsonString);

        // Handle non-exception-throwing cases:
        // Neither JSON.parse(false) or JSON.parse(1234) throw errors, hence the type-checking,
        // but... JSON.parse(null) returns 'null', and typeof null === "object", 
        // so we must check for that, too.
        if (o && typeof o === "object" && o !== null) {
            return o;
        }
    }
    catch (e) { }

    return false;
}; 

function getPlatform()
{
	 
     // return 'ios';
      if( typeof window.cordova != 'undefined' )	
      {   
             return window.cordova.platformId;
      }
      else
      { 
             if( typeof device != 'undefined' )
                   return (device.platform);
                    	 else
                    	    	return 'unknown'; 
      }
                    	    
}

function pushPossible()
{   
	if( getPlatform() == 'ios' || getPlatform() == 'android' )
		return 1;
	
	return 0;
}

function getDevice()
{
	if( typeof window.device )
		return window.device.model;
	
	return 'UNKNOWN';
}

//var GLOBALSENT = {};
function tr( text,vars ){ 
    	 
	 	/*
		if( typeof  GLOBALSENT[text] == 'undefined'  )
		{
				   var arr = [];
			   arr['text'] 		= text.replace('&','>>>||>>');
			   arr['programming'] 	= 'angular'; 
			   arr['module']	= '..';
			   arr['location']      =  document.location.href;
			  // console.log(">>>"+document.location.href);
			   arr['mobile']	= 1;
			   
			   var parsedArgs = '';
			    GLOBALSENT[text]='da';
		for( var i in arr )
			parsedArgs += '&'+i+'='+encodeURIComponent(arr[i]);
	
		 var urllink =  "http://localhost/cyberdunk2/API/TRANSLATIONS/PUT/?go=da&"+parsedArgs+"";
		  console.log(urllink);
		 var xmlhttp = new XMLHttpRequest();
		 xmlhttp.open("GET",urllink,true);
		 xmlhttp.send();  
		} 	
       		  // console.log("aici ["+text+"]  REDOING "); 	
       		  */
       		   
       		   if( typeof trln != 'undefined' )
       		   {  
       		   	   //console.log("aici ["+text+"] = "+trln[text]+" ?? ");
       		   	   if( typeof trln[text] != 'undefined' )
       		   	   	   if( trln[text] != null )
       		   	   	  	 text = trln[text];  
       		   }
       		   if( typeof vars != 'undefined' )
       		   	for( var k in vars )
       		   		text = text.replace('{'+k+'}', vars[k]);
       	return text;	 
} 

function html5PhoneyDatabase()
{}

function loadjscssfile(filename, filetype){
    if (filetype=="js"){ //if filename is a external JavaScript file
        var fileref=document.createElement('script')
        fileref.setAttribute("type","text/javascript")
        fileref.setAttribute("src", filename)
    }
    else if (filetype=="css"){ //if filename is an external CSS file
        var fileref=document.createElement("link")
        fileref.setAttribute("rel", "stylesheet")
        fileref.setAttribute("type", "text/css")
        fileref.setAttribute("href", filename)
    }
    if (typeof fileref!="undefined")
        document.getElementsByTagName("head")[0].appendChild(fileref)
}


/*
html5PhoneyDatabase.prototype.transaction = function(fn, error, success) {
    new html5PhoneyTransaction(this, fn, error, success, true, false);
};

function html5PhoneyTransaction(db, fn, error, success, txlock, readOnly) {
    if (typeof fn !== "function") {
 
      throw new Error("transaction expected a function");
    }
    this.db = db;
    this.fn = fn;
    this.error = error;
    this.success = success;
    this.txlock = txlock;
    this.readOnly = readOnly;
    this.executes = [];
    if (txlock) {
      this.executeSql("BEGIN", [], null, function(tx, err) {
        throw new Error("unable to begin transaction: " + err.message);
      });
    }
};
  
html5PhoneyTransaction.prototype.executeSql = function(sql, values, success, error) {
    return 0;
};*/
function setLocalStorage( url, stringification ){
	saveLocalStorage( url, stringification );	
}
function saveLocalStorage(url, stringification) {
    //console.log("[saveLocalStorage] >>>>>>>>>>>>>>>>>>TRYING TO SAVE "+url+" <<< "); 
    try{
	    if (typeof localStorage != 'undefined') {
		try {
		    localStorage.setItem(url, stringification);
		} catch (error) {
		    for (var j in localStorage) {
			if (j != 'token' && j != 'username' && j != 'id_account' && j != 'language' && j != 'myPlayers' && j != 'myTeams' && j != 'season')
			    localStorage.removeItem(j);
		    }
	
		    localStorage.setItem(url, stringification);
		}
	    } 
    }
    catch(e){ return null; }
}

function getLocalStorage( url )
{
	try{
		return localStorage.getItem( what );
	}catch(e){
		return null;
	}
}
 
Object.size = function(obj) {
    var size = 0, key;
    for (key in obj) {
        if (obj.hasOwnProperty(key)) size++;
    }
    return size;
};

function getAndroidVersion(ua) {
    ua = (ua || navigator.userAgent).toLowerCase(); 
    var match = ua.match(/android\s([0-9\.]*)/);
    return match ? match[1] : false;
};

function scrollIntoView(eleID) {
   var e = document.getElementById(eleID);
   if (!!e && e.scrollIntoView) {
       e.scrollIntoView();
   }
}
 
// Date Format Method
// copyright Stephen Chapman, 20th November 2007, 19 January 2011
// http://javascript.about.com
// permission to use this JavaScript on your web page is granted
// provided that all of the code below in this script (including these
// comments) is used without any alteration
 
String.prototype.ucwords = function() {
    var str = this.toLowerCase();
    return str.replace(/(^([a-zA-Z\p{M}]))|([ -][a-zA-Z\p{M}])/g,
        function($1){
            return $1.toUpperCase();
        });
}
Date.prototype.getMDay = function() {return (this.getDay() + 6) %7;};Date.prototype.getISOYear = function() {var thu = new Date(this.getFullYear(),this.getMonth(),this.getDate()+3-this.getMDay());return thu.getFullYear();};Date.prototype.getISOWeek = function() {var onejan = new Date(this.getISOYear(),0,1);var wk = Math.ceil((((this - onejan) / 86400000) + onejan.getMDay()+1)/7);if (onejan.getMDay() > 3) wk--;return wk;};Date.prototype.getJulian = function() {return Math.floor((this / 86400000) - (this.getTimezoneOffset()/1440) + 2440587.5);};Date.prototype.getMonthName = function() {var m = ['January','February','March','April','May','June','July','August','September','October','November','December'];return m[this.getMonth()];};Date.prototype.getMonthShort = function() {var m = ['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'];return m[this.getMonth()];};Date.prototype.getDayName = function() {var d = ['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday'];return d[this.getDay()];};Date.prototype.getDayShort = function() {var d = ['Sun','Mon','Tue','Wed','Thu','Fri','Sat'];return d[this.getDay()];};Date.prototype.getOrdinal = function() {var d = this.getDate();switch(d) {case 1: case 21: case 31: return 'st'; case 2: case 22: return 'nd'; case 3: case 23: return 'rd'; default: return 'th';}};Date.prototype.getDOY = function() {var onejan = new Date(this.getFullYear(),0,1); if (onejan.getDST()) onejan.addHours(1); if (this.getDST()) onejan.addHours(-1); return Math.ceil((this - onejan + 1) / 86400000);}; Date.prototype.getWeek = function() {var onejan = new Date(this.getFullYear(),0,1); return Math.ceil((((this - onejan) / 86400000) + onejan.getDay()+1)/7);};Date.prototype.getStdTimezoneOffset = function() {var jan = new Date(this.getFullYear(), 0, 1); var jul = new Date(this.getFullYear(), 6, 1); return Math.max(jan.getTimezoneOffset(), jul.getTimezoneOffset());}; Date.prototype.getDST = function() {return this.getTimezoneOffset() < this.getStdTimezoneOffset();};Date.prototype.getSwatch = function() {var swatch = ((this.getUTCHours() + 1)%24) + this.getUTCMinutes()/60 +  this.getUTCSeconds()/3600; return Math.floor(swatch*1000/24);};function _daysInMonth(month,year) {var dd = new Date(year, month, 0);return dd.getDate();};Date.prototype.format = function(f) {var fmt = f.split(''); var res = ''; for (var i = 0, l = fmt.length; i < l; i++) {switch(fmt[i]) {case '^':  res += fmt[++i]; break;  case 'd': var d = this.getDate();  res += ((d<10)?'0':'')+d;  break; case 'D': res += this.getDayShort(); break; case 'j': res += this.getDate(); break; case 'l': res += this.getDayName(); break; case 'S': res += this.getOrdinal(); break; case 'w': res += this.getDay(); break; case 'z': res += this.getDOY() - 1; break;  case 'R': var dy = this.getDOY(); if (dy<9) dy = '0'+dy; res += (dy > 99)? dy : '0'+dy; break; case 'F': res += this.getMonthName(); break; case 'm': var m = this.getMonth()+1; res += ((m<10)?'0':'')+m;  break; case 'M': res += this.getMonthShort(); break; case 'n': res += (this.getMonth()+1); break; case 't': res += _daysInMonth(this.getMonth()+1, this.getFullYear()); break; case 'L': res += (_daysInMonth(2, this.getFullYear()) == 29)? 1:0; break; case 'Y': res += this.getFullYear(); break; case 'y': var y = this.getFullYear().toString().substr(3); res += ((y<10)?'0':'')+y; break; case 'a': res += (this.getHours()>11)?'pm':'am'; break; case 'A': res += (this.getHours()>11)?'PM':'AM'; break; case 'g': var h = this.getHours()%12; res += (h==0)?12:h; break; case 'G': res += this.getHours(); break; case 'h': var h = this.getHours()%12; res += (h==0)?12:(h>9)?h:'0'+h; break; case 'H': var h = this.getHours(); res += (h>9)?h:'0'+h; break; case 'i': var m = this.getMinutes(); res += (m>9)?m:'0'+m; break; case 's': var s = this.getSeconds(); res += (s>9)?s:'0'+s; break; case 'O': var m = this.getTimezoneOffset(); var s = (m<0)?'+':'-'; m = Math.abs(m); var h = Math.floor(m/60); m = m%60; res += s + ((h>9)?h:'0'+h) + ((m>9)?m:'0'+m); break; case 'P': var m = this.getTimezoneOffset(); var s = (m<0)?'+':'-'; m = Math.abs(m); var h = Math.floor(m/60); m = m%60; res += s + ((h>9)?h:'0'+h) + ':' + ((m>9)?m:'0'+m); break; case 'U': res += Math.floor(this.getTime()/1000); break; case 'I': res += this.getDST() ? 1:0; break; case 'K': res += this.getDST() ? 'DST':'Std'; break; case 'c': res += this.format('Y-m-d^TH:i:sP'); break; case 'r': res += this.format('D, j M Y H:i:s P'); break; case 'Z': var tz = this.getTimezoneOffset() * -60; res += tz; break; case 'W': res += this.getISOWeek(); break; case 'X': res += this.getWeek(); break;  case 'x': var w = this.getWeek();res += ((w<10)?'0':'')+w; break;  case 'B': res += this.getSwatch(); break;  case 'N':  var d = this.getDay(); res += d?d:7; break; case 'u': res += this.getMilliseconds()*1000; break; case 'o':  res += this.getISOYear(); break; case 'J': res += this.getJulian(); break; case 'e': case 'T': break;  default: res += fmt[i];}}return res;}
