'use strict';

(function () {
  
    var scopePointer;
    var fields		= { myPlayer: 'fields,skills,fixtures=2,results=3,contract,salary,expiration,training,equipment,career,club,goals=fields' };
    var id      	= 0;
    var cache;
    var how;
    var cacheTactics 	= {};
    var training	= { 'intensity':'', 'skill':'' };
    var tacticsType 	= 'club';
    var lastCopyTheseClick = 'random';
    
 
		
    angular.module('myApp.player', ['myApp.AJAX','myApp.me' ])
        .service('player', [ 'AJAX','me' ,
            function ( AJAX,me  ) { 
                return { 
                	
                    clear: function()
                    {
                    	id = 0;
                    	cache = {};
                    	cacheTactics = {};
                    },
                    
                    updateGoalsView: function( data )
                    {
                    	//succesful get event. 
			scopePointer.cachedCopy = data.cache;
                	if( !data.cache ) 
                	{
               			scopePointer.API.setResting(false);
               			scopePointer.API.checkNotifications( data, scopePointer );
			}
			
               		if( data.status == 'SUCCESS' )
			{  
				scopePointer.data.goals    	= data.ret.goals;   
			}
			else
				scopePointer.API.setError( data.ret.message, scopePointer );
							
                    	    
                    },
                    
                    updateTrainingView: function( data )
                    {
                    	//succesful get event. 
                    	var obj = this;
                    	scopePointer.cachedCopy = data.cache;
                	if( !data.cache ){ 
                		scopePointer.API.setResting( false );
                		scopePointer.API.checkNotifications( data, scopePointer );
			}
			
                	if( data.status == 'SUCCESS' )
			{  
				scopePointer.data.training    	= data.ret.training; 
				scopePointer.skills		= data.ret.skills; 
								
				obj.setTraining( data.ret.training.fields.intensity, 'intensity' );
				obj.setTraining( data.ret.training.fields.skill, 'skill' );
				scopePointer.data.teammates    	= data.ret.teammates;
				scopePointer.data.title		= tr('Training');
								  
			}
			else
				scopePointer.API.setError( data.ret.message, scopePointer );
						    
                    },
                   
                    get: function( which, pid, $scope, FLAG, extra )
                    {  
                    	    
                    	    id 				= pid;
                    	    how 			= which; 
                    	    var obj			= this;
                    	    scopePointer 		= $scope; 
                    	    var requestFields 		= this.getRequestFields( which );
                    	    switch( which )
                    	    {
                    	    	    	case "goals":
                     	    	    		this.getMyPlayers();
                    	    	    		var getWhat = {get:'goals=fields-possible-completed', id_player: pid };
                    	    	    		var promise = AJAX.get( 'PLAYER', getWhat,1 );
                    	    	    		var obj     = this;
                    	    	    		    scopePointer.API.setResting( true );
						    scopePointer.API.clearErrors();
						    promise.success(function(data, status, headers, config) {
							obj.updateGoalsView( data );
						    });
						    
						    if( promise.update )
							    promise.update(function(data, status, headers, config) {
								obj.updateGoalsView( data );
							    });
						    
						    promise.error(function(data, status, headers, config) {
						    	   scopePointer.API.setResting( false );
							   scopePointer.API.setError( 'REST', scopePointer );
						    });                    	    	    		
                    	    	    		
                    	    	    	break;
                    	    	    
                    	    	    	case "training":
                    	    	    		this.createSkilList();
                    	    	    		this.getMyPlayers();
                    	    	    		var getWhat = {get:'skills,training=fields-teammates-benefits', id_player: pid };
                    	    	    		var promise = AJAX.get( 'PLAYER', getWhat,1 );
                    	    	    		
                    	    	    		    scopePointer.API.setResting( true );
						    scopePointer.API.clearErrors();
						    var obj = this;
						    promise.success(function(data, status, headers, config) {
							    obj.updateTrainingView( data );
						    });
						    if( promise.update )
							    promise.update(function(data, status, headers, config) {
								    obj.updateTrainingView( data );
							    });
						
						    promise.error(function(data, status, headers, config) {
								scopePointer.API.setResting( false );
								scopePointer.API.setError( 'REST', scopePointer );
						    });                 	    	    		
                    	    	    	break;
                    	    	    	case "draft": 
                    	    	    		
                    	    	    		var getWhat = {get:'fields,draft', id_player: pid };
                    	    	    		var promise = AJAX.get( 'PLAYER', getWhat,1 );
                    	    	    	 
                    	    	    		    scopePointer.API.setResting( true );
						    scopePointer.API.clearErrors();
						    var obj = this;
						    promise.success(function(data, status, headers, config) {
							    scopePointer.API.setResting(false);
						    	    scopePointer.data = data.ret;
						    	    scopePointer.text	= {'league_draft':tr('LEAGUE NAME & SIMTIME'),'pos':tr('DRAFTING SPOTS @ {pos}',scopePointer.data.fields)};
						    	    scopePointer.data.title = tr('Choose League');
							    scopePointer.draft.parseLeagues( data.ret.draft );
							 
						    });
						    if( promise.update )
							    promise.update(function(data, status, headers, config) {
								    scopePointer.data = data.ret;
								    scopePointer.data.title = tr('Choose League');
								    scopePointer.text	= {'league_draft':tr('LEAGUE NAME & SIMTIME'),'pos':tr('DRAFTING SPOTS @ {pos}',scopePointer.data.fields)};
					
								    scopePointer.draft.parseLeagues( data.ret.draft );
								    scopePointer.API.setResting(false);
								    scopePointer.API.checkNotifications( data, scopePointer);
							    
							    });
						
						    promise.error(function(data, status, headers, config) {
								scopePointer.API.setResting( false );
								scopePointer.API.setError( 'REST', scopePointer );
						    }); 
                    	    	    		                    	    	    		
                    	    	    	break;
                    	    	    
                    	    	    
                    	    	    	case "demo": 
                    	    	    		this.getMyPlayers();
                    	    	    		var getWhat = {get:'demos', id_player: pid };
                    	    	    		var promise = AJAX.get( 'PLAYER', getWhat );
                    	    	    		
                    	    	    		    scopePointer.API.setResting( true );
						    scopePointer.API.clearErrors();
						    promise.success(function(data, status, headers, config) {
							//succesful get event. 
							scopePointer.API.setResting( false );
							scopePointer.API.checkNotifications( data, scopePointer );
							if( data.status == 'SUCCESS' )
							{  
								
								scopePointer.data.demos    	= data.ret.demos; 
								scopePointer.data.title		= tr('Simulate Demo');
								  
							}
							else
								scopePointer.API.setError( data.ret.message, scopePointer );
						    });
						
						     promise.error(function(data, status, headers, config) {
								scopePointer.API.setResting( false );
								scopePointer.API.setError( 'REST', scopePointer );
						     });  
                    	    	    	break;
                    	    	    	
                    	    		case "demos":
                    	    			var getWhat = {get:'fields,skillpoints,demosCount', id_account: me.get('id_account') };
                    	    	    		var promise = AJAX.get( 'PLAYER', getWhat );
                    	    	    		
                    	    	    		    scopePointer.API.setResting( true );
						    scopePointer.API.clearErrors();
						  
						    promise.success(function(data, status, headers, config) {
							//succesful get event. 
							scopePointer.API.setResting( false );
							scopePointer.API.checkNotifications( data, scopePointer );
							if( data.status == 'SUCCESS' )
							{  
								var pList = [];
								delete data.ret.id_player;
								if( typeof data.ret.fields != 'undefined' )
									pList.push(data.ret);
								else
									pList = data.ret;
								scopePointer.data.demos    	= pList;//data.ret; 								
								scopePointer.data.title		= tr('Simulate Demo');
								  
							}
							else
								scopePointer.API.setError( data.ret.message, scopePointer );
						    });
						
						     promise.error(function(data, status, headers, config) {
								scopePointer.API.setResting( false );
								scopePointer.API.setError( 'REST', scopePointer );
						     });  
                    	    		break;
                    	    		
                    	    		case "skillpointsReceived":
                    	    			var getWhat = {'get':'fields,skillpoints,gameSkillpoints', 'id_players': extra['id_players'].split(','), 'id_game': extra['id_game']  };
                    	    	    		var promise = AJAX.get( 'PLAYER', getWhat );
                    	    	    		
                    	    	    		    scopePointer.API.setResting( true );
						    scopePointer.API.clearErrors();
						    promise.success(function(data, status, headers, config) {
							//succesful get event. 
							scopePointer.API.setResting( false );
							scopePointer.API.checkNotifications( data, scopePointer );
							if( data.status == 'SUCCESS' )
							{  
								var pList = [];
								delete data.ret.id_player;
								if( typeof data.ret.fields != 'undefined' )
									pList.push(data.ret);
								else
									pList = data.ret;
								scopePointer.data.demos    	= pList; 								
								scopePointer.data.title		= tr('Simulate Demo');
								  
							}
							else
								scopePointer.API.setError( data.ret.message, scopePointer );
						    });
						
						     promise.error(function(data, status, headers, config) {
								scopePointer.API.setResting( false );
								scopePointer.API.setError( 'REST', scopePointer );
						     });  
                    	    		break;
                    	    	    	//player profile
                    	    		case "playerProfile":
                    	    	    	case "profile":  
                    	    	    	//my crib
                    	    		case "mine": 
                    	    		default:
                    	    			  
                    	    			
                    	    			scopePointer.loaded	= false;
                    	    			var obj			= this;
                    	    			
                    	    			//get promise from DB 
                    	    			//when promise gets fullfiled, hits .then()
                    	    			 
                    	    			me.get('player', pid ).then(function( result ) {
                    	    				
                    	    				scopePointer.dbLoading 	= false;  
                    	    				if( typeof result[0] != 'undefined' )
                    	    					scopePointer.loaded	= true;
                    	    				  
                    	    				for( var j in result[0] )
                    	    					scopePointer.data[j] = result[0][j];
                    	    				 
                    	    				//scopePointer.data 	= result[0];  
                    	    				//draft bug :(
                    	    				cache  			= result[0]; 
                    	    				//console.log( JSON.stringify( scopePointer.data.fixtures ) );
                    	    				
                    	    				
                    	    				if( typeof FLAG != 'undefined' )
                    	    					if( FLAG == 'REST' )
                    	    						return obj.restUpdate( requestFields, 'flag' );  
                    	    				
                    	    				if( typeof result[0] == 'undefined' )
                    	    					return obj.restUpdate( requestFields, 'undefined sql' );  
                    	    				
                    	    				 
                    	    				if( typeof result[0].club == 'undefined' && result[0].fields.id_club != 0 )  
                    	    					return obj.restUpdate( requestFields, 'UNDEFINED CLUB IN SQL' );  
                    	    					
                    	    				scopePointer.data.title = result[0].fields.first_name + ' ' + result[0].fields.last_name;
                    	    				 
                    	    				//if( typeof scopePointer.data.equipment.worn == 'undefined' )
                    	    				//	scopePointer.data.equipment.worn = 0;
                    	    				for( var i in result[0].equipment )
                    	    					if( result[0].equipment[i].stat == 1 )
                    	    						scopePointer.data.equipment.worn++;
                    	    				
                    	    				var rest = 1;
                    	    				if( typeof result[0].timestamp != 'undefined' )
                    	    				{  
								//do we need to update ? was the data gathered yesterday ? (things have changed since then)
								//console.log("aici?" +  typeof FLAG);
								if( typeof FLAG != 'undefined' ) 
									if( FLAG != 'noREST' )
									{
										rest = 0;	
									}
								 
								if( rest == 1 )
								{
									if( result[0].timestamp.day != me.getDay() )
										return obj.restUpdate( requestFields, 'data gathered in a previous day' );
										
									 
									//if no games saved for this player update the database now from REST ?
									if( typeof result[0].fixtures == 'undefined' )
										return obj.restUpdate( requestFields , 'unknown fixtures' );
								}	
								//if the games we have on file where gathered yesterday, upate
								//if( result.fixtures.timestamp.day != me.day )
								//	obj.restUpdate( 'games' );
								
								//for example: if there was a game at 14:30, and the data was loaded at 13:30
								//and now it is 15:30, update from REST.
								//if( result.fixtures.timestamp.day == me.day && result.games.timestamp.time >= result.nextgame.time )
								//	obj.restUpdate( 'games' );
                    	    				}
                    	    				else
                    	    				{  
                    	    					return obj.restUpdate( requestFields, 'undefined timestamp' );  
                    	    				}
                    	    			
                    	    			});  
                    	    			obj.restUpdate( requestFields, 'undefined timestamp' );  
                    	    		break; 
                    	    }
                    },
                    
                    restUpdate: function( getWhat, from )
                    {   
                    	    var promise = AJAX.get('PLAYER', {get:getWhat,id_player:id},1 ); 
                    	    scopePointer.API.setResting( true );
                    	    scopePointer.API.clearErrors();
                    	    var obj	= this;
                    	    promise.success(function(data, status, headers, config) {
                		obj.updateView( data );
			    });
			    
			    if( promise.update )
				    promise.update(function(data, status, headers, config) {
					obj.updateView( data );
				    });
			
			     promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting( false );
					scopePointer.API.setError( 'REST', scopePointer );
			     }); 
                    },
                    
                    updateView: function( data )
                    {
                    	    	 
                    		//succesful get event. 
                		scopePointer.cachedCopy = data.cache;
                		if( !data.cache )
                			scopePointer.API.setResting(false);
                		scopePointer.API.checkNotifications( data, scopePointer );
                		if( data.status == 'SUCCESS' )
                    	    	{ 
					me.synch( 'player', data.ret, cache, data.timestamp );
					
					scopePointer.loaded		= true; 
					//scopePointer.data    		= data.ret; 
					if( typeof scopePointer.data != 'undefined' )
						if( typeof scopePointer.data.leagues != 'undefined' )
							var leagues = scopePointer.data.leagues;
					
                    	    		scopePointer.data =  data.ret;
                    	    		
                    	    		if( typeof leagues != 'undefined' )
                    	    			scopePointer.data.leagues = leagues;
                    	    		
					scopePointer.restLoading 	= false;
					scopePointer.data.title 	= data.ret.fields.first_name + ' ' + data.ret.fields.last_name;
					//scopePointer.data.equipment.worn = 0;
					
					for( var i in data.ret.equipment ) 	
						if( data.ret.equipment[i].stat == 1 ) 
                    	    				scopePointer.data.equipment.worn++; 
                    	    			
                    	    			
                    	    		if( typeof data.ret.career != 'undefined' )
                    	    			if( typeof data.ret.career.id_career != 'undefined' )
                    	    			{  
                    	    				if( typeof scopePointer.lifeSettings != 'undefined' ){
                    	    					scopePointer.lifeSettings.numLeft = scopePointer.API.getMaxCareers() + 1 - parseInt(data.ret.career.id_career);
                    	    				}
                    	    			}
                    	    			
                    	    		if( scopePointer.tutorial.getStep() == 'statGoals' )
                    	    		{
                    	    			//scroll to bottom in order to highlight the set goals tooltip
                    	    			window.scrollTo(0,500);	
                    	    		}
                    	    		 
				}
				else
					scopePointer.API.setError( data.ret.message, scopePointer );	    
                    },
                    
                    getRequestFields: function( which )
                    {
                    	switch( which )
                    	{
                    		case "playerProfile":
                    			return 'fields,profile,awards,club,history,statsHistory,ratings,career,results=3';
                    		break;
                    		case "mine":
                    			return fields.myPlayer;
                    		break;
                    		case "skillpoints":
                    			return 'fields,skills,boosts';
                    		break;
                    	}
                    },
                    
                    retirePlayer: function( )
                    {
                    	    var promise = AJAX.get('RETIREMENT', {id_player:id},1 ); 
                    	    scopePointer.API.setResting( true );
                    	    scopePointer.API.clearErrors();
                    	    var obj	= this;
                    	    promise.success(function(data, status, headers, config) {
                    	    	scopePointer.API.setResting( false );
                    	    	if( data.status == 'SUCCESS' )
                    	    		scopePointer.API.setMessage( data.ret.message );
                    	    	else
                    	    		scopePointer.API.setError( data.ret.message, scopePointer );
                		
			    });
			     
			     promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting( false );
					scopePointer.API.setError( 'REST', scopePointer );
			     });
                    },
                    
                    getTacticName: function( which, value )
                    {
                    	    switch( which )
                    	    {
                    	    	case "play_intensity":
                    	    		switch( value )
                    	    		{
                    	    			case 0: return tr('Hard'); break;
                    	    			case 1: return tr('Normal'); break;
                    	    			case 2: return tr('Relaxed'); break;
                    	    		}
                    	    	break;
                    	    	
                    	    	case "play_style":
                    	    		switch( value )
                    	    		{
                    	    			case 0: return tr('Ballhog'); break;
                    	    			case 1: return tr('Normal'); break;
                    	    			case 2: return tr('Pass'); break;
                    	    		}
                    	    	break;
                    	    	
                    	    	case "off_the_ball_d":
                    	    		switch( value )
                    	    		{
                    	    			case 0: return tr('Tight / Steal'); break;
                    	    			case 1: return tr('Loose / Block'); break; 
                    	    		}
                    	    	break;
                    	    	
                    	    	case "defensive_bonus":
                    	    		switch( value )
                    	    		{
                    	    			case 0: return tr('Inside'); break;
                    	    			case 1: return tr('Perimeter'); break; 
                    	    			case 2: return tr('Arc Pressure'); break; 
                    	    		}
                    	    	break;
                    	    }
                    	
                    },
                    
                    createDropDowns: function()
                    { 
                    	    scopePointer.form.options.play_intensity = [];
                    	    scopePointer.form.options.play_intensity.push( {value:0,name:this.getTacticName('play_intensity',0) }  );
                    	    scopePointer.form.options.play_intensity.push( {value:1,name:this.getTacticName('play_intensity',1) }  );
                    	    scopePointer.form.options.play_intensity.push( {value:2,name:this.getTacticName('play_intensity',2) }  );
                    	    scopePointer.form.model.play_intensity = scopePointer.form.options.play_intensity[1];
                    	    
                    	    scopePointer.form.options.play_style     = [];
                    	    scopePointer.form.options.play_style.push( {value:0,name:this.getTacticName('play_style',0)}  );
                    	    scopePointer.form.options.play_style.push( {value:1,name:this.getTacticName('play_style',1)}  );
                    	    scopePointer.form.options.play_style.push( {value:2,name:this.getTacticName('play_style',2)}  );
                    	    scopePointer.form.model.play_style = scopePointer.form.options.play_style[1]; 
                    	    
                    	    scopePointer.form.options.off_the_ball_d  = [];
                      	    scopePointer.form.options.off_the_ball_d.push( {value:0,name:this.getTacticName('off_the_ball_d',0)}  );
                    	    scopePointer.form.options.off_the_ball_d.push( {value:1,name:this.getTacticName('off_the_ball_d',1)}  );                  	    
                    	    scopePointer.form.model.off_the_ball_d = scopePointer.form.options.off_the_ball_d[0];
                    	    
                    	    scopePointer.form.options.defensive_bonus  = [];
                    	    scopePointer.form.options.defensive_bonus.push( {value:0,name:this.getTacticName('defensive_bonus',0)}  );
                    	    scopePointer.form.options.defensive_bonus.push( {value:1,name:this.getTacticName('defensive_bonus',1)}  );                  	    
                    	    scopePointer.form.options.defensive_bonus.push( {value:2,name:this.getTacticName('defensive_bonus',2)}  );
                    	    scopePointer.form.model.defensive_bonus = scopePointer.form.options.defensive_bonus[1];
                    	    
                    	    var positions = me.getPositionText();
                    	    for( var pos in positions )
                    	    { 
                    	    	 //if( typeof  scopePointer.form.options.passing_preferences[pos] == 'undefined' )
                    	    	 	 scopePointer.form.options.passing_preferences[pos] = [];
                    	    	 for(var i=10;i<=60;i=i+5)
                    	    	 	 scopePointer.form.options.passing_preferences[pos].push( {value: parseInt(i), name: i+'%' } );
                    	    	 
                    	    	 //if( typeof  scopePointer.form.model.passing_preferences[pos] == 'undefined' )
                    	    	 	 scopePointer.form.model.passing_preferences[pos] =  scopePointer.form.options.passing_preferences[pos][2];
                    	    }
                    	    
                    	    var shots = me.getShotsShort();
                    	    var shot;
                    	    for( var num in shots )
                    	    {
                    	    	 shot = shots[num];
                    	    	 //if( typeof  scopePointer.form.options.shooting_parameters[shot] == 'undefined' )
                    	    	 	 scopePointer.form.options.shooting_parameters[shot] = [];
                    	    	 
                    	    	 for(var i=5;i<=90;i=i+5)
                    	    	 	 scopePointer.form.options.shooting_parameters[shot].push( {value: parseInt(i), name: i+'%' } );
                    	    	 
				if( shot != '3pt' )	var defaultItem = 7;	else var defaultItem = 3;
                    	    	 
                    	    	 //if( typeof  scopePointer.form.model.passing_preferences[shot] == 'undefined' )
                    	    	 	 scopePointer.form.model.shooting_parameters[shot] =  scopePointer.form.options.shooting_parameters[shot][defaultItem];
                    	    }     
                    },
                    
                    setQuickset: function(which, value)
                    { 
                    	    var to = 0;
                    	    if( which == 'passing_preferences' )
                    	    { 
                    	    	for( var pos in me.getPositionText() )	
                    	    	{ 
                    	    		if( pos == value ) to = 60; else to = 10;
                    	    		this.setDropdownItem( which, pos, to );
                    	    	}
                    	    }else
                    	    {
                    	    	 var shots =    me.getShotsShort();
                    	    	for( var shot in shots )	
                    	    	{
                    	    		if( shots[shot] == value ) to = 90; else to = 5;
                    	    		 
                    	    		this.setDropdownItem( which, shots[shot], to );
                    	    	}
                    	    }
                    },
                    
                    setDropdownItem: function( which, subwhich, to )
                    {   
                    	   if( typeof subwhich != 'undefined' && subwhich!= null )
                    	   {
                    	   	   for( var i in scopePointer.form.options[which][subwhich] )
                    	   	   {
                    	   	   	   if( scopePointer.form.options[which][subwhich][i].value == to )
                    	   	   	   	scopePointer.form.model[which][subwhich] = scopePointer.form.options[which][subwhich][i];
                    	   	   }	   	
                    	   }
                    	   else
                    	   {
                    	   	     for( var i in scopePointer.form.options[which] )
                    	   	     {
                    	   	     	  if( scopePointer.form.options[which][i].value == to )
                    	   	   	   	scopePointer.form.model[which] = scopePointer.form.options[which][i];
                    	   	     }
          
                    	   }    
                    },
                    
                    transformShotShort: function(shot)
                    {
                    	if( shot == '3pt' ) return tr('3PT');
                    	if( shot == 'inside') return tr('INSIDE');
                    	if( shot == 'fg') return tr('MID RANGE');
                    },
                    
                    changePlayerInTactics: function()
                    {
                    	  id = scopePointer.form.model.player.value;   
                    	   
                    	  this.setTacticsType(  'club'  );
                    	  
                    	  if(   cacheTactics[ id ] != null )  
                    	  	  this.updateDropdowns( cacheTactics[ id ] ); 
                    	  if( cacheTactics[ id ]  == null )
                    	  	  this.createDropDowns();
                    },
                    setScope: function( $scope )
                    {
                    	    
                    	   scopePointer = $scope;
                    },
                    
                    setTacticsType: function( to )
                    {
                    	  for( var j in scopePointer.form.options.tacticsType )
                    	  	  if( scopePointer.form.options.tacticsType[j].value == to )
                    	  	  	scopePointer.form.model.tacticsType = scopePointer.form.options.tacticsType[j];
                    	    	    
                    	tacticsType = to;    
                    },
                    
                    changeTacticsType: function()
                    {
                    	    this.setTacticsType(  scopePointer.form.model.tacticsType.value );
                    	    this.getTactics( id, scopePointer );
                    },
                    
                    getTactics: function( pid, $scope )
                    {
                    	   
                    	scopePointer 		= $scope;
                    	id 			= pid;
                    	
                    	var obj = this;
                    	this.createDropDowns();
                    	
                    	
                    	me.get('playerTactics', me.get('id_account'), 'id_account' ).then(function( result ) {
                    		 
                    		for( var pl in result )
                    		{ 
					if( id == result[pl].fields.id )
					{  
						obj.updateDropdowns( result[pl].tactics ); 
						scopePointer.data.title = tr("Tactics",data.ret[pl].fields);
					}
							
					cacheTactics[ result[pl].fields.id ] = result[pl].tactics;	
				}
                    			
                    	});
                    	
                    	obj.getMyPlayers();
                     
                    	var getWhat = 'fields,tactics';
                    	var promise = AJAX.get('PLAYER', {tacticsType:tacticsType,get:getWhat,id_account:me.get('id_account')} ); 
                    	scopePointer.API.setResting( true );
                    	scopePointer.API.clearErrors();
                    	
                    	var savedCache;
                    	
                    	promise.success(function(data, status, headers, config) {
                    		//succesful get event. 
                    		
                		scopePointer.API.setResting( false );
                		if( data.status == 'SUCCESS' )
                    	    	{
                    	    		
				 
					scopePointer.loaded		= true; 
					scopePointer.data    		= data.ret; 
					scopePointer.restLoading 	= false;
					
					 
					for( var pl in data.ret )
					{  
						if( typeof data.ret[pl].fields != 'undefined' )
						{
							if( id == data.ret[pl].fields.id )
							{ 
								obj.updateDropdowns( data.ret[pl].tactics ); 
								scopePointer.data.title = tr("Tactics",data.ret[pl].fields);
							}
							me.synch( 'playerTactics', data.ret[pl], cacheTactics[ data.ret[pl].fields.id ], data.timestamp );
							cacheTactics[ data.ret[pl].fields.id ] = data.ret[pl].tactics; 
						}
					}
					
				}
				else
					scopePointer.API.setError( data.ret.message, scopePointer );
			  });
			
			  promise.error(function(data, status, headers, config) {
			  		  scopePointer.API.setResting( false );
				scopePointer.API.setError( 'REST', scopePointer );
			  });  
                    },
                    
                    getMyPlayers: function()
                    {
                    	   
                    	me.get('myPlayers', me.get('id_account') ).then( function( result ) {
                    		//if( typeof scopePointer.form.options['players'] == 'undefined' )
                    		//{
                    			scopePointer.form.options['players']    = [];
                    			scopePointer.form.model.player   = [];
                    		//}	
                    		var added = 0;
                    		for( var i in result )
                    		{
                    			
                    			//console.log("adding ???>>> "+(scopePointer.form)+" <<< ");
                    			scopePointer.form.options['players'].push( {value: result[i].fields.id, id_allstar:result[i].fields.id_allstar, id_national:result[i].fields.id_national, name: result[i].fields.first_name + ' '+ result[i].fields.last_name } );
                    			 
                    			if( result[i].fields.id == id )
                    				scopePointer.form.model.player = scopePointer.form.options['players'][added];
                    			 
                    			added++;
                    		}
                    	});    
                    	    
                    },
                    
                    setCopyTheseTactics: function( what ){
                    	
                    	//alert( " last Copy These Click = "+this.lastCopyTheseClick );
                    	//bug ??'
                    	
                    	if( typeof this.lastCopyTheseClick == 'undefined' )
                    		this.lastCopyTheseClick = what==false?true:false;
                    		 
                    	
						if( what == this.lastCopyTheseClick ) 
							what = what==false?true:false;
                    	
                    	//alert('aici '+what);
                    	//alert('clicked '+typeof scopePointer.form);
                    	scopePointer.form.copyThese = what;
                    	this.lastCopyTheseClick = what;
                    	//window.SC().form.copyThese  = what;
                    	//window.SC().$apply();
                    },
                    
                    saveTactics: function()
                    {
                    	scopePointer.savingTactics = 1;
                    	var patch = {};
                    	var obj   = this;
                    
                    	patch['ist'] 	 		 = scopePointer.form.model['play_intensity'].value+':'+scopePointer.form.model['play_style'].value;
                    	patch['defense'] 		 = scopePointer.form.model['off_the_ball_d'].value+':'+scopePointer.form.model['defensive_bonus'].value;
                    	patch['passing_pref'] 	 	 = scopePointer.form.model['passing_preferences']['C'].value+':'+scopePointer.form.model['passing_preferences']['PF'].value+':'+scopePointer.form.model['passing_preferences']['SG'].value+':'+scopePointer.form.model['passing_preferences']['PG'].value+':'+scopePointer.form.model['passing_preferences']['SF'].value;
                    	patch['shooting_parameters'] 	 = scopePointer.form.model['shooting_parameters']['3pt'].value+':'+scopePointer.form.model['shooting_parameters']['inside'].value+':'+scopePointer.form.model['shooting_parameters']['fg'].value;
              
                    	
                    	var getThese  			 = 'fields,tactics';
                    	//alert(scopePointer.form.copyThese);
                    	var promise = AJAX.patch('TACTICS', {type: tacticsType,edit:patch,copy: (scopePointer.form.copyThese==false?0:1),'return': getThese, id_player:id} ); 
                    	promise.success(function(data, status, headers, config) {
                    		//succesful get event. 
                    		scopePointer.savingTactics		= 0;      
                		scopePointer.API.setResting( false );
                		if( data.status == 'SUCCESS' )
                    	    	{    
					scopePointer.API.setMessage( data.ret.message ); 
					//for( var i in data.ret['return'] )
					//	cacheTactics[ data.ret['return'][i].fields.id ] = data.ret['return'][i].tactics;	
				 
					if( scopePointer.tutorial ){ 
						 
                    	    			scopePointer.tutorial.doneStep('setTactics');
                    	    			scopePointer.go('/myPlayer/'+id);
                    	    		}
                    	    		
                    	    		obj.updatePlayerTacticsDB( data.ret['return'] );
				}
				else
					scopePointer.API.setError( data.ret.message, scopePointer );
			  });
			
			  promise.error(function(data, status, headers, config) {
			  		  scopePointer.API.setResting( false );
				scopePointer.API.setError( 'REST', scopePointer );
			  })
                    	    
                    },
                    
                    updatePlayerTacticsDB: function( result ) 
                    {
                    	    var savedCache = {};
                    	    for( var pl in result )
                    	    	    if( typeof  result[pl].fields != 'undefined' )
					if( typeof cacheTactics[ result[pl].fields.id ] != 'undefined' ) 
						savedCache = cacheTactics[ result[pl].fields.id ];
							else
								savedCache = null;
							
			me.synch( 'playerTactics', result[pl], savedCache, result.timestamp );	    
                    },
                    
                    
                    updateDropdowns: function( result )
                    { 
                    	    for( var i in result.passing_preferences )
                    	    { 
                    	    	    this.setDropdownItem('passing_preferences', i, result.passing_preferences[i]);
                    	    }
                    	    for( var i in result.shooting_parameters )
                    	    	    this.setDropdownItem('shooting_parameters', i, result.shooting_parameters[i]);
                    	    
                    	    for( var i in result )
                    	    {
                    	    	if( i != 'passing_preferences' && i != 'shooting_parameters' )
                    	    		this.setDropdownItem( i, null, result[i] );
                    	    }
                    	    
                    	    if( result.copy_teammates == 1 )
                    	    	    scopePointer.form.copyThese = true;
                    	    		else	
                    	    			scopePointer.form.copyThese = false;
                    },
                    
                    
                    getContract: function( id_contract, $scope)
                    {
                    	    scopePointer = $scope;
                    	    scopePointer.data.title = tr('Contract');
                    	    var getWhat = {'get': 'fields,team=fields-manager', id_contract: id_contract }
                    	    
                    	    var promise = AJAX.get('CONTRACTS', getWhat );
                    	    
                    	    scopePointer.API.setResting( true );
                    	    var obj	= this;
                    	    promise.success(function(data, status, headers, config) {
                    		//succesful get event. 
                    		    
                		scopePointer.API.setResting( false );
                		  scopePointer.API.checkNotifications( data, scopePointer);
                		if( data.status == 'SUCCESS' )
                    	    	{   
					scopePointer.data = data.ret;
					if( obj.activeOffer()  )
						scopePointer.data.title = tr('Offer');
							else
								scopePointer.data.title = tr('Contract');
				}
				else
					scopePointer.API.setError( data.ret.message, scopePointer );
			  });
			
			  promise.error(function(data, status, headers, config) {
			  	scopePointer.API.setResting( false );
				scopePointer.API.setError( 'REST', scopePointer );
			  }) 
                    },
                    
                    releaseYourself: function()
                    {
                      		var getWhat = { 'cancelContract': scopePointer.data.fields.id_player , 'return': 'fields,club,contract' };
                		 
                		var obj     = this;
				var promise = AJAX.patch('CONTRACT', getWhat ); 
				scopePointer.submission = 1;
				promise.success(function(data, status, headers, config) {
					scopePointer.API.setResting(false);
					scopePointer.API.checkNotifications(data,scopePointer);
					scopePointer.submission = 0;
					if( data.status == 'SUCCESS' )
					{
						scopePointer.API.setMessage( data.ret.message );
						obj.resynchPlayer( data );
						scopePointer.go( '/myPlayer/' + scopePointer.data.fields.id_player );
					}
					else
						scopePointer.API.setError(  data.ret.message, scopePointer );
					
				});
				
				promise.error(function(data, status, headers, config) {
					  scopePointer.submission = 0;
			  		  scopePointer.API.setResting( false );
			  		  scopePointer.API.setError( 'REST', scopePointer );
				}); 
                    },
                    
                    contractDecision: function( decision )
                    {
                    	        var getWhat = { 'contractDecision': scopePointer.data.fields.id_player , 'decision':decision, 'id_contract': scopePointer.data.fields.id, 'return': 'fields,club,contract' };
                		 
                		var obj     = this;
				var promise = AJAX.patch('CONTRACT', getWhat ); 
				scopePointer.submission = 1;
				promise.success(function(data, status, headers, config) {
					scopePointer.API.setResting(false);
					scopePointer.API.checkNotifications(data,scopePointer);
					scopePointer.submission = 0;
					if( data.status == 'SUCCESS' )
					{
						if( typeof data.ret.message != 'undefined' )
							scopePointer.API.setMessage( data.ret.message );
						
						scopePointer.go( '/myPlayer/' + scopePointer.data.fields.id_player );
						//obj.resynchPlayer( data );
					}
					else
						scopePointer.API.setError(  data.ret.message, scopePointer );
					
				});
				
				promise.error(function(data, status, headers, config) {
					  scopePointer.submission = 0;
			  		  scopePointer.API.setResting( false );
			  		  scopePointer.API.setError( 'REST', scopePointer.ret.message );
				}); 
                    },
                    
                    resynchPlayer: function( data )
                    {
                    	    me.synch( 'player', data.ret['return'], null, data.timestamp  );
                    },
                    
                    getWornEquipment: function()
                    {
                    	    var items = 0;
                    	    if( typeof scopePointer.data.equipment != 'undefined' )
                    	    {
                    	    	    for( var equip in scopePointer.data.equipment  )
                    	    	    	    if( scopePointer.data.equipment[equip].stat == 1 )
                    	    	    	    	items++;
                    	    	    return items;
                    	    }
                    	    
                    	    return '?';    
                    },
                    
                    activeOffer: function()
                    {
                    	    if( 
                    	    	scopePointer.data.fields.stat == 8 || 
				scopePointer.data.fields.stat == 9 ||
				scopePointer.data.fields.stat == 12
			    )	
			    	return 1;
			    		else
			    			return 0;
                    },
                    
                    getAvailableDemos: function()
                    {
                    	if( typeof scopePointer.data.demos != 'undefined' )
                    		if( typeof scopePointer.data.demos.count != 'undefined' )	
                    			return ( 3 - scopePointer.data.demos.count );
                    		
                    	return '?';  
                    },
                    
                    simGame: function( which )
                    {
                    	        var getWhat = { 'id_player': id };
                		if( which == 'live' )
                			getWhat.live = 1;
                    	        
                		var obj     = this;
				var promise = AJAX.put('DEMOS', getWhat ); 
				scopePointer.API.setResting(true);
				scopePointer.submission = 1;
				promise.success(function(data, status, headers, config) {
					scopePointer.API.setResting(false);
					scopePointer.API.checkNotifications(data,scopePointer);
				 
					if( data.status == 'SUCCESS' )
					{
						 if( scopePointer.tutorial )
						 	 scopePointer.tutorial.doneStep('simulateGame');
						
						 if( which == 'live' )
						 	 scopePointer.go('/game/'+data.ret.id_game+'/live');
						 		else
						 			scopePointer.go('/simulatingDemo');
					}
					else
						scopePointer.API.setError(  data.ret.message, scopePointer );
					
				});
				
				promise.error(function(data, status, headers, config) {
					  scopePointer.submission = 0;
			  		  scopePointer.API.setResting( false );
			  		  scopePointer.API.setError( 'REST', scopePointer );
				});    
                    },
                    
                    getTraining: function( idPlayer, $scope )
                    {},
                    
                    createSkilList: function()
                    {
                    	    scopePointer.form.options.skills = [];
                    	    var skills = me.get('skills');
                    	    var obj    = {};
                    	    for( var sk in skills )
                    	    {
                    	    	    obj 	= {};
                    	    	    obj.name 	= me.getSkillTranslation(skills[sk]);
                    	    	    obj.value 	= skills[sk];
                    	    	    scopePointer.form.options.skills.push( obj );
                    	    }
                    	    
                    	    
                    	    
                    },
                    
                    getTrainingClass: function( which )
                    {   
                    	    if( which == training.intensity )
                    	    	    return 'selectedTraining';
                    	    		else
                    	    			return '';
                    },
                    
                    setTraining: function( to, which )
                    {
                    	training[which] = to;	   
                    	if( which == 'skill' )
                    	{
                    		if( typeof scopePointer.form.options.skills != 'undefined' )
                    			for( var num in scopePointer.form.options.skills )
                    				if( scopePointer.form.options.skills[num].value == to )
                    					scopePointer.form.model.value = scopePointer.form.options.skills[ num ];
                    	}
                    },
                    
                    getTrainingBenefit: function()
                    {
                    	    var v = {};
                    	    if( training['intensity'] == 'high' )
                    	    {
                    	    	    v['value'] = '20';
                    	    	    v['value2'] = '5';
                    	    	    return tr('+{value} to your skill',v)+'<p>'+tr('+{value2} to your teammates',v);
                    	    }
                    	    else if( training['intensity'] == 'med' )
                    	    {
                       	    	    v['value'] = '10';
                    	    	    v['value2'] = '3';
                    	    	    return tr('+{value} to your skill',v)+'<p>'+tr('+{value2} to your teammates',v);                  	    	    
                    	    }
                    	    else
                    	    {
                    	    	    v['value'] = '5';
                    	    	    v['value2'] = '1';
                    	    	    return tr('+{value} to your skill',v)+'<p>'+tr('+{value2} to your teammates',v);   	    
                    	    }
                    },
                    
                    getTrainingCost: function( )
                    {
                    	    var v = {};
                    	    if( training['intensity'] == 'high' )
                    	    {
                    	    	    v['cost'] = '84,000.00';
                    	    	    return tr('Cost ${cost} / official match',v);
                    	    }
                    	    else if( training['intensity'] == 'med' )
                    	    {
                    	    	    v['cost'] =  '20,000.00';
                    	    	    return tr('Cost ${cost} / official match',v);                    	    	    
                    	    }
                    	    else
                    	    	    return tr('Free training'); 
                    },
                    
                    chooseGoal: function( id_goal, level, career )
                    {
                    	var getWhat = { 'return': 'goals=fields-possible-completed', 'id_achievement':id_goal,'id_player': id, level: level, career: career };
                		     
                		var obj     = this;
        				var promise = AJAX.put('SPGOAL', getWhat ); 
        				scopePointer.API.setResting(true);
        				scopePointer.submission = 1;
        				promise.success(function(data, status, headers, config) {
        					scopePointer.API.setResting(false);
        					scopePointer.API.checkNotifications(data,scopePointer);
        				 
        					if( data.status == 'SUCCESS' )
        					{
        						 if( scopePointer.tutorial )
        						 	 scopePointer.tutorial.doneStep('statGoals');
        						
        						 scopePointer.data.goals    	= data.ret['return'].goals;   
        					}
        					else
        						scopePointer.API.setError(  data.ret.message, scopePointer );
        					
        				});
        				
        				promise.error(function(data, status, headers, config) {
        					  scopePointer.submission = 0;
        			  		  scopePointer.API.setResting( false );
        			  		  scopePointer.API.setError( 'REST', scopePointer );
        				});   
                            	    
                            },
                    
                    conditionalRedirect: function( link, iff )
                    {
                    	    if( iff != 0 )
                    	    	    scopePointer.go(link);
                    	return '#';    
                    },
                    
                    
                    
                    updateTraining: function()
                    { 
                    	        var getWhat = { 'skill':scopePointer.form.model.value.value, 'intensity':training['intensity'],'id_player': id };
                		 
                    	        
                		var obj     = this;
        				var promise = AJAX.patch('TRAINING', getWhat ); 
        				scopePointer.API.setResting(true);
        				scopePointer.submission = 1;
        				promise.success(function(data, status, headers, config) {
        					scopePointer.API.setResting(false);
        					scopePointer.API.checkNotifications(data,scopePointer);
        				 
        					if( data.status == 'SUCCESS' )
        					{
        						 
        					}
        					else
        						scopePointer.API.setError(  data.ret.message, scopePointer );
        					
        				});
        				
        				promise.error(function(data, status, headers, config) {
        					  scopePointer.submission = 0;
        			  		  scopePointer.API.setResting( false );
        			  		  scopePointer.API.setError( 'REST', scopePointer );
        				});   
                            },
                            
                          getHelp: function( page, item )
                          {
                		var help = { items:{} };
                		var v	 = { 'games_per_career':30, 'season_days':61,'teams_per_league':16,'regular':30,'playoff':'3/3/3','length': 12, '/a':'', pos:tr('C/PF/SF/SG/PG'),'cyberpoints_link':'','career_link':'', 'goals':3,'per_game':1, 'games':10,'sp_rewardable':30 };
                		 
                		switch( page )
                		{
                			case "demo": 
                				help.title 			= tr('Demo games are meant to help you understand how the game works and how to improve your performance.');
                				help.items.a2_recommandation	= {'text' :tr("We recommend doing it as you explore the possibilites of improving your performance. In this game small changes can have a big impact.",v) , 'title':tr('When to do it')};

                				help.items.a4_live		= {'text' :tr("You can watch a game that is being 'live simmed' in a 2D format.",v)+' '+tr('It lasts {length} minutes (without overtime).',v) , 'title':tr('Live Sim')};
                				help.items.a5_instant		= {'text' :tr("An 'instant sim' will happen almost automatically ( you`ll receive a notification once its done )",v), 'title':tr('Instant Sim')};
                				  //help.items.a3_league_position	= {'text' 	:tr(""), 'title':tr('')};
                			   
                			break;  
                			
                			case "tactics":
                				help.title 			= tr('Player tactics');
                				help.items.a1_intensity		= {'text' 	:tr("Play Intensity determines how much you will put during a game. It can be hard, normal or relaxed. The harder you play, the more stamina you burn but the better you play."), 'title':tr('Play Intensity')};
                				help.items.a2_style		= {'text' 	:tr("Determines how you will approach your offense, which shot you will look for. Obviously, it should correlate with your abilities."), 'title':tr('Play Style')};
                				help.items.a3_shooting		= {'text' 	:tr("Percentage of shots you will take from each area. 3 point shot, inside shot and mid range shot."), 'title':tr('Shooting Parameters - 3PT / INSIDE / SEMI:')};
                				help.items.a4_passing		= {'text' 	:tr("Determines the flow of the offense. The % of passes your player is likely to make towards the {pos}.",v), 'title':tr('Passing Preferences')};
                				help.items.a5_off_the_ball_d	= {'text' 	:tr("Gives your player a stealing or a blocking bonus."), 'title':tr('Off the ball D')};
                				help.items.a6_defensive		= {'text' 	:tr("Gives your player a bonus when his assignment makes plays in that particular area."), 'title':tr('Defensive Bonus')};
                				help.items.a7_quickset		= {'text' 	:tr("Allows you to easily set predefined numbers on each item."), 'title':tr('"Quickset"')};
                				
                				 
                				help.items.settings      	= {'text':help.items.a1_intensity.title+': '+help.items.a1_intensity.text+' \n \n '+help.items.a2_style.title+': '+help.items.a2_style.text};      				 
                				help.items.defensive      	= {'text':help.items.a5_off_the_ball_d.title+': '+help.items.a5_off_the_ball_d.text+' \n \n '+help.items.a6_defensive.title+': '+help.items.a6_defensive.text};
                				 
                				//help.items.a1_item	= {'text' 	:tr(""), 'title':tr('')}; 
                			break;
                			
                			case "training":
                				help.title 			= tr('Player training');
                				help.items.a1_training		= {'text' 	:tr("Choose a skill and an intensity.")+' '+tr('In the upcoming match you will enjoy a skill boost determined by your teammates`s training and your own.')+' '+tr('Training cost is charged at gametime. If you can`t afford the intensity selected your training will be decreased to the next affordable bracket.'), 'title':tr('Training')}; 
                				help.items.a2_skills		= {'text' 	:tr('Your skills without any kind of boost (equipment / training etc.)'), 'title':tr('Skills')}; 
                				help.items.a3_boost		= {'text' 	:tr('Skill boosts your player will get in the next game if no teammate changes training until then and if they can afford that training at gametime.') + ' ' + tr('You recieve a boost from each of their trainings.'), 'title':tr('Benefits next game')}; 
                				help.items.a4_teammates		= {'text' 	:tr('What your teammates are training.'), 'title':tr('Teammates')};           		
                			break;
                			
                			case "goals":
                			        help.title 			= tr('Set goals in order to earn more skillpoints');
                				help.items.a1_goals		= {'text' 	:tr("Goals are objectives you are setting for your player in the upcoming games.")+' '+tr('You can set {goals} goals for each {career_link}career stage{/a}(~1 season)',v)+' '+tr('That is {per_game} goal every {games} game(s)',v), 'title':tr('Goals')}; 
                				help.items.a2_goals		= {'text' 	:tr("Goals you've set and have completed or have yet to complete.",v), 'title':tr('Pending & completed goals')}; 
                				help.items.a3_goals		= {'text' 	:tr("Skillpoint rewards grow for every career stage. A rookie stage goal will yield about ~20% less than a sophomore goal.",v)+' '+tr('But no matter what you do, you will set them in order. Rookie goals, then sophomore goals, then junior goals - etc. You can not skip a stage.'), 'title':tr('Rewards')}; 
                			
                				help.items.completed 		= {'text'	: help.items.a2_goals.text+' '+help.items.a3_goals.text };
                			break;
                			
                			case "crib":
                				help.items.a1_sp		= {'text'	:tr('Are used to improve your skills.')+' '+tr('Skillpoints are received after almost every official games but only {sp_rewardable} per {career_link}career stage{/a} (~1 season).',v), 'title':tr('Skillpoints')};
                				help.items.a2_equip		= {'text' 	:tr("Each player can wear 3 items of clothing which will improve his skills and game performance."), 'title':tr('Equipment')}; 
                				help.items.a3_drafting		= {'text' 	:tr("If you are not part of a club, we recommend drafting into one asap.")+' '+tr('You can only draft into computer teams that have NPC players at your position.'), 'title':tr('Draft')};
                				help.items.a3_games		= {'text' 	:tr("Each league sims LIVE at a different time. Might be wise to take that into consideration when choosing your team.")+' '+tr('Each team takes part in league competitions and international ( inter-league ) competitions, the later might sim at a different time than your league though.') , 'title':tr('Fixtures')}; 
                				help.items.a4_games		= {'text' 	:tr("You can view the stats you've recorded in the results and visit the stats board & play-by-play by tapping the game."), 'title':tr('Results')}; 
                				help.items.a5_games		= {'text' 	:tr('Demo games are meant to help you understand how the game works and how to improve your performance.')+' '+tr("We recommend doing it after changing training, setting tactics, buying equipment or buying extra skillpoints. This will help you understand how your changes impact player performance.",v), 'title':tr('Simulate a demo')}; 
                				help.items.a6_games		= {'text' 	:tr('Who you pass to, how you shoot, defensive settings, intensity of play etc.',v), 'title':tr('Player tactics')}; 
                				help.items.a7_team		= {'text' 	:tr('Plays for this team at club level.',v), 'title':tr('Team')};
                				help.items.a8_manager		= {'text' 	:tr('The manager of this team. It can either be another user, yourself or the computer.',v) + ' ' + tr('Teams can be bought using {cyberpoints_link}cyberpoints{/a} (ingame currency)',v), 'title':tr('Manager')};
                				help.items.a9_league		= {'text'	:tr('Each league has {teams_per_league} teams.',v)+' '+tr('In each season (~{season_days} days) they play {regular} regular season games, after which a {playoff} playoff system to decide the winner.',v)+' '+tr('Different leagues may exist.'), 'title':tr('League')};
                				help.items.b0_contract		= {'text' 	:tr("You can release yourself instantly if your manager is non-human and depending on the release clause if he is human."), 'title':tr('Contract')}; 
                				
                				help.items.b1_training		= {'text' 	:tr('In the upcoming match you will enjoy a skill boost determined by your teammates`s training and your own.'), 'title':tr('Player training')}; 
                				help.items.b2_goals		= {'text' 	:tr("Goals are objectives you are setting for your player in the upcoming games.")+' '+tr('Upon their completion you recieve skillpoints to improve your skills with.'), 'title':tr('Skillpoint goals')}; 
                				var vv				= {'num': 10, 'num2':30};
                			
                				help.items.b3_retirement	= {'text'	:tr('There are {num} career stages.',vv)+' '+tr('Each career stage lasts about 1 season (if you play at least {num2} games).',vv)+' '+tr('Each season lasts about 2 months.'), 'title':tr('Retirement')};
                			break;
                			
                			case "profile":
                				help.items.a1_owner		= {'text'	:tr('User who currently owns this player.',v)+' '+tr('NPC players are owned by COMPUTER or a blank space is shown.'), 'title':tr('Owner')};
                				help.items.a2_team		= {'text'	:tr('Plays for this team at club level.',v), 'title':tr('Team')};
                				help.items.a3_league		= {'text'	:tr('Each league has {teams_per_league} teams.',v)+' '+tr('In each season (~{season_days} days) they play {regular} regular season games, after which a {playoff} playoff system to decide the winner.',v)+' '+tr('Different leagues may exist.'), 'title':tr('Team')};
                				help.items.a4_career		= {'text'	:tr('Once a player plays {games_per_career} games at a particular level and receives the skillpoints for those games he is ready to promote to the next career stage at the end of the season.',v)+' '+tr('Leagues are restricted by this "career stage" in order to enforce fairness & competition.')+' '+tr('Players usually spend 1 season for each career stage'), 'title':tr('Team')};
                				
                				help.items.a5_ratings		= {'text' 	:tr("These ratings give an insight on how the player is built (skill-wise)."), 'title':tr('Ratings')}; 
                				help.items.a6_results		= {'text' 	:tr("Latest games played by the player's team and stats recorded by this player in those games."), 'title':tr('Latest Games')}; 
                				help.items.a7_stats		= {'text' 	:tr('Stats recorded in each season')+' '+tr("PTS")+': '+tr('Points scored')+' '+tr("AST")+": "+tr('Assists')+' '+tr("BLK")+": "+tr('Blocks')+' '+tr("STL")+": "+tr('Steals')+' '+tr("REB")+": "+tr('Rebounds')+' '+tr("FLS")+": "+tr('Fouls')+' '+tr("MIN")+": "+tr('Minutes'), 'title':tr('Stats')}; 
                				help.items.a8_history		= {'text' 	:tr("Clubs, national teams and managers this player has played for during the seasons."), 'title':tr('Team History')}; 
                				help.items.a9_awards		= {'text' 	:tr("At the end of the season based on their performance and team performance awards are given."), 'title':tr('Awards')}; 
                				help.items.b1_sign		= {'text' 	:tr("If you own a team you can make an offer to this player"), 'title':tr('Sign player')}; 
                			break;
                			
                			case "contract_offer":
                				help.items.a5_auto_accept	= {'text' 	:tr("Since this is your player you can auto-sign the contract and join this team."), 'title':tr('Auto-Accept Contract')}; 
                			
                			case "contract":
                				help.items.a1_team_cash		= {'text' 	:tr("If the player is signed to a human manager - how much will the team that owns him get."), 'title':tr('Cash to team')}; 
                				help.items.a2_player_cash	= {'text' 	:tr("Money the player will receive daily (salary), when signing the contract (sign fee) and if the player is wrongfully released"), 'title':tr('Cash to team')}; 
                				help.items.a3_contract_duration	= {'text' 	:tr("When will the contract expire and the player will become a free agent."), 'title':tr('Contract Duration')}; 
                				help.items.a4_release_clause	= {'text' 	:tr("With a computer manager, you can release yourself at any time.")+' '+tr("With a human manager, if your playtime does not meet this guarantee you can release yourself."), 'title':tr('Release Clause')}; 
                			
                			break;
                		}
                		
                		 
                		if( typeof item != 'undefined' ){
                			//console.log(">> returning"+ help.items[item].text);
                			return help.items[item].text;
                		 }
                		
                		return help; 
                    	}
                }

            }]);
}());
