(function () {
  
    var scopePointer;
    var selectedPlayer;
    var boughtCareer 		= {};
    var selectedEquipmentType 	= 'none';
    
      
		
    angular.module('myApp.cyberpoints', ['myApp.AJAX','myApp.me' ])
        .service('cyberpoints', [ 'AJAX','me' ,
            function ( AJAX,me  ) { 
                return {
                	skillpointsSelect: function( pid )
                	{
                		if( typeof pid == 'undefined' )
                			var pid     = scopePointer.form.players.value; 
                		var getWhat = {'get':'bought_skillpoints,lifetime_possible_purchases', id_player: pid};
                		
                		scopePointer.API.setResting(true);
                		var promise = AJAX.get('PLAYER', getWhat );
                		
                		promise.success(function(data, status, headers, config) {
        				scopePointer.API.setResting(false); 
        				scopePointer.API.checkNotifications( data, scopePointer );
        				if( data.status == 'SUCCESS' )
        				{  
        					 
        					scopePointer.possible_purchases	 = data.ret.lifetime_possible_purchases;
        					boughtCareer = {};
        					if( typeof data.ret.bought_skillpoints != 'undefined' ) 
							if( typeof data.ret.bought_skillpoints.entries != 'undefined' )
								for( var i in data.ret.bought_skillpoints.entries ) 
										boughtCareer[data.ret.bought_skillpoints.entries[i].id_career] = 'da';
									
						scopePointer.skillpoints 	 = data.ret.bought_skillpoints;
					}
        				else
        					scopePointer.API.setError(  data.ret.message, scopePointer );
        					
        			});
        				
        			promise.error(function(data, status, headers, config) {
        				scopePointer.submission = 0;
        			  	scopePointer.API.setResting( false );
        			  	scopePointer.API.setError( 'REST', scopePointer );
        			});   
                	},
                	
                	getHelp: function( page, item )
                	{
                		var help = { items:{} };
                		help.items.a0_cyberpoints 			= {'text' 	:tr("Cyberpoints are the way we keep things running, make money, reward loyal users and how we reward you for spreading the word about this game.")+' '+tr('This is your current balance.')+' '+tr('You can earn more by purchasing, login bonuses, translations, referrals and whatever other methods are listed in the cyberpoints view with a (+).')+' '+tr('They can be spent on some extra skillpoints, teams, custom equipment and (-) items listed in the CyberPoints page.'), 'title':tr('CyberPoints ( ingame currency )')};
                		help.items.a5_extra_skillpoints = {'text': tr('Every career stage you can get extra skillpoints in exchange for CyberPoints.')+' '+tr("They can be used to improve your player's skills."), title: tr('Extra Skillpoints')};
                		help.items.a7_customs 		= {'text': tr('Customize equipment with the skill updates you desire.'), title: tr('Custom Equipment')};
                		help.items.b_shooting_3pt 	= {'text' 	:tr("Ability to shoot from beyond the arc. It is harder to make than a normal shot and it is rewarded with 3 points."), 'title':tr('3PT Shooting')};
				help.items.b_shooting_inside 	= {'text' 	:tr('AKA "In The Paint Shooting" is the ability to penetrate into the paint for small players and the ability to hustle inside the paint for big players.'), 'title':tr('Inside Shooting')};
				help.items.b_strength 		= {'text' 	:tr('Strength, Speed, Jumping, all of them will increase your performance on the court depending on your chosen shot type or defensive methods prefered. Strength is usually associated with bigger players & rebounding.'),title: tr('Strength')};
				help.items.a8_superstar		= {'text'	:tr('Superstar players start out with 25% extra skillpoints and earn 25% extra skillpoints their entire careers'), title:tr('Superstars')};		
				help.items.b_speed 		= {'text' 	:tr('Strength, Speed, Jumping, all of them will increase your performance on the court depending on your chosen shot type or defensive methods prefered. Speed is usually more associated with stealing and small players.'),title: tr('Speed')};
				help.items.b_stealing 		= {'text' 	:tr('The main defensive skill for the back court. Every steal will lower an offensive chance to the enemy by 1 and increase an offensive chance to the team by 1 so it`s a +2 for every steal.'),title: tr('Stealing')};
				help.items.b_stamina 		= {'text' 	:tr('Vital skill for the main scorer of the team as shooting consumes a lot of energy especially 3 pointers. Starters should have more because you stay on the court for a long time but subs should start training this after you train enough of your main skills because subs will be starters in the future. High stamina also guarantee you have stable performance for the whole match instead of a bad 4th quarter due to tiredness.'),title: tr('Stamina')};
				help.items.b_confidence 	= {'text' 	:tr('Affects your overall gameplay, especially free throws.'),title: tr('Confidence')};
				help.items.b_dribbling 		= {'text' 	:tr('Useful skill for small players that move around the court.'),title: tr('Dribbling')};
				help.items.b_shooting_fg 	= {'text' 	:tr('AKA "Semi Distance Shooting". Its usually a jump shot from inside the arc and outside the paint.'),title: tr('Mid Range Shooting')};
				help.items.b_jumping 		= {'text' 	:tr('Strength, Speed, Jumping, all of them will increase your performance on the court depending on your chosen shot type or defensive methods prefered. Jumping is a must for every position, helps gaining elevation when shooting or blocking.'),title: tr('Jumping')};
				help.items.b_blocking 		= {'text' 	:tr('The king of kings attribute for now, it determines how well you can block.'),title: tr('Blocking')};
				help.items.b_passing 		= {'text' 	:tr('A low passing will mean more turnovers. A high passing will mean assists and open looks for the scorers.'),title: tr('Passing')};
				help.items.b_rebounding 	= {'text' 	:tr('A good blocking monster + a good rebounding monster = Ownage. Why? Blocking make the player miss the shoot and rebound give the team a offensive chance. Rebounding is important as it give you 2nd chance when in offense and make sure your enemy don\'t have 2nd chance when in defense.'),title: tr('Rebounding')};
                		help.items.a6_own_team		= {'text': tr('You can buy a team to manage here.')+' '+tr('Teams are bought per season.'), title:tr('Your own team')};
                				
                		var v = {};
				v['cdpReviewReward'] = 400;
					
                		switch( page )
                		{
                			case "get":
                			case "home":
                				//help = { items:{} };	
                				help.items.a1_purchase		= {'text': tr('Tap the package in order to be redirected to the methods of payment.')+' '+tr('If you need another way of buying contact us.')+' '+tr('Purchases are non-refundable.'), title:tr('Purchasing')};	
                				help.items.a9_reviews		= {'text': tr('Earn {cdpReviewReward} CyberPoints by writting an honest review about this app.',v), title:tr('Site/App Reviews')};	
      
                				help.items.a2_login		= {'text': tr('Login everyday in order to earn more CyberPoints for your account.'), title:tr('Login Bonuses')};	
                				help.items.a3_referrals		= {'text': tr('Bring more people to the game and get a fraction of anything they buy.'), title:tr('Referrals')};	
                				help.items.a4_translations	= {'text': tr('Help translate the game in other languages and receive CyberPoints for your efforts.'), title:tr('Translations')};	
                				help.items.a6_own_team		= {'text': tr('You can buy a team to manage here.')+' '+tr('Teams are bought per season.'), title:tr('Your own team')};
                				help.items.a8_more_players	= {'text': tr('If you wish to create more players you can get extra slots here.')+' '+tr('These players slots do not expire.'), title:tr('More player slots')};
                				help.items.c3_uncredited	= {'text': tr('Once a purchase is made. It has to be credited//consumed. This is usually automatic, but, in case it does not happen automatic you can credit your account by clicking on the "uncredited purchases" button.'), title:tr('Uncredited Purchases')};
                				break; 
                			
                			
                			case "skillpoints":
                			case "customs":
                				
                			break;
                		}
                		
                		 console.log(">>>>>>>>>> "+(typeof item)+"<<<");
                		if( typeof item != 'undefined' )
                			if( typeof help.items[item] != 'undefined' )
                				return help.items[item].text;
                		
                		return help;
                	},
                	
                	purchaseSP: function( id_player, careerId )
                	{
                		var getWhat = { id_career: careerId, id_player: id_player};
                		
                		scopePointer.API.setResting(true);
                		var promise = AJAX.put('CYBERPOINTS_SKILLPOINTS', getWhat );
                		
                		promise.success(function(data, status, headers, config) {
        				scopePointer.API.setResting(false); 
        				scopePointer.API.checkNotifications( data, scopePointer );
        				if( data.status == 'SUCCESS' )
        				{   
        					boughtCareer[data.ret.careerId] = 'da'; 
        					scopePointer.data.fields.cyberpoints = data.ret.cdp.balance;
					}
        				else
        					scopePointer.API.setError(  data.ret.message, scopePointer );
        					
        			});
        				
        			promise.error(function(data, status, headers, config) {
        				scopePointer.submission = 0;
        			  	scopePointer.API.setResting( false );
        			  	scopePointer.API.setError( 'REST', scopePointer );
        			}); 
                	},
                	
                	loadMoreReferrals: function( )
                	{
                		var getWhat = { get: 'referrals='+(scopePointer.data.referrals.length), id_account : scopePointer.data.fields.id};
                		
                		scopePointer.API.setResting(true);
                		var promise = AJAX.get('ACCOUNTS', getWhat );
                		
                		promise.success(function(data, status, headers, config) {
        				scopePointer.API.setResting(false); 
        				scopePointer.API.checkNotifications( data, scopePointer );
        				if( data.status == 'SUCCESS' )
        				{   
        					for( var i in data.ret.referrals )
        						scopePointer.data.referrals.push( data.ret.referrals[i]  );
					}
        				else
        					scopePointer.API.setError(  data.ret.message, scopePointer );
        					
        			});
        				
        			promise.error(function(data, status, headers, config) {
        				scopePointer.submission = 0;
        			  	scopePointer.API.setResting( false );
        			  	scopePointer.API.setError( 'REST', scopePointer );
        			}); 
                	},
                	
                	getPlayers: function()
                	{
                		var arr 	= {};
                		arr.no_players 	= 2;
                		if( typeof scopePointer.data.fields != 'undefined' )
                			arr.no_players += scopePointer.data.fields.no_players;
                		
                		return arr;
                	},
                	
                	buyExtraSlots: function( numSlots )
                	{
                		var getWhat = { method: 'slots', buy: numSlots, 'return':'fields', id_account : me.get('id_account')};
                		
                		scopePointer.API.setResting(true);
                		var promise = AJAX.put('CYBERPOINTS', getWhat );
                		
                		promise.success(function(data, status, headers, config) {
        				scopePointer.API.setResting(false); 
        				scopePointer.API.checkNotifications( data, scopePointer );
        				if( data.status == 'SUCCESS' )
        				{   
        					me.synch( 'accounts', data.ret['return'], scopePointer.data, data.timestamp );
        					scopePointer.data.fields = data.ret['return'].fields; 
					}
        				else
        					scopePointer.API.setError(  data.ret.message, scopePointer );
        					
        			});
        				
        			promise.error(function(data, status, headers, config) {
        				scopePointer.submission = 0;
        			  	scopePointer.API.setResting( false );
        			  	scopePointer.API.setError( 'REST', scopePointer );
        			}); 	
                	},
                	
                	possibileToLoadMoreReferrals: function()
                	{
                		if( typeof scopePointer.data.referrals != 'undefined' )
                			if( scopePointer.data.referrals.length >= 20 )
                				if( scopePointer.data.referrals.length % 20 == 0 )
                					return 1;
                				
                		return 0;
                	},
                	
                	getCustomsCost: function()
                	{
                		 
                		if( scopePointer.form.equipmentType.value == 'under_clothing' )
                			return 900;
                				else
                					return 1350;
                	},
                	
                	
                	
                	calculateCustomTotals: function( skill )
                	{
                		var v 		= {};
                		v['maximum']	= this.getMaximumPerCustom();
                		if( isNaN(scopePointer.form[skill]) )
                		{
                			this.resetCustomSKTo( 0, skill );	
                			return scopePointer.API.setError( tr('Numeric value needed'), scopePointer );
                		}
                		
                		if( scopePointer.form[skill] < 0 )
                		{
                			this.resetCustomSKTo( 0, skill );
                			return scopePointer.API.setError( tr('Positive value needed'), scopePointer );
                		}
                		
                		if( scopePointer.form[skill] > v['maximum'] )
                		{
                			this.resetCustomSKTo( 0, skill );
                			return scopePointer.API.setError( tr('Skill value needs to be under {maximum}',v), scopePointer );
                		}
                		
                		var total = this.getTotalBoosted();
                		
                		if( v['maximum'] < parseInt(total) )
                		{
                			this.resetCustomSKTo( 0, skill );
                			return scopePointer.API.setError( tr('This type of custom equipment can only boost {maximum} skills.',v), scopePointer );
                		}
                		
                		scopePointer.form.reminder = v['maximum'] - parseInt(total); 
                	},
                	
                	modifyCustomSkill: function( skill, how )
                	{
                		
                		if( how == '-' )
                		{
                			if( scopePointer.form[skill] > 0 )
                			{
                				scopePointer.form[skill] = parseInt(scopePointer.form[skill])-1;	
                			}
                		}
                		
                		if( how == '+' )
                		{ 
                			if( scopePointer.form[skill] < this.getMaximumPerCustom() )
                			{
                				scopePointer.form[skill] = parseInt(scopePointer.form[skill])+1;	
                			}
                			
                			if( this.getTotalBoosted() > this.getMaximumPerCustom() )
                			{
                				var v 		= {};
                				v['maximum']	= this.getMaximumPerCustom();
                				scopePointer.form[skill] = parseInt(scopePointer.form[skill])-1;
                				return scopePointer.API.setError( tr('This type of custom equipment can only boost {maximum} skills.',v), scopePointer );
                
                			}  
                		}
                		
                		this.calculateCustomTotals( skill ); 
                	},
                	
                	getTotalBoosted: function()
                	{
                		var skills = me.get('skills');
                		var total  = 0;
                		for( var sk in skills )
                		{
                			if( scopePointer.form[skills[sk]] > 0 )
                				total += parseInt(scopePointer.form[skills[sk]]); 
                		}	
                		
                		return total;
                	},
                	
                	resetCustomSKTo: function( to, skill )
                	{
                		if( typeof skill != 'undefined' )
                		{
					scopePointer.form[skill] = to;
					this.calculateCustomTotals( skill );
				}
                	},
                	
                	setScope: function( $scope )
                	{
                		scopePointer = $scope;	
                	},
                	
                	purchased: function( careerId )
                	{
                		if( typeof boughtCareer[careerId]  != 'undefined' )
					if( boughtCareer[careerId] == 'da' )
						return 1;
					
				return 0;  
                	},
                	
                	getEquipmentMax: function( which )
                	{
                		if( which == 'under_clothing' )
                			return 30;
                				
                		return 45;
                	},
                	
                	getMaximumPerCustom: function()
                	{
                		if( scopePointer.form.equipmentType.value == 'under_clothing' )
                			return 30;
                		
                		return 45;	
                	},
                	
                	changeEquipmentSelection: function()
                	{
                		 //this.calculateCustomTotals(  ); 
                		 if( scopePointer.form.equipmentType.value == 'under_clothing' )
                		 {
                		 	 if( this.getMaximumPerCustom() < this.getTotalBoosted() )
                		 	 {
                		 	 	var skills = me.get('skills');
                		 	 	for( var sk in skills )
                		 	 		if( scopePointer.form[skills[sk]] != 0 )
                		 	 			this.resetCustomSKTo( 0, skills[sk] );
                		 	 }
                		 }
                		 
                		 scopePointer.form.reminder = this.getMaximumPerCustom() - parseInt(this.getTotalBoosted()); 
                	},
                	
                	createCustomEquipmentOptions: function()
                	{
                		var options = {};
                		var equips  = me.getEquipmentSlots();
                		scopePointer.form.equipments = [];
                		for( var i in equips )
                		{
                			options 	= {};
                			options.label	= tr(equips[i]) + ' ('+(this.getEquipmentMax( equips[i].replace(' ','_') ))+')';
                			options.value 	= equips[i].replace(' ','_');
                			scopePointer.form.equipments.push( options );
                		}
                		
                		var equipmentType = this.getSelectedEquipmentType();
                		if( equipmentType != 'none' )
                		{
                			if( equipmentType == 'shoes' )
                				scopePointer.form.equipmentType = scopePointer.form.equipments[0];
                			else if( equipmentType == 'accessory' )
                				scopePointer.form.equipmentType = scopePointer.form.equipments[1];
                			else
                				scopePointer.form.equipmentType = scopePointer.form.equipments[2];
                		}
                		else
                			scopePointer.form.equipmentType = scopePointer.form.equipments[0];
                		
                	},
                	
                	getSelectedEquipmentType: function()
                	{
                		return selectedEquipmentType;
                	},
                	
                	setSelectedEquipmetType: function( to )
                	{
                		selectedEquipmentType = to;
                	},
                	
                	purchaseable: function( careerId )
                	{
                		if( scopePointer.form.players.careerId >= careerId )
                			return 1;
                				else
                					return 0;
                	},
                	
                	buyTeam: function( clubId, seasons )
                	{
                		var getWhat = { method: 'team', id: clubId, seasons: seasons, 'return':'team=fields,accounts=fields'};
                		  
                		scopePointer.API.setResting(true);
                		var promise = AJAX.put('CYBERPOINTS', getWhat );
                		
                		promise.success(function(data, status, headers, config) {
        				scopePointer.API.setResting(false); 
        				scopePointer.API.checkNotifications( data, scopePointer );
        				if( data.status == 'SUCCESS' )
        				{    
        					scopePointer.API.setMessage(  data.ret.message, scopePointer );
        					scopePointer.data.fields = data.ret['return']['accounts'].fields; 
        					me.synch( 'accounts', data.ret['return']['accounts'], scopePointer.data, data.timestamp );
        					me.synch( 'teams', data.ret['return']['team'], null, data.timestamp );
        					scopePointer.go('/manageTeam/'+clubId);
					}
        				else
        					scopePointer.API.setError(  data.ret.message, scopePointer );
        					
        			});
        				
        			promise.error(function(data, status, headers, config) { 
        			  	scopePointer.API.setResting( false );
        			  	scopePointer.API.setError( 'REST', scopePointer );
        			}); 
                		
                	},
                	
                	getTitle: function( module )
                	{
                		if( module == 'customs' )
                			return tr('Create custom equipment');
                				else
                					return tr('Get extra skillpoints');
                		
                	},
                	
                	confirmReview: function()
                	{
                		var desc = scopePointer.form.nameAlias;
                		var promise = AJAX.put('CYBERPOINTS_REVIEWS', {text:desc} );
                		scopePointer.API.setResting(true);
                		promise.success(function(data, status, headers, config) {
        				scopePointer.API.setResting(false); 
        				scopePointer.API.checkNotifications( data, scopePointer );
        				if( data.status == 'SUCCESS' )
        				{    
        					scopePointer.API.setMessage(  data.ret.message, scopePointer );
        		 		}
        				else
        					scopePointer.API.setError(  data.ret.message, scopePointer );
        					
        			});
        				
        			promise.error(function(data, status, headers, config) { 
        			  	scopePointer.API.setResting( false );
        			  	scopePointer.API.setError( 'REST', scopePointer );
        			}); 	
                	},
                	
                	createEquipment: function()
                	{ 
                		var v = {};
                		v['maximum'] = this.getMaximumPerCustom();
                		v['updated'] = this.getTotalBoosted();
                		if( scopePointer.form.equipmentName.length <= 1 ) 
                			return scopePointer.API.setError( tr('Equipment name is too short'), scopePointer );	
                		 
                		if( scopePointer.form.equipmentPlayer.value <= 1 ) 
                			return scopePointer.API.setError( tr('Choose a player first'), scopePointer );	
                		
                		if( this.getMaximumPerCustom() != this.getTotalBoosted() ) 
                			return scopePointer.API.setError(tr('Please update exactly {maximum} skills. You`ve updated {updated}.',v), scopePointer);
                		 
                		var getWhat = { method: 'customs', type: scopePointer.form.equipmentType.value, name: scopePointer.form.equipmentName, id_player: scopePointer.form.equipmentPlayer.value, 'return':'accounts=fields,player=fields-equipment'};
                		var skills  = me.get('skills');
                		for( var sk in skills )
                			getWhat[ skills[ sk ] ] = scopePointer.form[ skills[sk] ];
                		
                		scopePointer.API.setResting(true);
                		var promise = AJAX.put('CYBERPOINTS', getWhat );
                		
                		promise.success(function(data, status, headers, config) {
        				scopePointer.API.setResting(false); 
        				scopePointer.API.checkNotifications( data, scopePointer );
        				if( data.status == 'SUCCESS' )
        				{    
        					scopePointer.API.setMessage(  data.ret.message, scopePointer );
        					scopePointer.data.fields = data.ret['return']['accounts'].fields; 
        					me.synch( 'accounts', data.ret['return']['accounts'], scopePointer.data, data.timestamp );
        					me.synch( 'players', data.ret['return']['players'], null, data.timestamp );
					}
        				else
        					scopePointer.API.setError(  data.ret.message, scopePointer );
        					
        			});
        				
        			promise.error(function(data, status, headers, config) {
        				scopePointer.submission = 0;
        			  	scopePointer.API.setResting( false );
        			  	scopePointer.API.setError( 'REST', scopePointer );
        			}); 	
                	},
                	
                	getReviewStat: function()
                	{
                		 
                		if( typeof scopePointer.data.cyberpoints.activeReviews == 'undefined' )
                			return 0;
                		
                		if( typeof scopePointer.data.cyberpoints.activeReviews[0] == 'undefined' )
                			return 0;
                		
                		if( typeof scopePointer.data.cyberpoints.activeReviews[0]['stat'] == 'undefined' )
                			return 0;
                		
                		return scopePointer.data.cyberpoints.activeReviews[0]['stat'];
                	},
                	
                	reviewLink: function()
                	{ 
                		if( getPlatform() == 'ios' )
                		{
                			window.open('itms-apps://itunes.apple.com/app/id966546033','_system');	
                		}
                		
                		if( getPlatform() == 'android' )
                		{
                			window.open('market://details?id=com.cybersports.cyberdunk','_system');	
                		}
                		
                		if( getPlatform() == 'windowsphone' )
                		{
                			window.open('ms-windows-store:reviewapp?appid=9NBLGGGZV6CK','_system');	
                		}
                		
                		if( getPlatform() == 'browser' )
                		{
                			window.open('https://chrome.google.com/webstore/detail/cyberdunk2-basketball-man/lfodpedgiihdghdllplglgemdidebjpe/reviews','_system');	
                		}
                	},
                	
                	fbInvites: function()
                	{
                		
                		facebookConnectPlugin.showDialog(
				{
					method: "apprequests",
					message: tr('Join my basketball team')
				 },
				 function (success){  
				    
				    alert(JSON.stringify( success ) );
				    
				 },
				    function (error) {console.log("ini error showdialog ni: " + error) }
				);	
                	}
                	
                }

            }]);
}());
