'use strict';

(function () {
  
    var scopePointer;
    var id      	= 0;
    var cache; 
    var equipped 	= { 'shoes':{type:'shoes',name:false} ,'accessory':{type:'accessory',name:false},'under clothing':{type:'under clothing',name:false}};
    var items    	= {};
    var workingType;
    var storeItems 	= []; 
 
		
    angular.module('myApp.equipment', ['myApp.AJAX','myApp.me' ])
        .service('equipment', [ 'AJAX','me' ,
            function ( AJAX,me  ) { 
                return {
                    	
                
                    init: function ( ) {
                    	  equipped 	= { 'shoes':{type:'shoes',name:false} ,'accessory':{type:'accessory',name:false},'under clothing':{type:'under clothing',name:false}};
                    	  items	   	= {};
                    	  workingType   = ''; 
                    	  storeItems 	= [];
                    },
                   
                    //GET INVENTORY
                    getInventory: function( id_player, $scope  )
                    {   
                    	    id = id_player; 
                    	    scopePointer = $scope;
                    	    var obj = this;
                    	    me.get('player', id_player ).then(function( result ) {
                    	    				 
                    	    		if( typeof result[0] != 'undefined' )
                    	    		{ 
                    	    			scopePointer.data.fields = result[0].fields;
                    	    			scopePointer.loaded	= true;
                    	    		
                    	    				 
						if( typeof result[0].equipment != 'undefined' )
						{   
							obj.setEquipmentFromJSON( result[0].equipment, 'id_inventory' ); 	
						}
                    	    		}
                    	    });
                    	   
                    	   
                    	    var getWhat = { 'get':'fields,equipment','id_player':id_player,'orderBy':'equipment.status' };
                    	    var promise = AJAX.get('PLAYER', getWhat,1 ); 
                    	    
                    	    $scope.API.setResting(true);
                    	
                    	    promise.success(function(data, status, headers, config) {
                    	    	obj.updateInventoryView(data, $scope);	
			    });
			    
			    if( promise.update )
				    promise.update(function(data, status, headers, config) {
					obj.updateInventoryView(data, $scope);		
				    });
			
			     promise.error(function(data, status, headers, config) {
					$scope.API.setResting(false);
			     }); 
                    },
                    
                    updateInventoryView: function( data, $scope )
                    {
                    	    var obj = this;
                    	    scopePointer.cachedCopy = data.cache;
                	    if( !data.cache ){
                		 scopePointer.API.setResting(false);
				 scopePointer.API.checkNotifications( data, scopePointer);
                	    }
			    //succesful get event. 
                	    me.synch( 'player', data.ret, cache, data.timestamp );
                            scopePointer.data 	= data.ret; 
                	    scopePointer.data.title = tr("{first_name}'s wearing ..",scopePointer.data.fields);
                	    obj.setEquipmentFromJSON( data.ret.equipment, 'id_inventory' );             
                    },
                    
                    //GET ITEMS FROM STORE ()
                    getStore: function( id_player,itemType, $scope )
                    {
                    	   
                    	    id 		= id_player; 
                    	    var obj 	= this;
                    	    if( typeof $scope != 'undefined' )
                    	    	    scopePointer = $scope;
                    	 
                    	    //GET PLAYER CASH
                    	    me.get('player', id_player ).then(function( result ) {
                    	    	if( typeof result[0] != 'undefined' )
                    	    	{
                    	    		scopePointer.data.fields = result[0].fields;
                    	    		scopePointer.data.skills = result[0].skills;
                    	    		//console.log("AICIIIIIIIIIIII >>> "+JSON.stringify(result[0].equipment)+" <<< <");
                    	    		obj.setEquipmentFromJSON(  result[0].equipment, 'id_item' );
                    	    	}
                    	    });
                    	     /*
                    	    //GET STORE ITEMS FROM DB 
                    	    me.get('items', itemType ).then(function( result ) {
                    	    	
                    	    	if( typeof result != 'undefined' )
					for( var i in result) 
						storeItems[ result[i].id ] = result[i];	 
                    	    });*/
                    	       
                    	    //GET STORE ITEMS FROM AJAX
                    	    var getWhat = { 'filter':'','type':itemType,'player': 'fields-skills','id_player': id,'unparsedSkills':1,'orderBy':'cost' };
                    	    var promise = AJAX.get('EQUIPMENT', getWhat,1 ); 
                    	  
                    	    $scope.API.setResting(true);
                    	
                    	    promise.success(function(data, status, headers, config) {
                    	    	obj.updateEquipmentStoreView( data, $scope );
			    });
			    
			    if( promise.update )
				    promise.update(function(data, status, headers, config) {
					obj.updateEquipmentStoreView( data, $scope ); 
				    });
			
			    promise.error(function(data, status, headers, config) {
				$scope.API.setResting(false);
			    });
                    },
                    
                    updateEquipmentStoreView: function( data, $scope )
                    {
                    	    var obj = this;
                    	    $scope.cachedCopy = data.cache;
                	    if( !data.cache ) 
                		$scope.API.setResting(false);
				
                    	    $scope.API.checkNotifications( data, $scope);
                    	    $scope.data.fields = data.ret.player.fields;
                    	    $scope.data.skills = data.ret.player.skills;
                	    //succesful get event. 
                		 
                	    me.synch( 'items', data.ret.items, cache, data.timestamp );
				for( var i in data.ret.items )
					storeItems.push(data.ret.items[i]);    
                    },
                    
                    getStoreItems: function()
                    {
                    	    return storeItems;
                    }, 
                    
                    getItems: function()
                    {
                    	    
                    	return items;    
                    },
                    
                    getTypeString: function( typeId )
                    {
                    	switch( parseInt(typeId) )
                    	{
                    		case 1:
                    			return 'shoes';
                    		break;
                    		
                    		case 2:
                    			return 'accessory';
                    		break;
                    		
                    		case 3:
                    			return 'under clothing';
                    		break;
                    	}
                    },
                    
                    getTypeNum: function( typeString )
                    {
                    	switch( typeString )
                    	{
                    		case "shoes":
                    			return 1;
                    		break;
                    		
                    		case "accessory":
                    			return 2;
                    		break;
                    		
                    		case "under clothing":
                    			return 3;
                    		break;
                    	}
                    },
                    
                    meetsFilter: function( filter, equip, typeFilter, notWorn )
                    { 
                    	if(  equip.stat == -1 )
                    		return 0;
                    	    
                    	if( typeof typeFilter != 'undefined' )
                    		if( equip.type != typeFilter )
                    			return 0;
                    		
                    	if( typeof notWorn != 'undefined' )
                    		if( equip.stat == 1 )
                    			return 0;
                    	    
                    	if( filter.length >= 3 )
                    	{
                    		for( var i in equip.skills )
                    		{
                    			if( i == filter && equip.skills[i] > 0 )
                    			{ 
                    				return 1;
                    			}
                    		}
                    			
                    		return 0;
                    	}
                    	else
                    	{ 
                    		return 1;
                    	}
                    },
                    
                    purchase: function(id_item, pays )
                    {
                    	       
                    	var req = [];
			req['id_item'] 		= id_item;
			req['pays']    		= pays;
			req['how']    	 	= 'purchase';
			req['id_player']	= id;
			req['equip']		= 1;
			req['return']		= 'fields,item';
			
			var obj			= this;
			var promise 		= AJAX.put('EQUIPMENT_PURCHASE', req ); 
			 
			scopePointer.API.setResting(true);
			promise.success(function(data, status, headers, config) {
                    	    		   
                    	    	scopePointer.API.setResting(false);
                		scopePointer.API.checkNotifications( data, scopePointer);
                    	    	
                    	    	if( data.status == 'SUCCESS' )
                    	    	{
                    	    		//cash balances & inventory
                    	    		obj.updatePlayerFields( data ); 
                    	    		if( scopePointer.tutorial )
                    	    			scopePointer.tutorial.doneStep('buyEquipment');
                    	    		
                    	    		scopePointer.go( 'equipment/'+id ); 
                    	    	}
                    	    	else
                    	    		scopePointer.API.setError( data.ret.message, scopePointer );
                		/*
                		me.synch( 'items', data.ret.items, cache, data.timestamp );
                		for( var i in data.ret.items )
                			storeItems.push(data.ret.items[i]);
                		*/
			    });
			
			promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false);
					scopePointer.API.setError( 'REST', scopePointer );
			});
                    },
                    
                    //AFTER PURCHASE OF ITEM
                    updatePlayerFields: function( info )
                    {
                    	   //UPDATE CASH & EQUIPMENT IN DATABASE
                    	   var jsnUpdate = {};
                    	   var jsnField = { worn: 0 };
                    	   var data     = info.ret.return;
                    	   for( var equipId in items )
                    	   { 
                    	   	   if( typeof info.ret.unequipped != 'undefined' )
                    	   	   	   if( info.ret.unequipped.id == equipId )
                    	   	   	   {
                    	   	   	   	   //console.log("unequip !!"+equipId);
                    	   	   	   	   items[equipId].stat = 0;
                    	   	   	   }	
                    	   	  
                    	   	   if( items[equipId].stat == 1 && items[equipId].type == data.item.type )
                    	   	   {
                    	   	   	   //console.log("unequip !!"+equipId);
                    	   	   	   items[equipId].stat = 0;
                    	   	   }
                    	   	   
                    	   	   if( items[equipId].stat == 1 )
                    	   	   	   jsnField.worn++;
                    	   	   //console.log(">>>"+JSON.stringify(items[equipId])+"<<< <BR>");
                    	   	   jsnField[ equipId ] = items[equipId];
                    	   }
                    	   
                    	   jsnField[ data.item.id ] = data.item; 
                    	   jsnField.worn++;
                    	   
                    	   
                    	   
                    	   var jsnUpdate = { 'id': id, 'equipment': jsnField };
                    	   if( typeof data.players != 'undefined' )
                    	   	   if( typeof data.players[id] != 'undefined' )
                    	   	   {
                    	   	   	jsnUpdate['fields'] 	 =  data.players[id].fields; 
                    	   	   	scopePointer.data.fields = data.players[id].fields; 	
                    	   	   }
                    	   	
                    	   //console.log( "in updateDB( "+id+"); >>"+JSON.stringify( jsnUpdate ) );
                    	   me.synch( 'player', jsnUpdate, null, info.timestamp ); 
                    	   
                    	   //UPDATE CASH ( IN CASE THE PURCHASE WAS DEDUCTED FROM MULTIPLE PLAYERS )
                    	   this.updatePlayers( data.players  );
                    	   
                    },
                    
                    setEquipmentFromJSON: function( jsnFile, indexField, extra )
                    { 
                 
                    	    var equip;
                    	    var obj = this;
                    	if( typeof jsnFile != 'undefined' )
                		for( var id_item in jsnFile)
                		{
                			if( id_item != 'worn' )
                			{
                				equip = jsnFile[ id_item ];
                				if( equip.stat == 1 )
                				{
                					obj.setEquipped( obj.getEquipType( equip.type ), equip ); 
                				}
                				obj.addItem( equip[indexField], equip, extra );
                			}
                		}    
                    },
                    
                    unequip: function( type )
                    {
                    	
                    	var id_inventory = this.getByType( type, 'id_inventory' );
                    	var id_item	 = this.getByType( type, 'id_item' );
                    	var obj		 = this;
                    	if( id_inventory != false )
                    	{
                    		
				var req = {};
				req['edit']		= {};
				req['edit']['stat']	= 0; 
				req['id_inventory'] 	= id_inventory;
				 
				
				var promise = AJAX.patch('INVENTORY', req);
				scopePointer.API.setResting( true );
				
				
				promise.success(function(data, status, headers, config) {
                    	    		   
					scopePointer.API.setResting(false); 
					scopePointer.API.checkNotifications( data, scopePointer);
					if( data.status == 'SUCCESS' )	
					{
						//set blank
						obj.setEquipped( type, {'type':type,'name':false} );
						//obj.patchItem( id_item, 'stat', 0 );
						items[id_item].stat = 0;
						obj.updateDB();
					}
					else
						scopePointer.API.setError( 'REST', data.ret.message );
						
				});
				
				promise.error(function(data, status, headers, config) {
					$scope.API.setResting(false);
					scopePointer.API.setError( 'REST', scopePointer );
				}); 
			}	
			
                    },
                    
                    updatePlayers: function( data )
                    {
                    	 var jsnUpdate = {};
                    	 if( typeof data != 'undefined' )
                    	 {
                    	   	var player;
                    	   	for( var pid in data  )
                    	   	{
                    	   		if( pid != id )
                    	   		{
                    	   			player    = {};
                    	   			player    =  data[pid];
                    	   			if( player != 'undefined' )
                    	   			{
							jsnUpdate = {};
							jsnUpdate =  { 'id': id, 'fields': player.fields };
							
							if( typeof player.equipment != 'undefined' )
								jsnUpdate.equipment = player.equipment;
							
							me.synch( 'player', jsnUpdate );
					       }
                    	   		}
                    	   		
                    	   	}
                    	   }    
                    	    
                    },
                    
                    //EQUIP SOMETHING VIA INVENTORY
                    //&UNEQUIP ON ANOTHER PLAYER
                    equip: function( id_inventory )
                    { 
                    	var obj		 = this;
                    	if( id_inventory != false )
                    	{
                    		
				var req = {};
				req['edit']			= {};
				req['edit']['id_player']	= id; 
				req['edit']['stat']		= 1; 
				req['id_inventory'] 		= id_inventory;
				req['return']			= 'fields,equipment';
				 
				 
				var promise = AJAX.patch('INVENTORY', req);
				scopePointer.API.setResting( true );
				
				promise.success(function(data, status, headers, config) {
                    	    		   
					scopePointer.API.setResting(false);
					scopePointer.API.checkNotifications( data, scopePointer);
					
					if( data.status == 'SUCCESS' )	
					{
						//set blank
						//obj.setEquipped( type, {'type':type,'name':false} );
						//obj.patchItem( id_item, 'stat', 0 );
						//items[id_item].stat = 1;
						if( typeof data.ret.return.players != 'undefined' )
							data.ret.return.players = {fields: data.ret.return.fields, equipment: data.ret.return.equipment };
						
						obj.updatePlayers( data.ret.return.players );
						
						scopePointer.go( 'equipment/'+id );
						
						
					}
					else
						scopePointer.API.setError( 'REST', data.ret.message );
						
				});
				
				promise.error(function(data, status, headers, config) {
					$scope.API.setResting(false);
					scopePointer.API.setError( 'REST', scopePointer );
				}); 
			}	
			
                    },
                    
                    sell: function( idInventory )
                    {
                    	 var obj		 = this;   
                    	 if( idInventory != false )
                    	 {
                    		var req = {};
                    		req['id_inventory'] = idInventory;
                    		req['return']	    = 'fields';			//new player balance
                    		
                    		var promise = AJAX.hit('EQUIPMENT/SELL/?app=mobile&notifications=1&token='+me.getToken()+'&id_inventory='+idInventory+'&return=fields');
				scopePointer.API.setResting( true );

				promise.success(function(data, status, headers, config) {
                    	    		   
					scopePointer.API.setResting(false); 
					scopePointer.API.checkNotifications( data, scopePointer);
					
					if( data.status == 'SUCCESS' )	
					{     
						items[idInventory].stat = -1; 
						
						obj.updateDB( id ); 
						//update cash
						me.synch('player', data.ret['return'], null, data.timestamp );
						 
					}
					else
						scopePointer.API.setError( data.ret.message, scopePointer );
				});
				
				promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false);
					scopePointer.API.setError( 'REST', scopePointer );
				}); 
                    	 }
                    },
                    
                    getAccountInventory: function( itemType, id_player, $scope )
                    { 
                    	  
                    	    scopePointer = $scope;
                    	    var obj 	 = this;
                    	     me.get('player', id_player ).then(function( result ) {
                    	    				 
                    	    		if( typeof result[0] != 'undefined' )
                    	    		{ 
                    	    			scopePointer.data.fields = result[0].fields;
                    	    			scopePointer.data.skills = result[0].skills;
                    	    			scopePointer.loaded	= true;
                    	    		} 
                    	    });
                    	    
                    	    me.get('myPlayers' ).then(function( result ) {
                    	    	if( typeof result != 'undefined' )
                    	    	{
                    	    		
                    	    		for( var i in result )
                    	    		{ 
                    	    			 
                    	    			if( typeof result[i].equipment != 'undefined' )
                    	    			 obj.setEquipmentFromJSON( result[i].equipment, 'id_inventory', {onPlayer: result[i].fields.first_name+" "+result[i].fields.last_name} ); 
                    	    		}
                    	    	}
                    	    });
                    	    
                    	    me.get('lastRest', 'accountInventory' ).then( function( result ){
                    	    		 
                    	    	if( typeof result[0] != 'undefined' )
                    	    	{ 
                    	    		 
                    	    		if( result[0].timestamp.day != me.getDay() ) 
                    	    			obj.accountInventoryRest(  ); 
                    	    			 
                    	    	}
                    	    	else
                    	    		obj.accountInventoryRest( );
                    	    });
                    	    
                    	    //IF.. last gathered != today RUN AJAX/REST
                    	    //COMPLEX QUERY TO REQUEST EQUIPMENT FROM ALL PLAYERS SO BETTER DO IT ONCE
                    },
                    
                    updateLastRest: function( timestamp )
                    {
                    	    //console.log("UPDATE LAST REST<<<<<<<<<<<<<<<<<<<<<<");
                    	   // console.log("UPDATE LAST REST<<<<<<<<<"+timestamp+"<<<"+JSON.stringify(timestamp)+"<<<<<<<<<<");
                    	    //console.log("UPDATE LAST REST<<<<<<<<<<<<<<<<<<<<<<");
                    	    me.synch( 'lastRest', {fields:{field:'accountInventory'},id:'accountInventory'},null,timestamp );
                    },
                    
                    accountInventoryRest: function()
                    {
                    
                    	    var req = { id_account: me.get( 'id_account' ), get:'fields,equipment','retired':1};
                    	    var promise = AJAX.get('PLAYER', req);
                    	    var obj = this;
			    scopePointer.API.setResting( true );
				
			    promise.success(function(data, status, headers, config) {
                    	    		   
					scopePointer.API.setResting(false); 
					scopePointer.API.checkNotifications( data, scopePointer);
					
					if( data.status == 'SUCCESS' )	
					{
						//set blank
						//obj.setEquipped( type, {'type':type,'name':false} );
						//obj.patchItem( id_item, 'stat', 0 );
						//items[id_item].stat = 1; 
						for( var i in data.ret )
						{  
							if( typeof data.ret[i].equipment != 'undefined' )
								obj.setEquipmentFromJSON( data.ret[i].equipment, 'id_inventory', {onPlayer: data.ret[i].fields.first_name+" "+data.ret[i].fields.last_name} ); 
						}
						obj.updateLastRest( data.timestamp ); 
						obj.updatePlayers(  data.ret );  
						
					}
					else
						scopePointer.API.setError( 'REST', data.ret.message );
						
				});
				
				promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false);
					scopePointer.API.setError( 'REST', scopePointer );
				}); 
                    },
                    
                    //update the server side inventory
                    updateDB: function( pid )
                    { 
                    	   var jsnField = { worn: 0 };
                    	   for( var equipId in items )
                    	   {
                    	   	   if( items.stat == 1 )
                    	   	   	   jsnField.worn++;
                    	   	   //console.log(">>>"+JSON.stringify(items[equipId])+"<<< <BR>");
                    	   	   
                    	   	   if( typeof pid != 'undefined' )
                    	   	   {
                    	   	   	   if( pid == items[equipId].id_player )
                    	   	   	   {
                    	   	   	   	   if( items[equipId].stat != -1 )
                    	   	   	   	   	   jsnField[ equipId ] = items[equipId];
                    	   	   	   }
                    	   	   }
                    	   	   else
                    	   	   	   jsnField[ equipId ] = items[equipId];
                    	   }
                    	   
                    	   var jsnUpdate = { 'id': id, 'equipment': jsnField };
                    	   //console.log( "in updateDB( "+id+"); >>"+JSON.stringify( jsnUpdate ) );
                    	   me.synch( 'player', jsnUpdate ); 
                    },
                    
                    getSkills: function( id_item )
                    {
                    	     
                    	    var obj;
                    	    var skills = [];
                    	    var sk;
				if( typeof items[id_item] != 'undefined' )
				{
					var skillSet = me.get( 'skills' );
					for( var skId in skillSet )
					{ 
						sk = skillSet[skId];
						if( parseInt(items[id_item][sk]) > 0 )
						{   
							//console.log("item: "+id_item+" >> skl "+sk+" vl >> "+items[id_item][sk]+" << <B");
							obj = {  skill:me.getSkillTranslation(sk), value: items[id_item][sk]  };
							skills.push(obj);
						}
					}
				} 
                    		return skills;
                    },
                    
                    getByType: function( itemType, field )
                    {
                    	//this searches among equipped only 
                    	if( typeof equipped[itemType] != 'undefined' )
                    	{
                    		var id_item = equipped[itemType].id_item;
                    		 
                    		if( field == 'id_item' )
                    			return id_item;
                    				else if( field == 'id_inventory' )
                    				{
                    					if( typeof items[id_item] != 'undefined' )
                    						return items[id_item].id_inventory;
                    							else if( typeof equipped[itemType] != 'undefined' )
                    								return equipped[itemType].id_inventory;	
                    							else;
                    							
                    							return false;
                    					
                    						}
                    						else
                    							return false;
                    	}
                    	else
                    		return false;
                    },
                    
                    get: function( id_item, field )
                    {
                    	    if( typeof items[id_item] != 'undefined' )
                    	    {
                    	    	    if( typeof items[id_item][field] != 'undefined' )
        				return items[id_item][field] ; 
        					else
        						return false;
                    	    }
                    	    
                    	    return false;	
                    },
                    
                    addItem: function( id_item, equip, extra )
                    {
                    	    items[id_item] = equip;
                    	   
                    	    if( typeof extra != 'undefined' )
                    	    	    for( var field in extra )
                    	    	    	items[id_item][field] = extra[field];
                    },
                    
                    getSalePrice: function( id_item)
                    { 
                    	    if( typeof items[id_item] != 'undefined' )
                    	    	    return parseInt(parseInt(items[id_item].cost) / 3);
                    	    		else
                    	    			return 0;
                    },
                    
                    getEquipType: function( typeNum )
                    {
                    	    if( typeNum == 1 )
                    	    	    return 'shoes';
                    	    if( typeNum == 2 )
                    	    	    return 'accessory';
                    	    
                    	    return 'under clothing';
                    },
                    
                    patchItem: function( id_item, field, value )
                    {
                    	items[id_item][field]=value;    
                    },
                    
                    setEquipped: function( type, equip )
                    {     
                    	equip.type     = type; 
                    	scopePointer.equipped[type] = equip; 
                    },
                    
                    getEquipped: function( type )
                    { 
                    	    if( typeof type == 'undefined' )
                    	    	    return equipped; 
                    	    
                    	    if( typeof equipped[type] != 'undefined' )
                    	    	    return equipped[type];
                    	    
                    	return false;	    
                    },
                    
                    setWorking: function( toEquipmentType )
                    { 
                    	workingType = toEquipmentType;    
                    },
                    
                    getWorking: function()
                    {
                    	return workingType;	    
                    },
                     
                	
                    getHelp: function( page, item )
                    {
                		var help = { items:{} };
                		var v	 = { 'cdp_link': '', '/a':'' };
                		switch( page )
                		{
                			case "player":
                				
                				 
                				help.title 			= tr('What this player is wearing');
                				help.items.a1_equipment		= {'text' :tr("Each player can wear 3 items of clothing which will improve his skills and game performance.")+' '+tr("Items can be purchased from the store using player cash (collected from bets / salary etc.).",v)+' '+tr('Custom signature equipment can be purchased using {cdp_link}cyberpoints{/a} (our ingame currency).',v), 'title':tr('Equipment')};
                				help.items.a2_equipment		= {'text' :tr("Tap on each item in order to equip, unequip etc",v), 'title':tr('Shoes, accessory & under clothing')};
                				    
                			break; 
                			
                			case "store":
                				help.title 			= tr("Buying equipment");
                				help.items.a1_filter 		= {'text' 	:tr("You can filter equipment by the skill you aim to improve. In the parenthesis you can find your player's skill in that attribute."), 'title':tr('Filter')};
                				
                				help.items.a1_buying 		= {'text' 	:tr("Just tap on which item you decide to get. You can use the cash from all your players to purchase an item or just from this personal balance."), 'title':tr('Buying an item')};
                				 //help.items.a3_league_position	= {'text' 	:tr(""), 'title':tr('')};
                			
                			break;
                			
                			case "inventory":
                				help.title 			= tr("Account inventory");
                				help.items.a1_inventory 	= {'text' 	:tr("Items you have available and are not wearing."), 'title':tr('Inventory')};
                				help.items.a2_asell 		= {'text' 	:tr('You can sell regular items back to the game at a loss. Custom equipment can not be sold back to the game (the ones bought and customised with ingame currency).'), 'title':tr("Selling an item")};
                				help.items.a3_buying 		= {'text' 	:'', 'title':tr("Tap to equip or sell")};
                				
                			
                			break;
                		}
                		
                		 
                		if( typeof item != 'undefined' )
                			return help.items[item].text;
                		
                		return help; 
                    	}
                    
                    
                    
                    
                     
                }

            }]);
}());
