'use strict';

(function () {
  
    var scopePointer;
    var fields	= { myPlayer: 'fields,skills,fixtures=2,results=3,salary,expiration,training,equipment,career,club' };
    var id      = 0;
    var cache;
    var data;
    var drafting = 0;
    
 
		
    angular.module('myApp.events', ['myApp.AJAX','myApp.me' ])
        .service('events', [ 'AJAX','me' ,
            function ( AJAX,me  ) { 
                return {
                    	
                    get: function( which, $scope ){
                    	 
                    	scopePointer = $scope;
                	var promise = AJAX.get('EVENTS', {which:which, get:'all'},1 );  
			scopePointer.API.setResting(true);
			  
			promise.success(function(data, status, headers, config) { 
			
				if( data.status == 'SUCCESS' ){
					scopePointer.data = data.ret;
					scopePointer.data.title = data.ret.fields.title;
					scopePointer.API.setResting(false);
					scopePointer.data.posts = [];
						 
					scopePointer.data.link			= data.ret.thread.link;
					scopePointer.data.posts			= [];
					scopePointer.data.posts[0] 		= data.ret.thread.thread;
					scopePointer.data.posts[0]['comments']  = data.ret.thread.comments;
					scopePointer.data.posts[0]['showReplyButton'] = 1;
					scopePointer.wall.generateCommentSelectors( 0 );
					scopePointer.API.checkNotifications(data, scopePointer);
				}
				else
					scopePointer.API.setError( 'REST', scopePointer );	
			});
				
			if( promise.update )
				promise.update(function(data, status, headers, config) { 
					if( data.status == 'SUCCESS' ){
						scopePointer.data = data.ret;
						scopePointer.data.title = data.ret.fields.title;
						scopePointer.API.setResting(false);
						
						scopePointer.data.link			= data.ret.thread.link;
						scopePointer.data.posts			= [];
						scopePointer.data.posts[0] 		= data.ret.thread.thread;
						scopePointer.data.posts[0]['comments']  = data.ret.thread.comments;
						scopePointer.data.posts[0]['showReplyButton'] = 1;
						scopePointer.wall.generateCommentSelectors( 0 );
						scopePointer.API.checkNotifications(data, scopePointer);
					}
					else 
						scopePointer.API.setError( 'REST', scopePointer );
				}); 
				
			promise.error(function(data, status, headers, config) {
				$scope.API.setResting(false);
				scopePointer.API.setError( 'REST', scopePointer );	
			});    
			
                    },
                    
                    makeBid: function(){
                    	var opt = {bid: scopePointer.form.maxBid,idAuction: scopePointer.form.idAuction }; 
                    	var promise = AJAX.put('AUCTION_BID',opt  );  
			scopePointer.API.setResting(true);
			  
			promise.success(function(data, status, headers, config) { 
				scopePointer.API.setResting(false);
				if( data.status == 'SUCCESS' ){
					scopePointer.form.madeBid = 1;
					scopePointer.API.setMessage(data.ret.message);
				}
				else
					scopePointer.API.setError(data.ret.message);	
			});
				 
			promise.error(function(data, status, headers, config) {
				scopePointer.API.setResting(false);
				scopePointer.API.setError( 'REST', scopePointer );	
			});  
                    	    
                    },
                    
                    buyTickets: function(){
                    	    var opt = {amount: scopePointer.form.how_many_tickets,event: scopePointer.form.event }; 
                    	    var promise = AJAX.put('RAFFLE_TICKETS',opt  );  
                    	    scopePointer.API.setResting(true);
			   
                    	    promise.success(function(data, status, headers, config) { 
                    	    	
                 		    scopePointer.API.setResting(false);
				if( data.status == 'SUCCESS' ){
					scopePointer.form.madeBid = 1;
					scopePointer.data.raffles.mytickets = data.ret.return.bought;
					scopePointer.data.raffles.fields.tickets_bought = data.ret.return.bought.length;
					scopePointer.API.setMessage(data.ret.message);
					
				}
				else
					scopePointer.API.setError(data.ret.message);	
			    });
				 
			    promise.error(function(data, status, headers, config) {
				scopePointer.API.setResting(false);
				scopePointer.API.setError( 'REST', scopePointer );	
			    }); 
                    },
                    
                    getAuction: function( id, $scope ){
                    	    
                    	scopePointer = $scope;    
                    	var promise = AJAX.get('AUCTIONS', {id:id, get:'fields,bids'} ,1 );  
			scopePointer.API.setResting(true);
			  
			promise.success(function(data, status, headers, config) { 
			
				if( data.status == 'SUCCESS' ){
					scopePointer.data = data.ret;
					
					scopePointer.data.title = data.ret.fields.title;
					scopePointer.API.setResting(false);
				}
				else
					scopePointer.API.setError( 'REST', scopePointer );	
			});
				
			if( promise.update )
				promise.update(function(data, status, headers, config) { 
					if( data.status == 'SUCCESS' ){
						scopePointer.data = data.ret;
						scopePointer.data.title = data.ret.fields.title;
						scopePointer.API.setResting(false);
					}
					else 
						scopePointer.API.setError( 'REST', scopePointer );
				}); 
				
			promise.error(function(data, status, headers, config) {
				$scope.API.setResting(false);
				scopePointer.API.setError( 'REST', scopePointer );	
			});      
                    },
                    
                    
                    setScopePointer: function( to ){
                    	scopePointer = to;    
                    },
                    
                     
                	
                    getHelp: function( page, item )
                    {
                		var help = { items:{} };
                		var v	 = { 'num': 8 };
                		switch( page )
                		{
                			case "leagues":
                				
                				 
                				help.title 			= tr('Choose a league for your player.');
                				help.items.a1_simtime 		= {'text' :tr("At which time each round is simmed LIVE, converted into your local timezone.")+' '+tr('Also, shown below the actual game time of the simulation. Announcements are usually made using that timezone.'), 'title':tr('Simtime')};
                				help.items.a2_simtime 		= {'text' :tr("Each COMPUTER managed team in this league may need a number of players. This is a cummulative for that."), 'title':tr('Spots available')};
                				   
                			break; 
                			
                			case "teams":
                				help.title 			= tr("Teams that need players at your position in this league.")+' '+tr('You can only draft into computer teams.');
                				help.items.a1_simtime 		= {'text' :tr("At which time each round is simmed LIVE, converted into your local timezone."), 'title':tr('Simtime')};
                				
                				help.items.a1_human_owners 	= {'text' 	:tr("Users who bought a team in this league and are managing a team filled with their players or other people's players."), 'title':tr('Human team owners')};
                				help.items.a2_human_players 	= {'text' 	:tr("Number of human controlled players in each team. A team may have NPC ( computer controlled ) players in their lineup. As more human-controlled players join, those are removed. They usually have the 'NPC' shorthand in their name. "), 'title':tr('Human players')};
                				help.items.a3_league_position	= {'text' 	:tr("Current standings position in the regular season. During the regular season, teams are ranked by victories vs losses and in case of a tie: points scored vs points received. Top {num} usually make it to the playoffs, all though this number may change season by season.",v), 'title':tr('League Position')};
                				//help.items.a3_league_position	= {'text' 	:tr(""), 'title':tr('')};
                			
                			break;
                		}
                		
                		 
                		if( typeof item != 'undefined' )
                			return help.items[item].text;
                		
                		return help;
                	}
                }

            }]);
}());
