(function () {
  
    var scopePointer;
    var id      	= 0;
    var season		= 0;
    var player		= {};
    var cacheSearch	= {};
    var idAccount	= -1;
    var fromVal		= 0;
    var tournaments     = {};
    var day		= 0;
    var players		= [];
    var lastLoaded	= 5;
    
    angular.module('myApp.oneOnOne', ['myApp.AJAX','myApp.me' ])
        .service('oneOnOne', [ 'AJAX','me' ,
            function ( AJAX,me  ) { 
                return {
                	
                	get: function( $scope )
                	{  
                		fromVal = 0;
                		scopePointer = $scope; 
                		var promise = AJAX.get('1ON1_RESULTS', {get:'tournaments,results',id_account:this.getIdAccount(), lastDays: 5, from: this.getFrom()},1 ); 
                		scopePointer.API.setResting(true);
                			 
				var obj = this;
				promise.success(function(data, status, headers, config) { 
					obj.updateView( data );
				});
				promise.update(function(data, status, headers, config) {
					 
					obj.updateView( data );
				});				
				promise.error(function(data, status, headers, config) {
			  		  scopePointer.API.setResting( false );
			  		  scopePointer.API.setError( 'REST', scopePointer );
				}); 
                	},
                	
                	getGame: function( $scope, idGame )
                	{
                		scopePointer = $scope; 
                		var promise = AJAX.get('1ON1_GAMES', {get:'fields,players,stats,log',id_game:idGame  },1 ); 
                		scopePointer.API.setResting(true);
                			 
				var obj = this;
				promise.success(function(data, status, headers, config) { 
					obj.updateGameView( data );
				});
				promise.update(function(data, status, headers, config) {
					 
					obj.updateGameView( data );
				});				
				promise.error(function(data, status, headers, config) {
			  		  scopePointer.API.setResting( false );
			  		  scopePointer.API.setError( 'REST', scopePointer );
				});  
                	},
                	
                	updateGameView: function( data )
                	{
                		var obj = this;
                		 
				scopePointer.cachedCopy = data.cache;
                		if( !data.cache ){
                			scopePointer.API.setResting(false);
                		 	scopePointer.API.checkNotifications( data, scopePointer);
				}
				
				scopePointer.data 	= data.ret;
				scopePointer.data.title = scopePointer.form.title;
				this.parseLog( );
                	},
                	
                	parseLog: function( )
                	{
                		var sides 			   = {};
                		var score			   = {};
                		var hide			   = 'yes';
                		var player			   = {};
                		score['left']			   = 0;
                		
                		score['right']			   = 0;
                		var when			   = 0;
                		var name			   = '';
                		var text			   = '';
                		scopePointer.data.stories          = []; 
                		for( var i in scopePointer.data.log )
                		{
                			hide	= 'no';
                			var item = scopePointer.data.log[i];
                			var next = scopePointer.data.log[parseInt(i)+1];
                			if( item.id_player == scopePointer.data.players.home_player.fields.id )
                			{ 	side = 'left';  otherSide = 'right'; 		
                				player = scopePointer.data.players.home_player;
                			}
                			else
                			{	side = 'right'; otherSide = 'left';		
                				player = scopePointer.data.players.away_player
                			}
                			
                			name	    = player.fields.first_name+' '+player.fields.last_name;
                			when	    = parseInt(item.cand);
                			switch( parseInt(item.id_action) )
                			{
                				case 5: if( typeof next != 'undefined')
                					if( next.id_action == 51 )
                					{
                						score[side]++;
                						text = tr('Inside Shot')+' - '+tr('Made');
                					}
                					else
                						text = tr('Inside Shot')+' - <span class="red">'+tr('Missed')+'</span>';
                				break;
                				
                				case 4: if( typeof next != 'undefined')
                					if( next.id_action == 41 ){
                						score[side]++;
                						text = tr('Semi Distance Shot')+' - <span class="green">'+tr('Made')+'</span>';
                					}
                					else
                						text = tr('Semi Distance Shot')+' - <span class="red">'+tr('Missed')+'</span>';
                				break;
                				
                				case 3: if( typeof next != 'undefined')
                					if( next.id_action == 31 ){
                						score[side]++;
                						score[side]++;
                						text = tr('3PT Shot')+' - '+tr('Made');
                					}
                					else
                						text = tr('3PT Shot')+' - <span class="red">'+tr('Missed')+'</span>';
                				break;
                				
                				case 11:
                						text = tr('Foul');
                				break;
                				
                				case 9:
                						text = tr('Steal');
                				break;
                				
                				case 8:
                						text = tr('Block');
                				break;
                				
                				case 10:
                						text = tr('Rebound');
                				break;
                			
                				default:
                					hide = 'yes';
                				break;
                			}
                			 
                			sides = {};
                			if( hide == 'no' )
                			{ 
                				//console.log(" score = "+JSON.stringify(score) );
						sides[side]    = text;
						sides['score'] = {left:score.left,right:score.right};
						sides['left_player']  = scopePointer.data.players.home_player;
						sides['right_player'] = scopePointer.data.players.away_player;
						//console.log( 'when = '+when+' nam = '+name+ ' act = '+item.id_action);
						scopePointer.data.stories.push(sides); 
					}
                			
                		}
                	},
                	setForm: function( to )
                	{ 
                		var obj = this;
                		scopePointer.API.backButton = function()
                		{
                			obj.saveTactics(scopePointer.form.playerSaved);	
                			scopePointer.form.status = 'list'; 
                			scopePointer.API.deleteBackButton();
                		};
                		scopePointer.form.status = to;
                	},
                	
                	
                	loadMore: function()
                	{
                		var from = this.getFrom()+5;
                		fromVal  = from + 5;
                		var promise = AJAX.get('1ON1_RESULTS', {get:'results',id_account:this.getIdAccount(), lastDays: 5, 'from': from},1 ); 
                		scopePointer.API.setResting(true);
                			 
				var obj = this;
				promise.success(function(data, status, headers, config) { 
						scopePointer.API.setResting( false );
					 
					if( data.status == 'SUCCESS' )
					{
						 
						if( typeof data.ret.results != 'undefined' )
							if( data.ret.results != null )
								for( var i in data.ret.results )
									obj.addResult( data.ret.results[i].fields, i );
					
						obj.updateLoad();
						
					}
					else
					{
						
					}
				});
				 				
				promise.error(function(data, status, headers, config) {
			  		  scopePointer.API.setResting( false );
			  		  scopePointer.API.setError( 'REST', scopePointer );
				}); 
                	},
                	updateLoad: function(){
                		scopePointer.show = [];
                		for( var i in scopePointer.list )
					scopePointer.show.push(   scopePointer.list[i]   );
				window.SC().$apply();
                	},
                	getSignup: function( $scope )
                	{
                		scopePointer = $scope;
                		 
                		var getWhat = {get:{'players':'fields,possible_1on1,1on1_tactics,signedup_today','1on1':'fields'}, id: {'players':'id_account-'+me.get('id_account')} };
                		var promise = AJAX.get('MULTI', getWhat,1  ); 
                		scopePointer.API.setResting(true);
                		var obj = this;
                		
				promise.success(function(data, status, headers, config) { 
					obj.update1on1SignupView( data );
				});
				promise.update(function(data, status, headers, config) {
					 
					obj.update1on1SignupView( data );
				});				
				promise.error(function(data, status, headers, config) {
			  		  scopePointer.API.setResting( false );
			  		  scopePointer.API.setError( 'REST', scopePointer );
				});  
                		
                	},
                	
                	ajaxTournament: function( idTournament, $scope )
                	{
                		 
                		scopePointer = $scope;
                		 
                		var promise = AJAX.get('1ON1', {get:'fields,prizes,latest,table,registrations,sims',fromLatest:0,toLatest:50,season:this.getSeason(), day:this.getDay(), id: idTournament } ); 
                		scopePointer.API.setResting(true);
                			 
				var obj = this;
				promise.success(function(data, status, headers, config) { 
					obj.updateTournamentView( data );
				});
				promise.update(function(data, status, headers, config) {
					 
					obj.updateTournamentView( data );
				});				
				promise.error(function(data, status, headers, config) {
			  		  scopePointer.API.setResting( false );
			  		  scopePointer.API.setError( 'REST', scopePointer );
				});  
                	},
                	
                	setSeason: function( to )
                	{
                		season = to;
                		return season;
                	},
                	
                	getSeason: function()
                	{
                		return season;	
                	},
                	
                	setDay: function( to )
                	{
                		day = to;	
                	},
                	
                	getDay: function()
                	{
                		return day;	
                	},
                	
                	update1on1SignupView: function( data )
                	{
                		var obj = this;
                		 
				scopePointer.cachedCopy = data.cache;
                		if( !data.cache ){
                			scopePointer.API.setResting(false);
                		 	scopePointer.API.checkNotifications( data, scopePointer);
				}
				
				scopePointer.data = data.ret;
				var pl  = {} ;
				players = {};
				for( var i in data.ret.players )
				{
					pl = data.ret.players[i];
					players[pl.fields.id] = pl;
					//this.save1on1Tactics(  pl, pl['1on1_tactics']  );
					this.savePossible1on1( pl, data.ret['1on1'] );
				} 
				
				scopePointer.data.title = tr('Signup');
                	},
                	
                	signUp: function()
                	{
                		var query = {};
                		for( var i in scopePointer.data.players )
                		{
                			//console.log(">>>"+JSON.stringify( scopePointer.data.players )+ " << ");
                			var pl  = players[ scopePointer.data.players[i].fields.id ];
                			if( pl.signedup_today != 1 ){
						var pid = pl.fields.id; 
						var tn	= scopePointer.form.selected[ pid ].value;
						
						var shoot_3pt 		= pl['1on1_tactics']['3pt_shooting'];
						var shoot_inside 	= pl['1on1_tactics'].inside_shooting;
						var shoot_fg 		= pl['1on1_tactics'].floor_shooting;
						var move		= pl['1on1_tactics'].move;
						var defensive		= pl['1on1_tactics'].defensive; 
						// console.log('3pt shooting = '+shoot_3pt);
			 
						query[ pid ] = tn+","+move+","+defensive+","+shoot_3pt+","+shoot_inside+","+shoot_fg;	
						//console.log(""+pid+" = "+query[pid]+" ");
						//console.log("   ");
					}
                		}
                		
                		var promise = AJAX.put('1ON1_SIGNUPS', query,1 ); 
                		scopePointer.API.setResting(true);
                			 
				var obj = this;
				promise.success(function(data, status, headers, config) { 
					scopePointer.API.setResting( false );
					if( data.status == 'SUCCESS' )
					{
						scopePointer.API.setMessage(tr('DONE'));
						scopePointer.go('/1on1/');
					}
					else
					{
						scopePointer.API.setError( tr('Error'), scopePointer );
					}
				}); 			
				promise.error(function(data, status, headers, config) {
			  		  scopePointer.API.setResting( false );
			  		  scopePointer.API.setError( 'REST', scopePointer );
				}); 
                		
                		
                	},
                	
                	saveTactics: function( pid )
                	{
                		var tactics = {};
                		var shots = ['3pt_shooting','inside_shooting','floor_shooting'];
                		for( var is in shots )
                		{
                			var shot = shots[is];
                			tactics[ shot ] = scopePointer.model.shooting[ pid ][ shot ].value;
                		}
                		
                		tactics['move'] = scopePointer.model.types[ pid ][ 'move' ].value;
                		tactics['defensive'] = scopePointer.model.types[ pid ][ 'move' ].value;
                		players[ pid ]['1on1_tactics'] = tactics;
                	},
                	
                	show1on1Tactics: function( pl )
                	{
                		//console.log(" pl="+pl+" tactics-1on1 >>> "+JSON.stringify( tactics1on1 ) );
                		var pid		= pl.fields.id;
                		var tactics1on1 = pl['1on1_tactics'];
                		scopePointer.form.shooting[ pid ]  = {};
                		scopePointer.model.shooting[ pid ] = {}; 
                		var num = {};
                		num[ pid ] = {};
                		var shots = ['3pt_shooting','inside_shooting','floor_shooting'];
                		for( var iS in shots ){
                			var shot = shots[ iS ];
                			
                			num[ pid ][ shot ] = 0;
                			scopePointer.form.shooting[ pid ][ shot ]  = [];
                			scopePointer.model.shooting[ pid ][ shot ] = {};
                			//console.log(">>>>>> ["+pid+"]["+shot+"] ==> 5 ");
					for( var i=5;i<=95;i=i+5 )
					{ 
						scopePointer.form.shooting[ pid ][ shot ].push( {value:i,name:i+'%'} );
						++num[ pid ][ shot ];
						//console.log("pid="+pid+" <<<>>> i="+i+" >>> "+JSON.stringify(tactics1on1 )+" <<< ");
						if( parseInt(i) == parseInt(tactics1on1[shot]) )
						{
							scopePointer.model.shooting[ pid ][ shot ] = scopePointer.form.shooting[ pid ][ shot ][ num[pid][shot]-1 ];
						} 		
					}
				}
				
				var types = {};
                		types['move'] 	   = {"2":tr('Hustle'),"1":tr('Penetration')};
                		types['defensive'] = {"1":tr('Normal'),"2":tr('Tight (Stealing Bonus)'),"3":tr('Loose (Block Bonus)')};
                		scopePointer.model.types[ pid ] = {};
                		scopePointer.form.types[ pid ] = {};
                	 
                		for( var i in types )
                		{
                			//console.log(">>>>>>>>>i="+i+"="+types[i]+"<<< ");
                			scopePointer.form.types[ pid ][ i ] 	 = [];
                			scopePointer.model.types[ pid ][ i ]     = {};
                			for( var j in types[i] )
                			{
                				scopePointer.form.types[ pid ][ i ].push( {value:j,name:types[i][j] } );
                			} 
                			
                			for( var j in scopePointer.form.types[ pid ][ i ] )
                			{
                				console.log(">>>>"+  tactics1on1[i] + " == " + scopePointer.form.types[ pid ][ i ][ j ].value );
                				if( parseInt(tactics1on1[i]) == parseInt(scopePointer.form.types[ pid ][ i ][ j ].value) )
                					scopePointer.model.types[ pid ][ i ] = scopePointer.form.types[ pid ][ i ][ j ];
                			}
                		}
                	},
                	
                	setQuickset: function( pid, value )
                	{ 
                		var shot = scopePointer.model.shootingQuickset.value;
                		
                		var to	 = 90;
                		for( var shotType in scopePointer.form.shooting[pid] )
                		{
                			if( shotType == shot )
                				to = 90;
                			else
                				to = 5;
                			 
					for( var i in scopePointer.form.shooting[pid][shot] )
					{ 
						//console.log("pid="+pid+">>>>>>>>>>>>>"+shot+" == "+shotType+"  to = "+to+"  === "+parseInt(scopePointer.form.shooting[pid][shot][i].value)+" <<<<<<<<<<<<< ");
						if( parseInt(scopePointer.form.shooting[pid][shotType][i].value) == to )
						{ 
							scopePointer.model.shooting[pid][shotType] = scopePointer.form.shooting[pid][shotType][i]
						}
					}
				}
                	},
                	
                	getShootingTypes: function()
                	{
                		return ['3pt_shooting','inside_shooting','floor_shooting'];	
                	},
                	
                	savePossible1on1: function( pl, tournaments )
                	{ 
                		
                		var tournaments;
                		var tName = {};
                		for( var j in tournaments )
                		{
                			tName[ parseInt(tournaments[j].fields.id) ] = tournaments[j].fields.name;
                			//console.log(">> tName["+parseInt(tournaments[j].fields.id)+"] = "+(tournaments[j].fields.name)+" << "  );
                		}
                	 
                		if( typeof pl.fields != 'undefined' ){
					var pid = pl.fields.id;
					scopePointer.form.options[ pid ] = [];
					for( var tn in pl.possible_1on1 )
					{ 
						var tnId = parseInt(pl.possible_1on1[tn]); 
						//console.log("tnId = "+tnId+" s>>"+JSON.stringify( tName ) );
						scopePointer.form.options[ pid ].push( {value:tnId,name: tName[tnId] } ); 
					}
					
					scopePointer.form.selected[ pid ] = scopePointer.form.options[pid][0]; 
                		} 
                	},
                	
                	updateTournamentView: function( data )
                	{
                		var obj = this;
                		 
				scopePointer.cachedCopy = data.cache;
                		if( !data.cache ){
                			scopePointer.API.setResting(false);
                		 	scopePointer.API.checkNotifications( data, scopePointer);
				}
				
				scopePointer.data 	= data.ret[0];
				scopePointer.data.title = scopePointer.data.fields.name;
			 
				this.parseLatest(   data.ret[0]['latest'] );
				this.parseBracket(  data.ret[0]['table'] );
                	},
                	
                	parseBracket: function( braket )
                	{
                		 console.log( JSON.stringify( braket ) );
                	},
                	
                	getTableTitle: function( item )
                	{
                		var runda = parseInt( item[0].runda );
                		var table = 0;
                		//console.log(">>>"+JSON.stringify( item ));
                		if( runda == 1 )
                			table = me.getTableSize( scopePointer.data.table[2].length )*2;
                		else
                			table = me.getTableSize( item.length );
                		
                		return me.tableToString(table);	
                	},
                	
                	getPlayer: function( id )
                	{
                		return players[id].fields;
                	},
                	
                	
                	parseLatest: function( latestArray )
                	{
                		//console.log(" [ latest ] >>> "+JSON.stringify( latestArray )+ " << ");
                		var option = {};
                		var v      = {};
                		scopePointer.form.optionsHistory = [];
                		var set    = 0;
                		for( var i in latestArray )
                		{
                			var latest = latestArray[i];
                			option = {};
                			option.value = latest.season+"/"+latest.day;
                			v['season']  = latest.season;
                			v['textu']   = latest.day;
                			option.name  = tr('Season {season}, day {textu}',v);
                			scopePointer.form.optionsHistory.push( option );
                			//console.log(">add SEASON "+latest.season+"   ADD ... latest.day="+latest.day+" .> day ="+this.getDay()+" < ");
                			if( this.getSeason() == latest.season &&
                			    this.getDay()    == latest.day )
                			{
                				set++;
                				var index = scopePointer.form.optionsHistory.length-1; 
                				scopePointer.form.selectedHistory = scopePointer.form.optionsHistory[index];
                			}
                		}
                		
                		if( set == 0 )
                		{
                			//console.log(">>>>>>>> add normal");
                			//console.log("length >"+scopePointer.form.optionsHistory.length+"< <<");
                			scopePointer.form.optionsHistory.push( {value: this.getSeason()+"/"+this.getDay(), name: tr('Season {season}, day {textu}',{season:this.getSeason(), textu: this.getDay(),season:this.getSeason(),day:this.getDay()})} );
                			var index = scopePointer.form.optionsHistory.length-2;
                			scopePointer.form.selectedHistory = scopePointer.form.optionsHistory[index];
                		}
                	},
                	
                	updateView: function( data )
                	{
                		var obj = this;
                		 
				scopePointer.cachedCopy = data.cache;
                		if( !data.cache ){
                			scopePointer.API.setResting(false);
                		 	scopePointer.API.checkNotifications( data, scopePointer);
				}
				
				//console.log(">>"+JSON.stringify(data.ret));
				if( typeof data.ret != 'undefined' ) 
				{
					scopePointer.list = {};
					for( var i in data.ret.results )
					{
						this.addResult( data.ret.results[i].fields );
					}
					
					scopePointer.show = [];
					
					for( var i in scopePointer.list )
						scopePointer.show.push(   scopePointer.list[i]   );
					
					scopePointer.tournaments = data.ret.tournaments;
					scopePointer.data.title = tr('1on1');
				
					for( var i in scopePointer.tournaments )
					{
						var tn = scopePointer.tournaments[i].fields;
						//console.log("tID==>"+tn.id+" << ");
						tournaments[ tn.id ] = tn;
					}	
				}
                	},
                	
                	addResult: function( item,i )
                	{
                		///console.log('adaugat  >'+item.season+'-'+item.ziua);
                				//console.log(">>>>>>>>>"+JSON.stringify( data.ret.results[i]));
						//var item  = data.ret.results[i].fields;
						var index = item.season+'-'+item.ziua;
						
						//console.log("label: "+item.label);
						if( typeof scopePointer.list[ index ] == 'undefined' )	
							scopePointer.list[ index ] = {};
						
						scopePointer.list[ index ].label   =  tr('Season {season}, Day {ziua}',item);
						scopePointer.list[ index ].val 	   =  parseInt(item.season)*60 + parseInt(item.ziua);
						scopePointer.list[ index ].season  = item.season;
						scopePointer.list[ index ].day	   = item.ziua;
						
						if( typeof scopePointer.list[ index ].results == 'undefined' )	
							scopePointer.list[ index ].results = [];
						
						scopePointer.list[ index ].results.push( item );	
						
                	},
                	
                	getTournament: function( idTournament )
                	{ 
                		 
                		return tournaments[ parseInt(idTournament) ];
                	},
                	
                	getPlacing: function( item )
                	{
                		//console.log(JSON.stringify( item ) );
                		var placing = parseInt(item.placing);
                		if( placing >= 1 && placing <= 3 )
                			return '<img src="pics/medals/medal'+placing+'.png">';
                		
                		if( placing == 4 )
                			return '<font class="black12">'+tr('4th')+'</font>';
                		
                		if( placing == 0 && item.ziua == me.get('day') && item.season == me.get('season') )
                			return '<font class="grey12">'+tr('Pending')+'</font>';
         	
                		if( placing == 0 && ( item.ziua != me.get('day') || item.season != me.get('season') ) )
                			return '<font class="grey12">'+tr('Pending')+'</font>';
         	
                		return '<font class="'+(placing<=8?'black12':'12')+' green">'+placing+'</greyfont>'; 
                	},	
                		 
                	
                	setIdAccount: function( to )
                	{
                		idAccount = to;
                	},
                	
                	getIdAccount: function()
                	{
                		return idAccount;	
                	},
                	
                	getFrom: function()
                	{
                		return fromVal; 
                	},
                	
                	setFrom: function( to )
                	{
                		fromVal = to;	
                	},
                	
                	signedCount: function()
			{
				var signed = 0;
				for( var i in scopePointer.data.players )
				{
					var pl = scopePointer.data.players[i];
					
					if( pl.signedup_today == 1 )
						signed++;
				}
				return signed;
					
			},
			
			getPlayer: function( id_player )
			{
				for( var i in scopePointer.data.players )
					if( id_player == scopePointer.data.players[i].fields.id )
						return  scopePointer.data.players[i];
					
				return '-';
			},
                	 
			getStat: function( item, what )
			{
				
				
				switch( what )
				{ 
					case "points": 
						return ( parseInt( item['score_inside'] )+ parseInt( item['score_fg'] ) + parseInt( item['score_3pt'] )*2 )
					break;
					
					case "shooting_3pt":
						return parseInt( item['score_3pt'] )+" / "+parseInt( item['shooting_3pt'] );
					break;
					
					case "shooting":
						return ( parseInt( item['score_inside'] )+ parseInt( item['score_fg'] )+ parseInt( item['score_3pt'] ) )+' / '+
						       ( parseInt( item['shooting_inside'] )+ parseInt( item['shooting_fg'] )+ parseInt( item['shooting_3pt'] ) );
			
					break;
					
					default:
						if( typeof item[what] == 'undefied' )
							return -3;
						 
						return parseInt(item[what]);
					break;
				}
			},
                	
			getRegistrationSize: function()
			{
				var cnt = 0;
				if( typeof scopePointer.data.registrations != 'undefined' )
					if( scopePointer.data.registrations != null ) 
						for( var i in scopePointer.data.registrations ) 
							cnt++;	  
						
				return cnt;
				
			},
			
                	getHelp: function( page, item )
                        {
                		var help = { items:{} };
                		var v	 = { 'from_tns': 4, 'to_tns': 7,'games_per_career':30, 'season_days':61,'teams_per_league':16,'regular':30,'playoff':'3/3/3','playoff_teams':8,'playoff_start':53,'length': 12, '/a':'', pos:tr('C/PF/SF/SG/PG'),'cyberpoints_link':'','career_link':'', 'goals':3,'per_game':1, 'games':10,'sp_rewardable':30 };
                		 
                		v.season = season;
                		switch( page )
                		{ 
                			
                			case "home":
                				help.items.a1_name	= {'text'	:tr('1-on-1 tournaments are played at the end of each day.'), title:tr('1on1')};
                				help.items.a2_date	= {'text'	:tr("Your results for each player on this particular day"), title: tr('Season')+'/'+tr('Day')};
                		 	break; 
                			
                			case "signup":
                				help.items.a0_signup= {'text'	:tr('1-on-1 tournaments are played at the end of each day.'), title:tr('1on1')};
                				
                				help.items.a1_tournament= {'text'	:tr('Based on player value and/or career stage he is eligible for a limited number of 1-on-1 tournaments.'), 'title': tr('Tournament')};
                				help.items.a2_tactics   = {'text'	:tr('Tactics will be saved for future dates as well.'), 'title': tr('Tactics')};
                				help.items.a3_shooting	= {'text' 	:tr("Percentage of shots you will take from each area. 3 point shot, inside shot and mid range shot."), 'title':tr('Shooting Parameters - 3PT / INSIDE / SEMI:')};
                				
                				help.items.a4_quickset	= {'text' 	:tr("Allows you to easily set predefined numbers on each item."), 'title':tr('"Quickset"')};
                				help.items.a5_offensive	= {'text' 	:tr("Fast players should look to penetrate to the basket while strong, heavy players will be inclined to hustle their way in the paint."), 'title':tr('Offensive Style')};
                				help.items.a6_defensive	= {'text' 	:tr("Gives your player a stealing or a blocking bonus."), 'title':tr('Defensive Bonus')};
                					
                				if( item == 'shooting' )
                					return help.items.a3_shooting.title+': '+help.items.a3_shooting.text + '<BR><BR>'+
                				               help.items.a4_quickset.title+': '+help.items.a4_quickset.text;
                				               
                				if( item == 'defensive' )
                					return help.items.a5_offensive.title+': '+help.items.a5_offensive.text + '<BR><BR>'+
                				               help.items.a6_defensive.title+': '+help.items.a6_defensive.text;
                			break;
                			
                			case "tournament":
                				help.items.a1_sims		= {'text'	:tr('1-on-1 tournaments are played at the end of each day.'), title:tr('1on1')};
                				help.items.a2_registrations	= {'text'	:tr("List of players that will play tonight."), title: tr('Registrations')+'/'+tr('Day')};
                				help.items.a3_playoff		= {'text'	:tr("This tournament follows a playoff system with losers going home."), title: tr('Knockout Bracket')+'/'+tr('Day')};
                		 
                			break;
                			
                			case "game":
                				help.items.a2_stats 	= {text:tr('Stats for players on this team.')+' '+tr("PTS")+': '+tr('Points scored')+' '+tr("AST")+": "+tr('Assists')+' '+tr("BLK")+": "+tr('Blocks')+' '+tr("STL")+": "+tr('Steals')+' '+tr("ORB")+": "+tr('Offensive Rebounds')+' '+tr("DRB")+": "+tr('Defensive Rebounds')+' '+tr("TO")+": "+tr('Turnovers')+' '+tr("REB")+": "+tr('Rebounds')+' '+tr("FLS")+": "+tr('Fouls')+' '+tr("MIN")+": "+tr('Minutes'), title: tr('Player Stats')};
                				help.items.a3_pbp 	= {text:tr('Game narration.'), title: tr('Play by play')};
                	
                			break;
                			
                			 
                			
                			
                		}
                		
                		 
                		if( typeof item != 'undefined' )
                			if( typeof help.items[item] != 'undefined' )
                				return help.items[item].text;
                					 
                		
                		return help; 
                    	},
                	
                	
                	
                	
                	
                }

            }]);
}());
