(function() {

    var scopePointer;
    var id = 0;
    var season = 0;
    var player = {};
    var cacheSearch = {};


    angular.module('myApp.pickupGames', ['myApp.AJAX', 'myApp.me'])
        .service('pickupGames', ['AJAX', 'me',
            function(AJAX, me) {
                return {

                    get: function(teamId, $scope, clubType) {
                        scopePointer = $scope;
                        //console.log("beforeAjaxForIt "+JSON.stringify(scopePointer.team)+" <<<< ");

                        id = teamId;
                        var fields = {};

                        //sql for team data
                        var obj = this;

                        me.get('myTeams', me.get('id_account')).then(function(result) {
                        			
                            scopePointer.teams = result;

                            if (typeof teamId == 'undefined')
                                teamId = result[0];

                            scopePointer.manage.loadTeam('team');
                            obj.ajaxForIt();
                            //console.log("beforeAjaxForIt "+JSON.stringify(scopePointer.team)+" <<<< ");

                            for (var i in result) {
                            	
                                if (result[i].fields.id == teamId)
                                    scopePointer.data = scopePointer.team;
                            }

                            obj.setFilters(clubType);
                        });
                    },

                    setFilter: function(pw) {
                        if (pw == 'password') {
                            var cur = scopePointer.form.noPassword;
                            scopePointer.form.noPassword = (cur == 1 ? 0 : 1);
                        }
                        //console.log(JSON.stringify(scopePointer.form.filterOptions));
                    },

                    anyTeamsAvailable: function() {
                        var added = 0;
                        if (typeof scopePointer.data.pickupGamesList != 0)
                            for (var i in scopePointer.data.pickupGamesList) {
                                var item = scopePointer.data.pickupGamesList[i];
                                if (this.meetsFilter(item))
                                    added++;
                            }

                        return added;

                    },

                    canShow: function(type, showOnly) {
                        if (typeof showOnly == 'undefined')
                            return 1;

                        if (showOnly == null)
                            return 1;

                        if (showOnly == type)
                            return 1;

                        return 0;
                    },

                    setFilters: function(clubType) {
                        scopePointer.form.filterOptions = [];
                        var v = {};
                        //scopePointer.form.filterOptions.push(tr('All'));

                        for (var i = 1; i <= me.getCareers(1).length; i++) {
                            if (i <= me.get('season')) {

                                v.career = me.getCareers()[parseInt(i) - 1].label;

                                if (i == 11)
                                    scopePointer.form.filterOptions.push({
                                        name: tr('{career} clubs', v),
                                        value: me.getCareers()[parseInt(i) - 1].value,
                                        type: 0
                                    });
                                else {

                                    if (this.canShow(0, clubType))
                                        scopePointer.form.filterOptions.push({
                                            name: tr('{career} clubs', v),
                                            value: me.getCareers()[parseInt(i) - 1].value,
                                            type: 0
                                        });
                                    if (this.canShow(5, clubType))
                                        scopePointer.form.filterOptions.push({
                                            name: tr('{career} national teams', v),
                                            value: me.getCareers()[parseInt(i) - 1].value,
                                            type: 5
                                        });
                                    if (this.canShow(10, clubType))
                                        scopePointer.form.filterOptions.push({
                                            name: tr('{career} allstar teams', v),
                                            value: me.getCareers()[parseInt(i) - 1].value,
                                            type: 10
                                        });
                                }


                                if (scopePointer.data.fields.career == me.getCareers()[parseInt(i) - 1].value) {
                                    if (scopePointer.data.fields.club_type == 5)
                                        scopePointer.form.filter = scopePointer.form.filterOptions[scopePointer.form.filterOptions.length - 1];
                                    else
                                        scopePointer.form.filter = scopePointer.form.filterOptions[scopePointer.form.filterOptions.length - 2];
                                }

                                //console.log(" v.career = "+v.career+" << ");
                            }
                        }
                    },

                    meetsFilter: function(item) {
                        //console.log("meetsFilter"+JSON.stringify(item));
                        //console.log('career [ '+item.fields.career+' == '+(scopePointer.filter.value)+' ] type [ '+item.fields.type+' ] == '+ (scopePointer.filter.type) +'  << ');

                        if (item.fields.career == scopePointer.form.filter.value && parseInt(item.fields.type) == parseInt(scopePointer.form.filter.type)) {
                            if (scopePointer.form.noPassword == 1)
                                if (item.fields.hasPassword == 1)
                                    return 0;
                                else
                                    return 1;
                            else
                                return 1;

                        }
                        //else
                        //	console.log("ELSE >> career "+item.fields.career+" == "+scopePointer.filter.value+"  >>"+ parseInt(item.fields.type)+" ==  "+parseInt(scopePointer.filter.type));


                        return 0;
                    },

                    getSelection: function() {
                        return scopePointer.form.sim.fields;
                    },

                    ajaxForIt: function() {
                        console.log("JSON ==>" + JSON.stringify(scopePointer.team));

                        var getWhat = {
                            'get[teams]': 'fields',
                            'id[teams]': 'id_account-' + me.get('id_account'),
                            'get[pickupGames]': 'fields',
                            'career[pickupGames]': scopePointer.team.fields.career
                        };
                        getWhat['get[accounts]'] = "fields";
                        getWhat['id[accounts]'] = "id-" + me.get('id_account');
                        //console.log("ajaxForIt "+JSON.stringify(scopePointer.team)+" <<<< ");


                        var promise = AJAX.get('MULTI', getWhat, 1);
                        scopePointer.API.setResting(true);
                        var obj = this;
                        promise.success(function(data, status, headers, config) {
                            console.log(" SUCCESS ");
                            obj.updateView(data);
                        });

                        if (promise.update)
                            promise.update(function(data, status, headers, config) {

                                obj.updateView(data);
                            });
                        promise.error(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            scopePointer.API.setError('REST', scopePointer);
                        });
                    },

                    addTeam: function() {
                        if (typeof scopePointer.addWith == 'undefined')
                            var idClub = this.getAddSelection();
                        else
                            var idClub = scopePointer.addWith;
                        var promise = AJAX.put('PICKUP_GAMES_LIST', {
                            'return': 'pickupGames=fields',
                            'id_club': idClub,
                            'games': scopePointer.form.games,
                            'password': scopePointer.form.password
                        });

                        scopePointer.API.setResting(true);
                        var obj = this;
                        promise.success(function(data, status, headers, config) {

                            scopePointer.API.setResting(false);
                            if (data.status == 'SUCCESS') {
                                scopePointer.form.status = 'list';
                                scopePointer.data.pickupGamesList = data.ret['return'];
                                scopePointer.API.setMessage(tr('Added'));
                            } else
                                scopePointer.API.setError(data.ret.message);

                        });

                        promise.error(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            scopePointer.API.setError('REST', scopePointer);
                        });
                    },

                    setStatus: function(to) {
                        scopePointer.API.createBackButton(scopePointer.form.status, scopePointer);
                        scopePointer.form.status = to;
                    },

                    updateView: function(data) {
                        //console.log(">>>>>>>> "+JSON.stringify(data) );
                        var obj = this;
                        scopePointer.cachedCopy = data.cache;
                        if (!data.cache)
                            scopePointer.API.setResting(false);

                        scopePointer.teams = data.ret.teams;
                        scopePointer.accounts = data.ret.accounts;
                        scopePointer.data.pickupGamesList = data.ret.pickupGames;
                        scopePointer.data.title = tr('Pickup Games');
                    },

                    setPlaySelection: function( to ) {
                        /*
                		var selIndex = document.getElementById('pg-play').value;
                		var idClub   = scopePointer.teamOptions[ selIndex ].value;
                		scopePointer.playWith = idClub;*/
                		 
                        scopePointer.playWith.value = to.value;
                        return  scopePointer.playWith.value;
                    },

                    setAddSelection: function() {

                        scopePointer.addWith = this.getAddSelection();
                    },

                    getAddSelection: function() {
                        //var selIndex = document.getElementById('add-play').value;

                        //var idClub   = scopePointer.teamOptions[ scopePointer.selectTeam.value ].value;

                        return scopePointer.selectTeam.value;
                    },

                    simulate: function(type) {

                        var idClub = scopePointer.playWith.value;
                      
                        var list = {
                            'id': this.getSelection().id,
                            'myTeam': scopePointer.playWith.value,
                            'password': scopePointer.form.sendPassword
                        };
                        if (type == 'live')
                            list.live = 1;
                        if (type == 'secret')
                            list.secret = 1;

                        var promise = AJAX.put('PICKUPGAMES', list);

                        scopePointer.API.setResting(true);
                        var obj = this;
                        promise.success(function(data, status, headers, config) {

                            scopePointer.API.setResting(false);
                            if (data.status == 'SUCCESS') {
                                scopePointer.form.status = 'list';
                                scopePointer.API.setMessage(data.ret.message);
                                if (type == 'live') {
                                    var idGame = data.ret.id_game;
                                    scopePointer.go('/game/' + idGame);

                                }
                            } else {
                                scopePointer.API.setError(data.ret.message, scopePointer);
                            }

                        });

                        promise.error(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            scopePointer.API.setError('REST', scopePointer);
                        });
                    },


                    getHelp: function(item) {
                        var help = {
                            items: {}
                        };
                        var v = {
                            'from_tns': 4,
                            'to_tns': 7,
                            'games_per_career': 30,
                            'season_days': 61,
                            'teams_per_league': 16,
                            'regular': 30,
                            'playoff': '3/3/3',
                            'playoff_teams': 8,
                            'playoff_start': 53,
                            'length': 12,
                            '/a': '',
                            pos: tr('C/PF/SF/SG/PG'),
                            'cyberpoints_link': '',
                            'career_link': '',
                            'goals': 3,
                            'per_game': 1,
                            'games': 10,
                            'sp_rewardable': 30
                        };

                        v.season = season;
                        help.items.a1_addTeam = {
                            'text': tr("You can either 'add your team' and wait for someone else to play you, or choose one of the teams below to play against."),
                            'title': tr('Add Team')
                        };
                        help.items.a2_pickupgames = {
                            'text': tr("There's a limited number of pickup games you can play each season."),
                            'title': tr('pickup games').ucwords()
                        };
                        help.items.a3_simType = {
                            'text': tr('You can sim with an instant result or watch the game live.') + ' ' + tr("A secret sim will be hidden from public in your calendar or in other places. The result will be instant. It is useful when testing tactics."),
                            'title': (tr('Simulation type'))
                        };

                        if (typeof item != 'undefined')
                            if (typeof help.items[item] != 'undefined')
                                return help.items[item].text;


                        return help;


                    }




                }

            }
        ]);
}());